USE [master]
/****** Object:  Database [WaspConfig]    Script Date: 05/08/2009 07:00:29 ******/
IF  NOT EXISTS (SELECT name FROM dbo.sysdatabases WHERE name = N'WaspConfig')
	CREATE DATABASE [WaspConfig]
GO

USE [WaspConfig]
GO
/****** Object:  UserDefinedDataType [dbo].[wtbool]    Script Date: 05/08/2009 06:58:09 ******/
IF NOT EXISTS (SELECT * FROM systypes WHERE name = N'wtbool')
EXEC dbo.sp_addtype N'wtbool', N'char(1)',N'not null'
GO
/****** Object:  UserDefinedDataType [dbo].[wtpassword]    Script Date: 05/08/2009 06:58:09 ******/
IF NOT EXISTS (SELECT * FROM systypes WHERE name = N'wtpassword')
EXEC dbo.sp_addtype N'wtpassword', N'varchar(20)',N'null'
GO
/****** Object:  UserDefinedDataType [dbo].[record_status_type]    Script Date: 05/08/2009 06:58:09 ******/
IF NOT EXISTS (SELECT * FROM systypes WHERE name = N'record_status_type')
EXEC dbo.sp_addtype N'record_status_type', N'smallint',N'not null'
GO

/****** Object:  Table [dbo].[applications]    Script Date: 05/08/2009 06:58:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[applications]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[applications](
		[app_id] [int] NOT NULL,
		[app_name] [nvarchar](200) NOT NULL,
		[app_type] [char](3) NOT NULL CONSTRAINT [DF_applications_app_type]  DEFAULT ('STD'),
		[app_code] [char](2) NOT NULL,
		[access_code] [nvarchar](50) NOT NULL CONSTRAINT [DF_applications_access_code]  DEFAULT (''),
		[license1] [nvarchar](50) NULL, 
		[license2] [nvarchar](50) NULL, 
		[PerformanceKey1] [nvarchar](50) NULL, 
		[PerformanceKey2] [nvarchar](50) NULL, 
	 CONSTRAINT [PK_applications] PRIMARY KEY CLUSTERED 
	(
		[app_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
ELSE IF ((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[applications]') AND NAME = 'license1') = 0)
BEGIN

	ALTER TABLE [dbo].[applications] ADD [license1] [nvarchar](50) NULL, 
		[license2] [nvarchar](50) NULL, 
		[PerformanceKey1] [nvarchar](50) NULL, 
		[PerformanceKey2] [nvarchar](50) NULL
		
END


GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[application_databases]    Script Date: 05/08/2009 06:58:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[application_databases]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[application_databases](
	[db_id] [int] IDENTITY(1,1) NOT NULL,
	[db_server_name] [varchar](200) NOT NULL,
	[db_database_name] [varchar](50) NOT NULL,
	[db_update_user] [varchar](50) NULL,
	[db_update_password] [wtpassword] NULL,
	[db_read_user] [varchar](50) NULL,
	[db_read_password] [wtpassword] NULL,
	[db_is_demo] [wtbool] NOT NULL CONSTRAINT [DF_application_databases_db_is_demo]  DEFAULT ('F'),
	[app_id] [int] NOT NULL,
	[db_description] [varchar](200) NOT NULL,
	[db_integrated] [wtbool] NOT NULL CONSTRAINT [DF_application_databases_db_integrated]  DEFAULT ('F'),
	[db_version] [varchar](50) NULL,
 CONSTRAINT [PK_application_databases] PRIMARY KEY CLUSTERED 
(
	[db_id] ASC
) ON [PRIMARY]
) ON [PRIMARY]
END

/****** Object:  Index [IX_DatabaseName]    Script Date: 05/11/2009 14:49:04 ******/
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[application_databases]') AND name = N'IX_DatabaseName')
BEGIN
CREATE UNIQUE NONCLUSTERED INDEX [IX_DatabaseName] ON [dbo].[application_databases] 
(
	[db_database_name] ASC
) ON [PRIMARY]
END
GO


----------------------------------------------------------------------------------------
-- Start Stored Procedures
----------------------------------------------------------------------------------------

/****** Object:  StoredProcedure [dbo].[spUpdateDbVersion]    Script Date: 07/06/2009 15:58:45 ******/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[spUpdateDbVersion]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[spUpdateDbVersion]
GO


/****** Object:  StoredProcedure [dbo].[spUpdateDbVersion]    Script Date: 07/06/2009 15:58:45 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[spUpdateDbVersion]
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	declare @dbname varchar(200)
	declare @cmd varchar(300);

	declare dbCursor cursor
	for select db_database_name from WaspConfig..application_databases

	Open dbCursor

	fetch next from dbCursor into @dbname
	while (@@fetch_status <> -1)
	begin

		set @cmd = 'update WaspConfig..application_databases set db_version = (select option_value from ' + @dbname + '..app_options where code = 101) where db_database_name = ''' + @dbname + ''''
		print @cmd
		exec(@cmd)

		fetch next from dbCursor into @dbname

	end

	close  dbCursor
	deallocate dbCursor
END

GO



/****** Object:  StoredProcedure [dbo].[spGetUser]    Script Date: 06/30/2009 16:54:09 ******/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[spGetUser]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[spGetUser]
GO

/****** Object:  StoredProcedure [dbo].[spGetUser]    Script Date: 06/30/2009 16:34:20 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


-- =============================================
-- Author:		CT
-- Create date: 9 JUNE 2009
-- Modification date: June 30, 2009
-- Description:	COMPANY USER CHECK
-- =============================================
CREATE PROCEDURE [dbo].[spGetUser] 
	-- Add the parameters for the stored procedure here
	@pUser varchar(20) = NULL, 
	@pPwd wtpassword = NULL,
	@pAppId int = 1,
	@pDemo wtbool
AS
BEGIN
	
	if (@pUser = 'su')
	begin
		select 
			[db_server_name] ,
			[db_database_name], 
			[db_update_user] ,
			[db_update_password] ,
			[db_read_user] ,
			[db_read_password] ,
			[db_is_demo] ,
			[app_id] ,


			[db_description] ,
			[db_integrated] ,
			[db_version]
		from WaspConfig..application_databases 
		where WaspConfig..application_databases.[app_id] = @pAppId and  db_is_demo = @pDemo
	end
	else
	begin
		-- SET NOCOUNT ON added to prevent extra result sets from
		-- interfering with SELECT statements.
		SET NOCOUNT ON;

		declare @dbname varchar(200)
		declare @cmd varchar(1024);


		declare dbCursor cursor
		for select db_database_name from WaspConfig..application_databases 

		--check if temp table resultset exists
		if exists (select * from [dbo].[sysobjects] where id = object_id(N'#T1') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [#T1]

		--create temp table
		CREATE TABLE [#T1]
		(
			[db_name] varchar(200) ,
			[pwd] varchar(20) DEFAULT ('')


		)


		--cursor to loop through the databases
		Open dbCursor

		fetch next from dbCursor into @dbname
		while (@@fetch_status <> -1)
		begin

			set @cmd = 'INSERT INTO #T1 (db_name,pwd) 
					(select ''' + @dbname + ''', user_password from ' 
					+@dbname + '..users, '+@dbname + '..user_groups, '+@dbname + '..user_group_privileges where '
					+@dbname+'..users.user_logon = ''' + @pUser + ''' and '+@dbname+'..users.record_status = 1 and '
					+@dbname+'..users.group_id = '+@dbname+'..user_groups.group_id and '
					+@dbname+'..user_groups.group_id = '+@dbname+'..user_group_privileges.group_id and '
					+@dbname+'..user_group_privileges.security_code = ''pc'''+')'
					
			print @cmd
			exec(@cmd)

			fetch next from dbCursor into @dbname

		end

		close  dbCursor
		deallocate dbCursor

		--output
		update #T1 set pwd = '' where pwd is null

		select 
			[db_server_name] ,
			[db_database_name], 
			[db_update_user] ,
			[db_update_password] ,
			[db_read_user] ,
			[db_read_password] ,
			[db_is_demo] ,
			[app_id] ,


			[db_description] ,
			[db_integrated] ,
			[db_version]
		from [dbo].[#T1] inner join WaspConfig..application_databases on WaspConfig..application_databases.[db_database_name] = #T1.[db_name]
		where WaspConfig..application_databases.[app_id] = @pAppId and  #T1.[pwd] = @pPwd and db_is_demo = @pDemo


		--drop temp table
		if exists (select * from [dbo].[sysobjects] where id = object_id(N'#T1') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [#T1]
	END
END

GO



/****** Object:  StoredProcedure [dbo].[spGetUser]    Script Date: 06/30/2009 16:54:09 ******/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[spGetUserForWeb]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[spGetUserForWeb]
GO

/****** Object:  StoredProcedure [dbo].[spGetUserForWeb]    Script Date: 06/30/2009 16:34:20 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


-- =============================================
-- Author:		CT
-- Create date: 9 JUNE 2009
-- Modification date: June 24, 2010 BY CY (to include group_id and group_name
-- Description:	COMPANY USER CHECK
-- =============================================
CREATE PROCEDURE [dbo].[spGetUserForWeb] 
	-- Add the parameters for the stored procedure here
	@pUser varchar(20) = NULL, 
	@pPwd wtpassword = NULL,
	@pAppId int = 1,
	@pDemo wtbool
AS
BEGIN
	
	if (@pUser = 'su')
	begin
		select 
			[db_server_name] ,
			[db_database_name], 
			[db_update_user] ,
			[db_update_password] ,
			[db_read_user] ,
			[db_read_password] ,
			[db_is_demo] ,
			[app_id] ,
			1 as [group_id],
			'Admin Group' as [group_name],
			[db_description] ,
			[db_integrated] ,
			[db_version]
		from WaspConfig..application_databases 
		where WaspConfig..application_databases.[app_id] = @pAppId and  db_is_demo = @pDemo
	end
	else
	begin
		-- SET NOCOUNT ON added to prevent extra result sets from
		-- interfering with SELECT statements.
		SET NOCOUNT ON;

		declare @dbname varchar(200)
		declare @cmd varchar(1024);


		declare dbCursor cursor
		for select db_database_name from WaspConfig..application_databases 

		--check if temp table resultset exists
		if exists (select * from [dbo].[sysobjects] where id = object_id(N'#T1') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [#T1]

		--create temp table
		CREATE TABLE [#T1]
		(
			[db_name] varchar(200) ,
			[pwd] varchar(20) DEFAULT (''),
			[group_id] int DEFAULT(0),
			[group_name] varchar(50) DEFAULT('')
		)


		--cursor to loop through the databases
		Open dbCursor

		fetch next from dbCursor into @dbname
		while (@@fetch_status <> -1)
		begin

			set @cmd = 'INSERT INTO #T1 (db_name,pwd,group_id,group_name) 
					(select ''' + @dbname + ''', user_password, '+@dbname+'..user_groups.group_id, '+@dbname+'..user_groups.group_name from ' 
					+@dbname + '..users, '+@dbname + '..user_groups, '+@dbname + '..user_group_privileges where '
					+@dbname+'..users.user_logon = ''' + @pUser + ''' and '+@dbname+'..users.record_status = 1 and '
					+@dbname+'..users.group_id = '+@dbname+'..user_groups.group_id and '
					+@dbname+'..user_groups.group_id = '+@dbname+'..user_group_privileges.group_id and '
					+@dbname+'..user_group_privileges.security_code = ''web'''+')'
					
			print @cmd
			exec(@cmd)

			fetch next from dbCursor into @dbname

		end

		close  dbCursor
		deallocate dbCursor

		--output
		update #T1 set pwd = '' where pwd is null

		select 
			[db_server_name] ,
			[db_database_name], 
			[db_update_user] ,
			[db_update_password] ,
			[db_read_user] ,
			[db_read_password] ,
			[db_is_demo] ,
			[app_id] ,
			[group_id],
			[group_name],
			[db_description] ,
			[db_integrated] ,
			[db_version]
		from [dbo].[#T1] inner join WaspConfig..application_databases on WaspConfig..application_databases.[db_database_name] = #T1.[db_name]
		where WaspConfig..application_databases.[app_id] = @pAppId and  #T1.[pwd] = @pPwd and db_is_demo = @pDemo


		--drop temp table
		if exists (select * from [dbo].[sysobjects] where id = object_id(N'#T1') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [#T1]
	END
END
GO


/****** Object:  StoredProcedure [dbo].[spGetCompanyGroupNames]    Script Date: 05/26/2010 16:07:14 ******/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[spGetCompanyGroupNames]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[spGetCompanyGroupNames]
GO

/****** Object:  StoredProcedure [dbo].[spGetCompanyGroupNames]    Script Date: 05/26/2010 16:07:14 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE  PROCEDURE [dbo].[spGetCompanyGroupNames] 
	-- Add the parameters for the stored procedure here
	@pAppType varchar(20),
	@pAppId int = 1,
	@pDemo wtbool
AS
BEGIN
		-- SET NOCOUNT ON added to prevent extra result sets from
		-- interfering with SELECT statements.
		SET NOCOUNT ON;

		declare @dbname varchar(200)
		declare @cmd varchar(1024);

		declare dbCursor cursor
		for select db_database_name from WaspConfig..application_databases 

		--check if temp table resultset exists
		if exists (select * from [dbo].[sysobjects] where id = object_id(N'#T1') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [#T1]

		--create temp table
		CREATE TABLE [#T1]
		(
			[db_name] varchar(200) ,
			[group_id] int,
			[group_name] varchar(200),
		)

		--cursor to loop through the databases
		Open dbCursor

		fetch next from dbCursor into @dbname
		while (@@fetch_status <> -1)
		begin

			set    @cmd = 'INSERT INTO #T1 (db_name,group_id,group_name) 
					(select '''+ @dbname +''','+ @dbname + '..user_groups.group_id ' + ','+ @dbname + '..user_groups.group_name  from '+
					 @dbname + '..user_group_privileges'+' inner join ' +  @dbname +'..user_groups'+
					' On '+  @dbname+'..user_group_privileges.group_id ='+  @dbname +'..user_groups.group_id'+
					' where '+ @dbname+'..user_groups.record_status = 1 and '
					+ @dbname+'..user_group_privileges.security_code = '''+ @pAppType+ ''')'		

			print @cmd
			exec(@cmd)

			fetch next from dbCursor into @dbname

		end

		close  dbCursor
		deallocate dbCursor

		--output
	

		select 
			[db_server_name] ,
			[db_database_name], 
			[db_update_user] ,
			[db_update_password] ,
			[db_read_user] ,
			[db_read_password] ,
			[db_is_demo] ,
			[app_id] ,
			[group_id],
			[group_name] ,
			[db_description] ,
			[db_integrated] ,
			[db_version]
		from [dbo].[#T1] inner join WaspConfig..application_databases on WaspConfig..application_databases.[db_database_name] = #T1.[db_name]
		where WaspConfig..application_databases.[app_id] = @pAppId and   db_is_demo = @pDemo

		--drop temp table
		if exists (select * from [dbo].[sysobjects] where id = object_id(N'#T1') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
		drop table [#T1]

END

GO


--------------------------------------------------------------------
-- End Stored Procedures
--------------------------------------------------------------------

/****** Object:  ForeignKey [FK_application_databases_applications]    Script Date: 05/08/2009 06:58:06 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_application_databases_applications]') AND type = 'F')
ALTER TABLE [dbo].[application_databases]  WITH CHECK ADD  CONSTRAINT [FK_application_databases_applications] FOREIGN KEY([app_id])
REFERENCES [dbo].[applications] ([app_id])
GO

IF NOT EXISTS (select * from WaspConfig..applications where app_id = 1)
insert into WaspConfig..applications (app_id,app_name,app_type,app_code,access_code) values (1,'MobileAsset','STD','MA','')
GO
IF NOT EXISTS (select * from WaspConfig..applications where app_id = 2)
insert into WaspConfig..applications (app_id,app_name,app_type,app_code,access_code) values (2,'InventoryControl','STD','IC','')
GO