
USE [WaspTrackAsset]


PRINT ''
PRINT ''
PRINT '******************************'
PRINT 'Update tables  -- Create New Tables '
PRINT '******************************'
PRINT ''


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[asset_orders]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... asset_orders'
	CREATE TABLE [dbo].[asset_orders] (
		[asset_order] [int] NULL ,
		[asset_id] [int] NULL ,
		[asset_level] [int] NULL ,
		[root_id] [int] NULL ,
		[parent_id] [int] NULL ,
		[user_id] [int] NULL ,
		[date_updated] [datetime] NULL 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[asset_linking_indicator]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... asset_linking_indicator'
	CREATE TABLE [dbo].[asset_linking_indicator] (
		[linking_indicator] [int] NOT NULL ,
		[linking_description] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		CONSTRAINT [PK_asset_linking_indicator] PRIMARY KEY  CLUSTERED 
		(
			[linking_indicator]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[contracts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... contracts'
	CREATE TABLE [dbo].[contracts] (
		[contract_id] [int] IDENTITY (1, 1) NOT NULL ,
		[contract_number] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[contract_description] [nvarchar] (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[internal_contact] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[vendor_id] [int] NOT NULL ,
		[begin_date] [datetime] NULL ,
		[end_date] [datetime] NULL ,
		[num_licenses] [int] NOT NULL ,
		[is_software] [wtbool] NOT NULL ,
		[no_end_date] [wtbool] NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		[usrdefdate1] [datetime] NULL ,
		[usrdefdate2] [datetime] NULL ,
		[usrdefdate3] [datetime] NULL ,
		[usrdefdate4] [datetime] NULL ,
		[usrdefdate5] [datetime] NULL ,
		[usrdefnumber1] [decimal](18, 0) NULL ,
		[usrdefnumber2] [decimal](18, 0) NULL ,
		[usrdefnumber3] [decimal](18, 0) NULL ,
		[usrdefnumber4] [decimal](18, 0) NULL ,
		[usrdefnumber5] [decimal](18, 0) NULL ,
		[usrdeftext1] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext2] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext3] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext4] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext5] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext6] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext7] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext8] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext9] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		[usrdeftext10] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL ,
		CONSTRAINT [PK_contracts] PRIMARY KEY  CLUSTERED 
		(
			[contract_id]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[asset_contract]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... asset_contract'
	CREATE TABLE [dbo].[asset_contract] (
		[asset_id] [int] NOT NULL ,
		[contract_id] [int] NOT NULL ,
		[record_added] [datetime] NOT NULL ,
		[record_removed] [datetime] NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		CONSTRAINT [PK_asset_contract] PRIMARY KEY  CLUSTERED 
		(
			[asset_id],
			[contract_id],
			[record_added]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[maintenance_types]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... maintenance_types'
	CREATE TABLE [dbo].[maintenance_types] (
		[maintenance_id] [int] IDENTITY (1, 1) NOT NULL ,
		[maint_shortname_desc] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[date_updated] [datetime] NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL ,
		CONSTRAINT [PK_maintenance_types] PRIMARY KEY  CLUSTERED 
		(
			[maintenance_id]
		)  ON [PRIMARY] 
	) ON [PRIMARY]
END


if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ui_settings]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... ui_settings'
	CREATE TABLE [dbo].[ui_settings] (
		[user_id] [int] NOT NULL ,
		[setting_name] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[setting_type] [varchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[setting_value] [image] NULL ,
		CONSTRAINT [PK_ui_settings] PRIMARY KEY  CLUSTERED 
		(
			[user_id],
			[setting_name],
			[setting_type]
		)  ON [PRIMARY] 
	) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
END

if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[user_site]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... user_site'
	CREATE TABLE [dbo].[user_site](
		[id] [int] IDENTITY(1000,1) NOT NULL,
		[user_id] [int] NOT NULL,
		[site_id] [int] NOT NULL,
 		CONSTRAINT [PK_ID] PRIMARY KEY CLUSTERED 
	(
		[id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
	
if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[user_site]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	ALTER TABLE [dbo].[user_site]  WITH CHECK ADD  CONSTRAINT [FK_user_site_sites] FOREIGN KEY([site_id])
	REFERENCES [dbo].[sites] ([site_id])
END
GO

if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[user_site]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	ALTER TABLE [dbo].[user_site] CHECK CONSTRAINT [FK_user_site_sites]
END
GO

if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[user_site]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	ALTER TABLE [dbo].[user_site]  WITH CHECK ADD  CONSTRAINT [FK_user_site_users] FOREIGN KEY([user_id])
	REFERENCES [dbo].[users] ([user_id])
END
GO

if NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[user_site]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	ALTER TABLE [dbo].[user_site] CHECK CONSTRAINT [FK_user_site_users]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[user_groups]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... user_groups'
	CREATE TABLE [dbo].[user_groups](
		[group_id] [int] IDENTITY(1,1) NOT NULL,
		[group_name] [nvarchar](50) NOT NULL,
		[group_description] [nvarchar](500) NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL,
	 CONSTRAINT [PK_user_group] PRIMARY KEY CLUSTERED 
	(
		[group_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]


	--add a default record here, so check constraint on UPG_Tables_users.sql can work
	SET IDENTITY_INSERT [user_groups] ON;

	INSERT INTO [dbo].[user_groups] (group_id, [group_name], [group_description] ,[record_status] ,[company_id])
    		VALUES (1, 'Admin Group', 'Administrative Group With All Rights', 4, 1)

	SET IDENTITY_INSERT [user_groups] OFF;
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[user_group_privileges]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... user_group_privileges'
	CREATE TABLE [dbo].[user_group_privileges] (
		[group_id] [int] NOT NULL ,
		[security_code] [varchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
		[record_status] [record_status_type] NOT NULL ,
		[company_id] [int] NOT NULL,
		CONSTRAINT [PK_group_privileges] PRIMARY KEY  CLUSTERED 
		(
			[group_id],
			[security_code]
		)  ON [PRIMARY] ,
		CONSTRAINT [FK_group_privileges_group] FOREIGN KEY 
		(
			[group_id]
		) REFERENCES [dbo].[user_groups] (
			[group_id]
		),
		CONSTRAINT [FK_group_privileges_security_privileges] FOREIGN KEY 
		(
			[security_code]
		) REFERENCES [dbo].[security_privileges] (
			[security_code]
		)
	) ON [PRIMARY]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[user_group_sites]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... user_group_sites'
	CREATE TABLE [dbo].[user_group_sites](
		[id] [int] IDENTITY(1000,1) NOT NULL,
		[group_id] [int] NOT NULL,
		[site_id] [int] NOT NULL,
	 CONSTRAINT [PK_GSID] PRIMARY KEY CLUSTERED 
	(
		[id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]

	ALTER TABLE [dbo].[user_group_sites]  WITH CHECK ADD  CONSTRAINT [FK_user_group_sites_groups] FOREIGN KEY([group_id])
	REFERENCES [dbo].[user_groups] ([group_id])

	ALTER TABLE [dbo].[user_group_sites] CHECK CONSTRAINT [FK_user_group_sites_groups]

	ALTER TABLE [dbo].[user_group_sites]  WITH CHECK ADD  CONSTRAINT [FK_user_group_sites_sites] FOREIGN KEY([site_id])
	REFERENCES [dbo].[sites] ([site_id])

	ALTER TABLE [dbo].[user_group_sites] CHECK CONSTRAINT [FK_user_group_sites_sites]

END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... filter'
	CREATE TABLE [dbo].[filter](
		[filter_id] [int] IDENTITY(1,1) NOT NULL,
		[calling_form_id] [int] NOT NULL,
		[filter_name] [nvarchar](255) NOT NULL,
		[filter_desc] [nvarchar](1000) NULL,
		[is_default] [wtbool] NOT NULL,
		[is_global] [wtbool] NOT NULL,
		[user_id] [int] NOT NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL,
		[date_updated] [datetime] NULL
	) ON [PRIMARY]

END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[mobile_data_unprocessed_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... mobile_data_unprocessed_history'
	CREATE TABLE [dbo].[mobile_data_unprocessed_history](
		[id] [int] NOT NULL,
		[device_type] [varchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
		[device_name] [varchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
		[data_type] [varchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
		[mobile_data] [varchar](1000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
		[data_error] [varchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
		[transaction_time] [datetime] NULL,
		[upload_time] [datetime] NOT NULL,
		[company_id] [int] NOT NULL,
		[record_status] [record_status_type] NOT NULL CONSTRAINT [DF_mobile_data_unprocessed_history_record_status]  DEFAULT ((1)),
	 CONSTRAINT [PK_mobile_data_unprocessed_history] PRIMARY KEY CLUSTERED 
	(
		[id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[asset_transactions_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [asset_transactions_history]'
	CREATE TABLE [dbo].[asset_transactions_history](
		[transaction_id] [int] NOT NULL,
		[trans_type] [int] NOT NULL,
		[asset_id] [int] NOT NULL,
		[location_id] [int] NOT NULL,
		[other_location_id] [int] NULL,
		[user_id] [int] NOT NULL,
		[department_id] [int] NOT NULL CONSTRAINT [DF_asset_transactions_history_department_id]  DEFAULT ((0)),
		[reason_id] [int] NULL,
		[action_type] [int] NULL,
		[entry_date] [datetime] NULL,
		[trans_date] [datetime] NULL,
		[date_acquired] [datetime] NULL,
		[maint_date] [datetime] NULL,
		[maint_complete] [wtbool] NULL,
		[condition_id] [int] NULL CONSTRAINT [DF_asset_transactions_history_condition_id]  DEFAULT ((0)),
		[cost] [decimal](18, 0) NULL,
		[customer_id] [int] NULL,
		[employee_id] [int] NULL,
		[supplier_id] [int] NULL,
		[serial_number] [varchar](25) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
		[record_status] [record_status_type] NOT NULL,
		[record_source] [varchar](100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
		[company_id] [int] NOT NULL,
	 CONSTRAINT [PK_asset_transactions_history] PRIMARY KEY CLUSTERED 
	(
		[transaction_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
GO

/****** Object:  Table [dbo].[filter_details]    Script Date: 08/09/2009 17:09:34 ******/
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter_details]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [filter_details]'
	CREATE TABLE [dbo].[filter_details](
		[rec_id] [int] IDENTITY(1,1) NOT NULL,
		[filter_id] [int] NOT NULL,
		[form_id] [int] NOT NULL,
		[user_id] [int] NOT NULL,
		[company_id] [int] NOT NULL,
		[selected_form_id] [int] NULL,
		[field_id] [int] NULL,
		[device_name] [varchar](255) NULL,
		[field_value] [varchar](255) NULL,
		[filter] [varchar](6800) NULL,
		[whole_word_flag] [wtbool] NULL,
		[advanced_flag] [wtbool] NOT NULL CONSTRAINT [DF_filter_details_advanced_flag]  DEFAULT ('F'),
		[find_all_flag] [wtbool] NULL,
	 CONSTRAINT [PK_filter_details] PRIMARY KEY CLUSTERED 
	(
		[rec_id] ASC
	) ON [PRIMARY]
	) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter_grid_settings]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [filter_grid_settings]'
	CREATE TABLE [dbo].[filter_grid_settings](
		[filter_id] [int] NULL,
		[form_id] [int] NULL,
		[col_name] [nvarchar](50) NOT NULL,
		[col_order] [int] NOT NULL,
		[sort_order] [nvarchar](50) NULL,
		[width] [decimal](18, 0) NOT NULL,
		[visible] [wtbool] NOT NULL,
		[group_level] [int] NULL,
		[user_id] [int] NOT NULL,
		[company_id] [int] NOT NULL,
		[record_status] [record_status_type] NOT NULL
	) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[filter_form_settings]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [filter_form_settings]'
	CREATE TABLE [dbo].[filter_form_settings](
		[filter_id] [int] NULL,
		[form_id] [int] NULL,
		[xpos] [int] NOT NULL CONSTRAINT [DF_filter_form_settings_top_pos]  DEFAULT ((0)),
		[ypos] [int] NOT NULL CONSTRAINT [DF_filter_form_settings_left_pos]  DEFAULT ((0)),
		[width] [decimal](18, 0) NOT NULL,
		[heigth] [decimal](18, 0) NOT NULL,
		[user_id] [int] NOT NULL,
		[company_id] [int] NOT NULL,
		[record_status] [record_status_type] NOT NULL
	) ON [PRIMARY]
END
GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[schedule_asset_availability]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [schedule_asset_availability]'
	CREATE TABLE [dbo].[schedule_asset_availability](
		[rec_id] [int] IDENTITY(1,1) NOT NULL,
		[asset_id] [int] NOT NULL,
		[start_date] [datetime] NOT NULL,
		[end_date] [datetime] NOT NULL,
		[na_reason_id] [int] NOT NULL,
		[user_id] [int] NOT NULL,
		[detail_id] [int] NOT NULL,
		[employee_id] [int] NOT NULL,
		[customer_id] [int] NOT NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL
) ON [PRIMARY]
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[custom_values]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [custom_values]'
	CREATE TABLE [dbo].[custom_values](
	[form_id] [int] NOT NULL,
	[custom_field] [varchar](30) NOT NULL,
	[value] [varchar](100) NOT NULL,
	[default] [wtbool] NULL,
	[order] [int] NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NOT NULL,
 CONSTRAINT [PK_custom_values] PRIMARY KEY CLUSTERED 
(
	[form_id] ASC,
	[custom_field] ASC,
	[value] ASC
)WITH FILLFACTOR = 90 ON [PRIMARY]
) ON [PRIMARY]
END
GO



IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[reservation]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [reservation]'

	/****** Object:  Table [dbo].[reservation]    Script Date: 07/11/2010 07:15:48 ******/
	CREATE TABLE [dbo].[reservation](
	[reservation_id] [int] IDENTITY(1,1) NOT NULL,
	[reservation_number] [nvarchar](50) NOT NULL,
	[reference_number] [nvarchar](100) NULL,
	[customer_id] [int] NOT NULL CONSTRAINT [DF_reservation_customer_id]  DEFAULT ((0)),
	[employee_id] [int] NOT NULL CONSTRAINT [DF_reservation_employee_id]  DEFAULT ((0)),
	[urgency_id] [int] NOT NULL,
	[approver_id] [int] NOT NULL,
	[request_status_id] [int] NOT NULL,
	[user_id] [int] NOT NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NOT NULL,
	[notify_reservedby] [wtbool] NULL,
	[notify_reservedfor] [wtbool] NULL,
	[last_updated] [datetime] NULL,
 CONSTRAINT [PK_reservation] PRIMARY KEY CLUSTERED 
(
	[reservation_id] ASC
)WITH FILLFACTOR = 90 ON [PRIMARY]
) ON [PRIMARY]

END
GO



IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[request_urgency]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [request_urgency]'

CREATE TABLE [dbo].[request_urgency](
	[urgency_id] [int] NOT NULL,
	[urgency_text] [nvarchar](50) NOT NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NOT NULL,
 CONSTRAINT [PK_request_urgency] PRIMARY KEY CLUSTERED 
(
	[urgency_id] ASC
)WITH FILLFACTOR = 90 ON [PRIMARY]
) ON [PRIMARY]
END

GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[request_status]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [request_status]'

	CREATE TABLE [dbo].[request_status](
	[request_status_id] [int] NOT NULL,
	[request_status_text] [nvarchar](50) NOT NULL,
	[record_status] [record_status_type] NOT NULL,
	[company_id] [int] NOT NULL,
 CONSTRAINT [PK_request_status] PRIMARY KEY CLUSTERED 
(
	[request_status_id] ASC
)WITH FILLFACTOR = 90 ON [PRIMARY]
) ON [PRIMARY]

END

GO



IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[reservation_details]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [reservation_details]'

	CREATE TABLE [dbo].[reservation_details](
		[detail_id] [int] IDENTITY(1,1) NOT NULL,
		[reservation_id] [int] NOT NULL,
		[asset_id] [int] NOT NULL,
		[asset_type_id] [int] NOT NULL,
		[quantity] [decimal](18, 0) NOT NULL,
		[reservation_start] [datetime] NOT NULL,
		[reservation_end] [datetime] NOT NULL,
		[relating_detail_id] [int] NOT NULL,
		[line_status_id] [int] NOT NULL,
		[user_id] [int] NOT NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL,
		[last_updated] [datetime] NOT NULL
	) ON [PRIMARY]

	ALTER TABLE [dbo].[reservation_details] ADD  CONSTRAINT [DF_reservation_detail_quantity]  DEFAULT (1) FOR [quantity]
	ALTER TABLE [dbo].[reservation_details] ADD  CONSTRAINT [DF_reservation_detail_line_status_id]  DEFAULT (1) FOR [line_status_id]

END

GO



IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[not_avail_reason]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [not_avail_reason]'

	CREATE TABLE [dbo].[not_avail_reason](
		[na_reason_id] [int] NOT NULL,
		[na_reason_text] [nvarchar](50) NOT NULL,
		[record_status] [record_status_type] NOT NULL,
		[company_id] [int] NOT NULL
	) ON [PRIMARY]

END

GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[reservation_approval_history]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	PRINT '... [reservation_approval_history]'

	CREATE TABLE [dbo].[reservation_approval_history](
	[transaction_id] [int] IDENTITY(1,1) NOT NULL,
	[reservation_id] [int] NOT NULL,
	[by_user_id] [int] NOT NULL,
	[comment] [nvarchar](1000) NOT NULL CONSTRAINT [DF_reservation_approval_history_comment]  DEFAULT (''),
	[action_type] [nchar](1) NOT NULL CONSTRAINT [DF_reservation_approval_history_action_type]  DEFAULT ('A'),
	[next_approver_id] [int] NOT NULL,
	[action_date] [datetime] NOT NULL,
	[company_id] [int] NOT NULL
) ON [PRIMARY]

	--uncompatable with sql 2000
	--EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'A for approval, R for rejection' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'reservation_approval_history', @level2type=N'COLUMN',@level2name=N'action_type'

END

GO




















