
USE [WaspTrackAsset]

PRINT ''
PRINT ''
PRINT '******************************'
PRINT 'Update tables  -- [asset] '
PRINT '******************************'
PRINT ''

--SELECT * FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]')

if (((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]') AND NAME = 'parent_id') = 0) OR
	((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]') AND NAME = 'transact_as_whole') = 0) OR
    ((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]') AND NAME = 'linking_indicator') = 0) )
BEGIN

	ALTER TABLE [dbo].[asset] ADD [parent_id] [int] NOT NULL DEFAULT (0),
		[transact_as_whole] [wtbool] NOT NULL DEFAULT 'T',
		[linking_indicator] [int] NOT NULL DEFAULT (0),
		[linking_is_child_checked_out] [wtbool] NOT NULL DEFAULT 'F' 
		
END

if (SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]')
 AND NAME = 'usrdefnumber1' and xprec != 19) > 0
BEGIN
	ALTER TABLE [dbo].[asset] ALTER COLUMN usrdefnumber1 [decimal](19, 4) NULL
END

if (SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]')
 AND NAME = 'usrdefnumber2' and xprec != 19) > 0
BEGIN
	ALTER TABLE [dbo].[asset] ALTER COLUMN usrdefnumber2 [decimal](19, 4) NULL
END

if (SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]')
 AND NAME = 'usrdefnumber3' and xprec != 19) > 0
BEGIN
	ALTER TABLE [dbo].[asset] ALTER COLUMN usrdefnumber3 [decimal](19, 4) NULL
END

if (SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]')
 AND NAME = 'usrdefnumber4' and xprec != 19) > 0
BEGIN
	ALTER TABLE [dbo].[asset] ALTER COLUMN usrdefnumber4 [decimal](19, 4) NULL
END

if (SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]')
 AND NAME = 'usrdefnumber5' and xprec != 19) > 0
BEGIN
	ALTER TABLE [dbo].[asset] ALTER COLUMN usrdefnumber5 [decimal](19, 4) NULL
END

-- Adding the fields that dupe the asset type data
if NOT EXISTS (select * from dbo.syscolumns where name = 'asset_description' and id = object_id(N'[dbo].[asset]'))
	ALTER TABLE [dbo].[asset] ADD [asset_description] [description_type] NULL 
GO

if NOT EXISTS (select * from dbo.syscolumns where name = 'manufacturer_id' and id = object_id(N'[dbo].[asset]'))
	ALTER TABLE [dbo].[asset] ADD [manufacturer_id] [int] NOT NULL DEFAULT (0)
GO

if NOT EXISTS (select * from dbo.syscolumns where name = 'model' and id = object_id(N'[dbo].[asset]'))
ALTER TABLE [dbo].[asset] ADD [model] [varchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO

if NOT EXISTS (select * from dbo.syscolumns where name = 'supplier_id' and id = object_id(N'[dbo].[asset]'))
ALTER TABLE [dbo].[asset] ADD [supplier_id] [int] NOT NULL DEFAULT (0)
GO

if NOT EXISTS (select * from dbo.syscolumns where name = 'checkout_duration' and id = object_id(N'[dbo].[asset]'))
ALTER TABLE [dbo].[asset] ADD [checkout_duration] [int] NULL
GO

if NOT EXISTS (select * from dbo.syscolumns where name = 'lead_time' and id = object_id(N'[dbo].[asset]'))
ALTER TABLE [dbo].[asset] ADD [lead_time] [int] NULL
GO

-- Add fields
if ((SELECT COUNT(*) FROM dbo.syscolumns WHERE id = OBJECT_ID(N'[dbo].[asset]') AND NAME = 'linked_reference') = 0)
BEGIN
	ALTER TABLE [dbo].[asset] ADD [linked_reference] [nvarchar](1000) COLLATE SQL_LATIN1_General_CP1_CI_AS NULL  
END

if (select top 1 asset.asset_description from asset) is null
begin
	-- Now update all the assets with the asset_type (item) data
	update asset set 
		asset.asset_description = (select item.description from item where asset.item_id = item.item_id),
		asset.manufacturer_id = (select item.manufacturer_id from item where asset.item_id = item.item_id),	
		asset.model = (select item.model from item where asset.item_id = item.item_id),
		asset.supplier_id = (select item.supplier_id from item where asset.item_id = item.item_id),		
		asset.checkout_duration = (select item.checkout_duration from item where asset.item_id = item.item_id),
		asset.lead_time = (select item.lead_time from item where asset.item_id = item.item_id)
		
	update asset set asset.asset_description = '' where asset.asset_description is null
end
GO
