USE WaspTrackAsset;
GO

PRINT ''
PRINT ''
PRINT '******************************'
PRINT 'Insert default initial records '
PRINT '******************************'
PRINT ''

 
----------------------------------------------------
-- Table Name: address
----------------------------------------------------
if NOT EXISTS (select * from address WHERE address_id=1 AND table_name='company_info' and address_type_id=1)
BEGIN
	INSERT INTO address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) VALUES (1,'company_info',1,'Company Corporate','','',null,null,'','','','',null,1);
END

if NOT EXISTS (select * from address WHERE address_id=1 AND table_name='company_info' and address_type_id=2)
BEGIN
	INSERT INTO address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) VALUES (1,'company_info',2,'Company Shipping','','',null,null,'','','','',null,1);
END

if NOT EXISTS (select * from address WHERE address_id=1 AND table_name='company_info' and address_type_id=3)
BEGIN
	INSERT INTO address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) VALUES (1,'company_info',3,'Company Receiving','','',null,null,'','','','',null,1);
END

if NOT EXISTS (select * from address WHERE address_id=1 AND table_name='company_info' and address_type_id=4)
BEGIN
	INSERT INTO address (address_id,table_name,address_type_id,record_type,address1,address2,address3,address4,city,state,postal_code,country,mail_stop,record_status) VALUES (1,'company_info',4,'Company Billing','','',null,null,'','','','',null,1);
END
GO

if NOT EXISTS (select * from phone WHERE phone_id=1 AND table_name='Company_info' and phone_type_id=1)
	INSERT INTO phone (phone_id,table_name,phone_type_id,record_type,phone_number,extension,record_status) VALUES (1,'Company_info',1,'Company Phone','','',1);
	
if NOT EXISTS (select * from phone WHERE phone_id=1 AND table_name='Company_info' and phone_type_id=2)
	INSERT INTO phone (phone_id,table_name,phone_type_id,record_type,phone_number,extension,record_status) VALUES (1,'Company_info',2,'Company Fax','','',1);
GO

----------------------------------------------------
-- Table Name: app_options
----------------------------------------------------

if NOT EXISTS (SELECT * FROM app_options WHERE code = '3')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'3','bool','Show Warning Messages','Show all warning messages.','Show all warning messages.','T','F','','Support',1,1);
END

if EXISTS (SELECT * FROM app_options WHERE code = '4' and option_value = '01/01/2003')
BEGIN
	DELETE FROM app_options WHERE code = '4'
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'4','date','Archive Transactions','Archive transactions prior to the date below :','Arhive transaction prior to this date','F','T','01/01/2005','Database',2,1);
END
ELSE IF NOT EXISTS (SELECT * FROM app_options WHERE code = '4')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'4','date','Archive Transactions','Archive transactions prior to the date below :','Arhive transaction prior to this date','F','T','01/01/2005','Database',2,1);
END

if EXISTS (SELECT * FROM app_options WHERE code = '5')
BEGIN
	UPDATE app_options SET description = 'Automatically open the Create New screen when you enter an asset/site/location etc. that does not exist.  e.g. if you are creating a new asset and enter a location that is not in the database, the New Location screen will pop up automatically.', tool_tip = 'Automatically open the Create New screen when you enter an asset/site/location etc. that does not exist.  e.g. if you are creating a new asset and enter a location that is not in the database, the New Location screen will pop up automatically.' WHERE code = '5'
END
ELSE IF NOT EXISTS (SELECT * FROM app_options WHERE code = '5')
BEGIN
	insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'5','bool','Automatic New','Automatically open the Create New screen when you enter an asset/site/location etc. that does not exist.  e.g. if you are creating a new asset and enter a location that is not in the database, the New Location screen will pop up automatically.','Automatically open the Create New screen when you enter an asset/site/location etc. that does not exist.  e.g. if you are creating a new asset and enter a location that is not in the database, the New Location screen will pop up automatically.','F','F','','Asset',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '6')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'6','text','Decimal Places','All numbers that can display decimal places will use this number to determine how many decimal places to display. Valid VALUES 0..4','All numbers that can display decimal places will use this number to determine how many decimal places to display.','F','T','2','Asset',1,1);
END
ELSE IF EXISTS (SELECT * FROM app_options WHERE code = '6')
BEGIN
	UPDATE app_options SET record_status = 1 WHERE code = '6';
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '7')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'7','bool','Allow Negative Quantities','Allow quantities to go negative. This option turns Quantity validation on or off for Picking and Move operations.','Allow quantities to go negative. This option turns Quantity validation on or off on Picking and Move operations.','T','T','','Asset',2,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '8')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'8','bool','Edit Field Names','Allows administrators to control field name editing.','Allows administrators to control field name editing.','F','T','','Asset',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '10')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'10','bool','Close New Form','Automatically close the New form each time a new record is created or duplicated.','Automatically close the New form each time a new record is created or duplicated.','F','T','','Support',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '11')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'11','bool','Previously processed XML records','Turn this option on to show previously processed transactions in downloaded mobile files','Turn this option on to show previously processed transactions in downloaded mobile files','F','T','','Support',2,0);
END
GO
if NOT EXISTS (SELECT * FROM app_options WHERE code = '13')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'13','text','Max Row Count','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','F','F','0','Support',1,1);
END	
else if NOT EXISTS (SELECT * FROM app_options WHERE code = '13' and record_status = 1 and company_id = 1)
BEGIN
	DELETE FROM app_options WHERE code = '13'
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'13','text','Max Row Count','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','This is the maximum number of rows that will be displayed on most grids. Set this number to 0 to see all rows. The maximum can not be less than 100.','F','F','0','Support',1,1);
END	

if NOT EXISTS (SELECT * FROM app_options WHERE code = '14')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'14','bool','Print Pick Tickets with Bar Codes','Print Pick Tickets with Bar Codes','Print the Pick Tickets with Bar Codes','T','T','','Asset',2,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '15')
BEGIN
INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'15','date','Last Depreciation Date','This is the last date used to calculate asset depreciation.','This is the last date used to calculate asset depreciation.','F','T','','Asset',1,1);
END
ELSE
BEGIN
UPDATE app_options SET description='This is the last date used to calculate asset depreciation.',tool_tip='This is the last date used to calculate asset depreciation.' WHERE code = '15'
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '16')
BEGIN
INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'16','bool','Automatic Asset Tags','Automatically assign asset tags when creating a new or duplicating an existing asset.','Automatically assign asset tags when creating a new or duplicating an existing asset.','F','F','','Asset',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '17')
BEGIN
INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'17','bool','Automatic Process Mobile Data','Automatically process data uploaded from mobile devices.','Automatically process data uploaded from mobile devices.','T','T','','Support',1,1);
END

if EXISTS (SELECT * FROM app_options WHERE code = '18')
BEGIN
	UPDATE app_options SET description = 'Allow duplicate Serial Numbers within the same Asset Type', tool_tip = 'Allow duplicate Serial Numbers within the same Asset Type' WHERE code = '18'
END
else
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'18','bool','Allow Duplicate Serial Numbers','Allow duplicate Serial Numbers within the same Asset Type','Allow duplicate Serial Numbers within the same Asset Type','F','T','','Asset',1,1);
END

GO
if NOT EXISTS (SELECT * FROM app_options WHERE code = '20')
BEGIN
   INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'20','bool','Check For Software Updates','Turn this option on to automatically check for software update upon application startup. Must have internet connection for this to work.','Turn this option on to automatically check for software update upon application startup. Must have internet connection for this to work.','T','T','','Support',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '22')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'22','text','Archive Processed Mobile Data','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid VALUES 90..360. Recommended 180.','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid VALUES 90..360. Recommended 180.','F','F','180','Support',1,1);
END
ELSE IF EXISTS (SELECT * FROM app_options WHERE code = '22' and option_value = '180')
BEGIN
	DELETE FROM app_options WHERE code = '22'
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'22','text','Archive Processed Mobile Data','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid VALUES 90..360. Recommended 180.','Archive processed mobile data older than the number of the days listed below. Set this number to 0 if you do not wish to archive any processed mobile data. Valid VALUES 90..360. Recommended 180.','F','F','180','Support',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '23')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'23','bool','Edit Inherited Asset Type Data','Turn this option off to prevent the data on the asset window that is inherited from the asset type from being edited.','Turn this option off to prevent the data on the asset window that is inherited from the asset type from being edited.','F','T','','Asset',1,1);
END

DELETE FROM app_options WHERE code = '100'
INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'100','text','Version','Application Version','','F','F','6.2.2','',2,0);

DELETE FROM app_options WHERE code = '101'
INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'101','text','Database Version','Database Version','','F','F','6.2.1','',2,0);

if NOT EXISTS (SELECT * FROM app_options WHERE code = '301')
BEGIN
	insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'301','text','SMTP Server','An outgoing mail server that supports SMTP for delivering notification email. Set this to the same thing as the ''outgoing mail server'' in your own email program. If you don''t want to send notification email at all, leave this blank.','SMTP outgoing mail server','T','T','','Email',1,1);
END
GO
if NOT EXISTS (SELECT * FROM app_options WHERE code = '302')
BEGIN
	insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'302','text','SMTP Port','SMTP mail server listening port. Default SMTP server listening port is 25.','SMTP mail server listening port','T','T','','Email',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '303')
BEGIN
insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'303','text','SMTP User','If your SMTP server requires authentication to send outgoing email, enter the account name to use. Otherwise, leave this blank.','SMTP authentication user name','T','T','','Email',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '304')
BEGIN
insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'304','password','SMTP Password','If your SMTP server requires authentication to send outgoing email, enter the account password to use. Otherwise, leave this blank.','SMTP authentication password','T','T','','Email',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '305')
BEGIN
insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'305','bool','SMTP SSL/TSL','If your SMTP server requires a secure connection (SSL or TSL), check the box to turn this option on.','If your SMTP server requires a secure connection (SSL or TSL), check the box to turn this option on.','T','T','','Email',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '330')
BEGIN
insert into app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) values (null,'330','bool','Always Show Email Destination List','Turn this option off if you don''t want to show email destination list when you send email from the application.','Turn this option off if you don''t want to show email destination list form when you send email from the application.','T','T','','Email',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '400')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'400','text','SQL Server Backup Location','This is an existing directory on the PC/Server WHERE the SQL database is installed in which user has permission to store the database backups. By default the Microsoft SQL Server backup directory is being used.','Database backup directory on the Machine WHERE the database is installed','F','T','','Support',1,1);
END
GO
if NOT EXISTS (SELECT * FROM app_options WHERE code = '401')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'401','text','Last Backup Name','Name of the last backup','Name of the last backup','F','F','','Support',2,0);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '405')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'405','bool','Check For Newer Label Versions','When printing labels, like for asset tags, if a newer label has been installed and this option is on, the new label will be used.','When printing labels, like for asset tags, if a newer label has been installed and this option is on, the new label will be used.','T','F','','Support',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '410')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'410','bool','Due Date On Next Week Day','If the calculated due date falls on a weekend, the next week day will be selected.','If the calculated due date falls on a weekend, the next week day will be selected.','F','T','','Asset',1,1);
END

if NOT EXISTS (SELECT * FROM app_options WHERE code = '411')
BEGIN
	INSERT INTO app_options (user_id,code,type,name,description,tool_tip,flag,admin,option_value,option_section,record_status,company_id) VALUES (null,'411','bool','Checkout Duration Uses Week Days','When calculating the due date, only week days are counted as checked out days.','When calculating the due date, only week days are counted as checked out days.','F','T','','Asset',1,1);
END

Delete FROM app_options WHERE code = '412'

GO




----------------------------------------------------
-- Table Name: asset_linking_indicator
----------------------------------------------------

DELETE FROM asset_linking_indicator

INSERT INTO asset_linking_indicator (linking_indicator,linking_description) VALUES (0,'  Not Linked');
INSERT INTO asset_linking_indicator (linking_indicator,linking_description) VALUES (1,'  Has Parent');
INSERT INTO asset_linking_indicator (linking_indicator,linking_description) VALUES (2,'  Has Child');
INSERT INTO asset_linking_indicator (linking_indicator,linking_description) VALUES (3,'  Linked Both Ways');
GO

----------------------------------------------------
-- Table Name: category
----------------------------------------------------

if ( SELECT COUNT(category_id) FROM [category] WHERE category_id = 0 ) = 0
BEGIN
	SET IDENTITY_INSERT [category] ON;
	INSERT INTO category (category_id,description,record_status,company_id) VALUES (0,' ',0,0);
	SET IDENTITY_INSERT [category] OFF;
END
GO

-- company_info
if ( SELECT COUNT(company_id) FROM company_info WHERE company_id = 1 ) = 0
BEGIN
	INSERT INTO company_info (company_id,company,email,website,record_status) VALUES (1,'','','',1);
END
GO



-- condition
if ( SELECT COUNT(condition_id) FROM condition ) = 0
BEGIN
	SET IDENTITY_INSERT [condition] ON;
	INSERT INTO condition (condition_id,description,record_status) VALUES (0,' ',2);
	INSERT INTO condition (condition_id,description,record_status) VALUES (1000,'Excellent',1);
	INSERT INTO condition (condition_id,description,record_status) VALUES (1001,'Good',1);
	INSERT INTO condition (condition_id,description,record_status) VALUES (1002,'Bad',1);
	INSERT INTO condition (condition_id,description,record_status) VALUES (1003,'Fine',1);
	SET IDENTITY_INSERT [condition] OFF;
END
GO



----------------------------------------------------
-- Table Name: contracts
----------------------------------------------------
if ( SELECT COUNT(contract_id) FROM contracts WHERE contract_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [contracts] ON;
   INSERT INTO contracts (contract_id,contract_number,contract_description,internal_contact,vendor_id,begin_date,end_date,num_licenses,is_software,no_end_date,record_status,company_id,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10) VALUES (0,' ',null,null,0,null,null,0,'F','F',1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null);
   SET IDENTITY_INSERT [contracts] OFF;
END
GO



-- [customer]
if ( SELECT COUNT(customer_id) FROM [customer] WHERE customer_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [customer] ON;
   INSERT INTO customer (customer_id,customer_number,name,company_name,email,department,allow_shorting,date_added,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10,record_status,company_id,update_user_id,list_id,date_updated) VALUES (0,'',null,null,null,null,'T',null,null,null,null,null,null,0,0,0,0,0,null,null,null,null,null,null,null,null,null,null,2,0,null,null,'3/11/2004 3:51:37 PM');
   SET IDENTITY_INSERT [customer] OFF;
END
GO



-- [departments]
if ( SELECT COUNT(department_id) FROM [departments] WHERE department_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [departments] ON;
   INSERT INTO departments (department_id,code,name,record_status,company_id) VALUES (0,' ',' ',2,0);
   SET IDENTITY_INSERT [departments] OFF;
END
GO


----------------------------------------------------
-- Table Name: depreciation_methods
----------------------------------------------------

if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 0) = 0
   INSERT INTO depreciation_methods (type_id,description) VALUES (0,'None');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 1) = 0
   INSERT INTO depreciation_methods (type_id,description) VALUES (1,'Straight-Line');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 2) = 0
   INSERT INTO depreciation_methods (type_id,description) VALUES (2,'Double Declining Balance');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 3) = 0
   INSERT INTO depreciation_methods (type_id,description) VALUES (3,'150% Declining Balance');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 4) = 0
   INSERT INTO depreciation_methods (type_id,description) VALUES (4,'Declining Balance Custom');
if (SELECT COUNT(type_id) FROM depreciation_methods WHERE type_id = 5) = 0
   INSERT INTO depreciation_methods (type_id,description) VALUES (5,'Sum-of-the-years''-digits');
GO



-- [asset_class]
if ( SELECT COUNT(class_id) FROM [asset_class] WHERE class_id = 0 ) = 0
BEGIN
	SET IDENTITY_INSERT [asset_class] ON;
	INSERT INTO asset_class (class_id,class_name,depreciation_method,asset_life_years,asset_life_months,record_status,company_id) VALUES (0,' ',0,0,0,2,0);
	SET IDENTITY_INSERT [asset_class] OFF;
END
GO


-----employees
if ( SELECT COUNT(employee_id) FROM [employees] WHERE employee_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [employees] ON;

   insert into [employees] (employee_id,employee_number,last_name,first_name,title,department_id,manager_id,email,date_added,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10,company_id,record_status,date_updated) values (0,'','','',null,0,0,'','1/1/2010',null,null,null,null,null,0.0000,0.0000,0.0000,0.0000,0.0000,null,null,null,null,null,null,null,null,null,null,1,1,'1/1/2010');

   SET IDENTITY_INSERT [employees] OFF;
END
GO



----------------------------------------------------
-- Table Name: filter_grid_settings     'Factory Default' Grid settings for Web
----------------------------------------------------
--- Delete all the 'factory default' settings
DELETE FROM filter_grid_settings WHERE filter_id = -2
GO

--- Customer Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'customer_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'customer_number',1,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'name',2,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'company_name',3,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'email',4,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'department',5,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'date_added',6,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'address1',7,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'address2',8,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'city',9,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'state',10,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'postal_code',11,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'country',12,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'mail_stop',13,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'phone_number',14,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'extension',15,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefdate1',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefdate2',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefdate3',18,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefdate4',19,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefdate5',20,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefnumber1',21,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefnumber2',22,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefnumber3',23,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefnumber4',24,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdefnumber5',25,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext1',26,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext2',27,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext3',28,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext4',29,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext5',30,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext6',31,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext7',32,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext8',33,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext9',34,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,4,'usrdeftext10',35,'Unsorted',85,'T',-1,0,1,1);
GO

--- Manufacturer Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'manufacturer_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'name',1,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'email',2,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'website',3,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'contact_name',4,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'address1',5,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'address2',6,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'city',7,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'state',8,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'postal_code',9,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'country',10,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'mail_stop',11,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'phone_number',12,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefdate1',13,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefdate2',14,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefdate3',15,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefdate4',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefdate5',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefnumber1',18,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefnumber2',19,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefnumber3',20,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefnumber4',21,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdefnumber5',22,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext1',23,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext2',24,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext3',25,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext4',26,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext5',27,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext6',28,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext7',29,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext8',30,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext9',31,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,5,'usrdeftext10',32,'Unsorted',85,'T',-1,0,1,1);
GO

--- Asset Type Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'item_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'item_number',1,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'description',2,'Unsorted',125,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'checkout_duration',3,'Unsorted',115,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'manufacturer',4,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'model',5,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'supplier_number',6,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'class_name',7,'Unsorted',105,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'category',8,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'linked_reference',9,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'lead_time',10,'Unsorted',115,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'length',11,'Unsorted',45,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'width',12,'Unsorted',45,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'height',13,'Unsorted',45,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'weight',14,'Unsorted',45,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefdate1',15,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefdate2',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefdate3',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefdate4',18,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefdate5',19,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefnumber1',20,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefnumber2',21,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefnumber3',22,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefnumber4',23,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdefnumber5',24,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext1',25,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext2',26,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext3',27,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext4',28,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext5',29,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext6',30,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext7',31,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext8',32,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext9',33,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,6,'usrdeftext10',34,'Unsorted',85,'T',-1,0,1,1);
GO

--- Location Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'location_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'site',1,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'code',2,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'description',3,'Unsorted',120,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefdate1',4,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefdate2',5,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefdate3',6,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefdate4',7,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefdate5',8,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefnumber1',9,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefnumber2',10,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefnumber3',11,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefnumber4',12,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdefnumber5',13,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext1',14,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext2',15,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext3',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext4',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext5',18,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext6',19,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext7',20,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext8',21,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext9',22,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,7,'usrdeftext10',23,'Unsorted',85,'T',-1,0,1,1);
GO
--- Site Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'site_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'site_name',1,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'description',2,'Unsorted',120,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefdate1',3,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefdate2',4,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefdate3',5,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefdate4',6,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefdate5',7,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefnumber1',8,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefnumber2',9,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefnumber3',10,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefnumber4',11,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdefnumber5',12,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext1',13,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext2',14,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext3',15,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext4',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext5',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext6',18,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext7',19,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext8',20,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext9',21,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,8,'usrdeftext10',22,'Unsorted',85,'T',-1,0,1,1);
GO
--- Supplier (Vendor) Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'supplier_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'supplier_number',1,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'name',2,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'email',3,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'website',4,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'contact_name',5,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'address1',6,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'address2',7,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'city',8,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'state',9,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'postal_code',10,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'country',11,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'mail_stop',12,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'phone_number',13,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'fax_number',14,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefdate1',15,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefdate2',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefdate3',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefdate4',18,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefdate5',19,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefnumber1',20,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefnumber2',21,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefnumber3',22,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefnumber4',23,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdefnumber5',24,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext1',25,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext2',26,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext3',27,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext4',28,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext5',29,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext6',30,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext7',31,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext8',32,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext9',33,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,9,'usrdeftext10',34,'Unsorted',85,'T',-1,0,1,1);
GO
--- (Depreciation) Class Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,26,'class_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,26,'class_name',1,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,26,'depreciation_method',2,'Unsorted',120,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,26,'depreciation_custom_percent',3,'Unsorted',115,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,26,'asset_life_years',4,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,26,'asset_life_months',5,'Unsorted',105,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,26,'deprec_to_salvage',6,'Unsorted',195,'T',-1,0,1,1);
GO
--- Asset Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'asset_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'linking_indicator',1,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'asset_tag',2,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'asset_description',3,'Unsorted',110,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'item_number',4,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'description',5,'Unsorted',135,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'transact_as_whole',6,'Unsorted',110,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'site_name',7,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'location',8,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'code',9,'Unsorted',105,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'is_checked_out',10,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'serial_number',11,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'condition',12,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'linked_reference',13,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'manufacturer',14,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'model',15,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'checkout_duration',16,'Unsorted',115,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'lead_time',17,'Unsorted',115,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'class_name',18,'Unsorted',110,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'cadescription',19,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'supplier_number',20,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'purchase_date',21,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'purchase_cost',22,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'salvage_value',23,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'depreciation_begin_date',24,'Unsorted',140,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'last_depreciation_date',25,'Unsorted',135,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'total_depreciation',26,'Unsorted',110,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'current_depreciation',27,'Unsorted',120,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'depreciated_value',28,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'should_depreciate',29,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'po',30,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'warranty_begin_date',31,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'warranty_end_date',32,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'warranty_provider',33,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'last_audit_date',34,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'date_acquired',35,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'customer_number',36,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'customer_name',37,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'employee_number',38,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'employee_name',39,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefdate1',40,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefdate2',41,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefdate3',42,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefdate4',43,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefdate5',44,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefnumber1',45,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefnumber2',46,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefnumber3',47,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefnumber4',48,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdefnumber5',49,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext1',50,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext2',51,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext3',52,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext4',53,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext5',54,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext6',55,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext7',56,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext8',57,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext9',58,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,27,'usrdeftext10',59,'Unsorted',85,'T',-1,0,1,1);
GO
--- Department Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,28,'department_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,28,'code',1,'Unsorted',150,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,28,'name',2,'Unsorted',250,'T',-1,0,1,1);
GO
--- Employee Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'employee_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'employee_number',1,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'last_name',2,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'first_name',3,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'code',4,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'manager_number',5,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'phone_number',6,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'extension',7,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'email',8,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'address1',9,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'address2',10,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'mail_stop',11,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'city',12,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'state',13,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'postal_code',14,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'country',15,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefdate1',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefdate2',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefdate3',18,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefdate4',19,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefdate5',20,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefnumber1',21,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefnumber2',22,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefnumber3',23,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefnumber4',24,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdefnumber5',25,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext1',26,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext2',27,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext3',28,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext4',29,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext5',30,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext6',31,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext7',32,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext8',33,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext9',34,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,30,'usrdeftext10',35,'Unsorted',85,'T',-1,0,1,1);
GO
--- Contract Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'contract_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'contract_number',1,'Unsorted',105,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'contract_description',2,'Unsorted',110,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'internal_contact',3,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'begin_date',4,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'end_date',5,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'num_licenses',6,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'no_end_date',7,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'asset_count',8,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'is_software',9,'Unsorted',60,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'cost',10,'Unsorted',55,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'linked_reference',11,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'vendor_number',12,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'vendor_name',13,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefdate1',14,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefdate2',15,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefdate3',16,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefdate4',17,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefdate5',18,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefnumber1',19,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefnumber2',20,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefnumber3',21,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefnumber4',22,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdefnumber5',23,'Unsorted',100,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext1',24,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext2',25,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext3',26,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext4',27,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext5',28,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext6',29,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext7',30,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext8',31,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext9',32,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,32,'usrdeftext10',33,'Unsorted',85,'T',-1,0,1,1);
GO
--- (Asset) Transaction Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'transaction_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'trans_date',1,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'trans_description',2,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'asset_tag',3,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'code',4,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'location_code',5,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'other_location_code',6,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'reason',7,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'entry_date',8,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'date_acquired',9,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'maint_date',10,'Unsorted',85,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'maint_complete',11,'Unsorted',95,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'condition',12,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'customer_number',13,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'customer_name',14,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'employee_number',15,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'employee_name',16,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'cost',17,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'serial_number',18,'Unsorted',65,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'user_logon',19,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,38,'record_source',20,'Unsorted',90,'T',-1,0,1,1);
GO

--- Asset Reservation Grid Settings
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'reservation_id',0,'Unsorted',50,'F',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'reservation_number',1,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'reference_number',2,'Unsorted',75,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'customer_number',3,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'customer_name',4,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'employee_number',5,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'employee_name',6,'Unsorted',90,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'urgency_text',7,'Unsorted',45,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'earliest_due',8,'Unsorted',70,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'request_status_text',9,'Unsorted',105,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'approver',10,'Unsorted',80,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'notify_change',11,'Unsorted',135,'T',-1,0,1,1);
INSERT INTO filter_grid_settings ( filter_id, form_id, col_name, col_order, sort_order, width, visible, group_level, user_id, company_id, record_status )  VALUES (-2,39,'created_by',12,'Unsorted',80,'T',-1,0,1,1);

GO

----------------------------------------------------
-- Table Name: form
----------------------------------------------------
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1,'Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 2) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (2,'CompanyInfo','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 3) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (3,'ImportExport','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 4) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (4,'Customer','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 5) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (5,'Manufacturer','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 6) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (6,'Item','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 7) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (7,'Location','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 8) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (8,'Site','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 9) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (9,'Supplier','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10,'Category','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 11) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (11,'Inventory','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 12) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (12,'History','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 13) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (13,'Inventory_Transactions','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 14) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (14,'Filter','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 15) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (15,'Add','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 16) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (16,'Remove','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 17) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (17,'Move','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 18) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (18,'CheckIn','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 19) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (19,'CheckOut','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 20) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (20,'Audit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 21) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (21,'Adjust','F',1,1);
GO
if (SELECT COUNT(form_id) FROM form WHERE form_id = 22) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (22,'PurchaseOrder','T',2,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 23) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (23,'Invoice','T',2,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 24) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (24,'InvoiceLineItem','T',2,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 25) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (25,'POLineItem','T',2,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 26) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (26,'Class','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 27) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (27,'Asset','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 28) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (28,'Department','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 29) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (29,'users','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 30) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (30,'Employee','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 32) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (32,'Contracts','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 38) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (38,'AssetTransactions','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 39) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (39,'Reservations','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 40) = 0
	insert into form (form_id,form_name,list_flag,record_status,company_id) values (40,'ReservationDetails','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 100) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (100,'Ma_Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 101) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (101,'Ma_CompanyInfo','T',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 200) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (200,'Qb_Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1000) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1000,'PDA - Add','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1001) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1001,'PDA - Remove','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1002) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1002,'PDA - Move','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1003) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1003,'PDA - Audit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1004) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1004,'PDA - Adjust','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1005) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1005,'PDA - Detail','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1006) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1006,'PDA - Review Add','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 1007) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (1007,'PDA - Review Remove','F',1,1);
GO
if (SELECT COUNT(form_id) FROM form WHERE form_id = 2000) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (2000,'PDA - Login','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 2001) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (2001,'PDA - Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 2002) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (2002,'PDA - New Asset','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 2003) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (2003,'PDA - New Item','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 2004) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (2004,'PDA - Browse','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10000) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10000,'PDT - Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10001) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10001,'PDT - Add','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10002) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10002,'PDT - Remove','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10003) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10003,'PDT - Move','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10004) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10004,'PDT - Adjust','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10005) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10005,'PDT - Details','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10006) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10006,'PDT - Audit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10008) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10008,'PDT - Site Configuration','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10010) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10010,'PDT - SN Looping','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10011) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10011,'PDT - Trackby Looping','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10012) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10012,'PDT - Item Looping','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10100) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10100,'WDT - Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10101) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10101,'WDT - Add','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10102) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10102,'WDT - Remove','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10103) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10103,'WDT - Move','F',1,1);
GO
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10104) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10104,'WDT - Adjust','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10105) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10105,'WDT - Details','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10106) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10106,'WDT - Audit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10108) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10108,'WDT - Site Configuration','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10110) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10110,'WDT - SN Looping','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10111) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10111,'WDT - Trackby Looping','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10112) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (10112,'WDT - Item Looping','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10200) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10200,'PPC - Main','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10201) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10201,'PPC - New','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10202) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10202,'PPC - Edit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10203) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10203,'PPC - Audit','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10204) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10204,'PPC - CheckIn','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10205) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10205,'PPC - CheckOut','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10206) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10206,'PPC - Dispose','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10207) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10207,'PPC - Move','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 10208) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) values (10208,'PPC - Maint','F',1,1);
if (SELECT COUNT(form_id) FROM form WHERE form_id = 90000) = 0
	INSERT INTO form (form_id,form_name,list_flag,record_status,company_id) VALUES (90000,'Crystal Report','F',1,1);
GO


----------------------------------------------------
-- Table Name: form_field_meta
----------------------------------------------------

DELETE FROM form_field_meta WHERE form_id = 6 and field = 'checkout_duration'
DELETE FROM form_field_meta WHERE form_id = 6 and field = 'description'

DELETE FROM form_field_meta WHERE form_id = 26
DELETE FROM form_field_meta WHERE form_id = 27 AND field not like 'usrdef%'

-- v4.0.2 already has users (form 29) entries, so delete and reinsert
DELETE FROM form_field_meta WHERE form_id = 29
DELETE FROM form_field_meta WHERE form_id = 32 AND field not like 'usrdef%'
DELETE FROM form_field_meta WHERE form_id = 38
DELETE FROM form_field_meta WHERE form_id = 39
DELETE FROM form_field_meta WHERE form_id = 40
DELETE FROM form_field_meta WHERE form_id = 100
DELETE FROM form_field_meta WHERE form_id >= 2000 and form_id <= 2200
DELETE FROM form_field_meta WHERE form_id = 90000
DELETE FROM form_field_meta WHERE form_id in (10200, 10203, 10204, 10205, 10206, 10207, 10208)	-- don't delete existing data for 10201, 10202
GO

--form 1
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Add',null,null,'Add','Click to add items into inventory.','T','T','T',30,'Add','Click to add items into inventory.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Audit',null,null,'Audit','Click to audit assets.','T','T','F',30,'Audit','Click to audit assets.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Check-In',null,null,'Check-In','Click to check items back into inventory.','T','T','T',30,'Check-In','Click to check items back into inventory.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Check-Out',null,null,'Check-Out','Click to check items out of inventory.','T','T','T',30,'Check-Out','Click to check items out of inventory.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Transfer',null,null,'Transfer Check-Out','Click to transfer or modify a checked-out asset.','T','T','T',30,'Transfer Check-Out','Click to transfer or modify a checked-out asset.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','CompanyInfo',null,null,'Company Info','Click to edit the company info.','T','T','T',30,'Company Info','Click to edit the company info.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Counts',null,null,'Audit','Click to imput audit counts.','T','T','F',30,'Audit','Click to imput audit counts.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Dispose',null,null,'Dispose','Click to dispose assets.','T','T','T',30,'Dispose','Click to dispose assets.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','History',null,null,'History','Click to view the history of an item.','T','T','F',30,'History','Click to view the history of an item.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','ImportExport',null,null,'Import / Export','Click to import or export data from the database.','T','T','F',30,'Import / Export','Click to import or export data from the database.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Lists',null,null,'List Forms','Click to view lists of the data in your system.','T','T','F',30,'List Forms','Click to view lists of the data in your system.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Title','Maint',null,null,'Maintenance Entry',null,'T','T','F',30,'Maintenance Entry',null,'T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','ManageAudit',null,null,'Manage Audit','Click to move assets from one location to another.','T','T','F',30,'Manage Audit','Click to move assets from one location to another.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Move',null,null,'&Move','Click to move items from one location to another.','T','T','F',30,'&Move','Click to move items from one location to another.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Save',null,null,'&Save','Click to save maintenance entry','T','T','F',30,'&Save','Click to save maintenance entry','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1,'Button','Security',null,null,'Security','Click to manage the security of users.','T','T','F',30,'Security','Click to manage the security of users.','T','T',30,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN
	-- transfer
	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 1 and control = 'Button' and field = 'Transfer') = 0
		insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (1,'Button','Transfer',null,null,'Transfer Check-Out','Click to transfer asset or modify a check-out asset.','T','T','T',30,'Transfer Check-Out','Click to transfer asset or modify a check-out asset.','T','T',30,null,null,null,1,1,'T','1','1');
END
GO

-- form 2
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 2) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 2';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Address1',null,'address1','Address &1:','Enter your company address, line 1.','T','F','T',100,'Address &1:','Enter your company address, line 1.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Address2',null,'address2','Address &2:','Enter your company address, line 2.','T','F','T',100,'Address &2:','Enter your company address, line 2.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','City',null,'City','Cit&y:','Enter the city where your company is located.','T','F','T',50,'Cit&y:','Enter the city where your company is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Company',null,'Company','Company &Name:','Enter the name of your company.','T','F','T',50,'Company &Name:','Enter the name of your company.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Country',null,'Country','Co&untry:','Enter the country where your company is located.','T','F','T',50,'Co&untry:','Enter the country where your company is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Email',null,'Email','&Email:','Enter your company email address.','T','F','T',250,'&Email:','Enter your company email address.','T','F',250,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Fax',null,'Fax','&Fax:','Enter your company fax number.','T','F','T',20,'&Fax:','Enter your company fax number.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Form Name','FormName',null,null,null,'**','T','F','F',30,null,'**','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Phone',null,'phone_number','&Phone:','Enter your company phone number.','T','F','T',20,'&Phone:','Enter your company phone number.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','State',null,'State','&State:','Enter the state where your company is located.','T','F','T',50,'&State:','Enter the state where your company is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','Website',null,'Website','&Website:','Enter your company website.','T','F','T',255,'&Website:','Enter your company website.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2,'Label','ZipCode',null,'postal_code','&Postal Code:','Enter your company postal code.','T','F','T',10,'&Postal Code:','Enter your company postal code.','T','F',10,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN

UPDATE form_field_meta SET tool_tip = 'Enter your company address, line 1.', default_tool_tip = 'Enter your company address, line 1.' WHERE form_id = 2 and field = 'Address1'
UPDATE form_field_meta SET tool_tip = 'Enter your company address, line 2.', default_tool_tip = 'Enter your company address, line 2.' WHERE form_id = 2 and field = 'Address2'

END
GO

-- form 3
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 3) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 3';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','delimiter',null,null,'Field delimiter:','Select the delimiter between fields in your file.','T','F','T',255,'Field delimiter:','Select the delimiter between fields in your file.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','export_file',null,null,'To file:','Name the file you are exporting to.','T','F','T',255,'To file:','Name the file you are exporting to.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','export_heading',null,null,'Include field names on first row.','Is the first row of data the column header?','T','F','T',null,'Include field names on first row.','Is the first row of data the column header?','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','export_preview',null,null,'Preview of data from table: ','This window is a preview of the data.','T','F','T',255,'Preview of data from table: ','This window is a preview of the data.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','export_preview2',null,null,'Data Preview of Table: ','This window is a preview of the data.','T','F','T',255,'Data Preview of Table: ','This window is a preview of the data.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Radio','export_radio',null,null,'Export to text file','Name the file to which you are exporting.','T','F','T',null,'Export to text file','Name the file to which you are exporting.','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','fields_available',null,null,'Fields available:','This is a list of the fields available for export in the selected table.','T','F','T',255,'Fields available:','This is a list of the fields available for export in the selected table.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','fields_selected',null,null,'Fields selected:','This is a list of the fields you have selected.','T','F','T',255,'Fields selected:','This is a list of the fields you have selected.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','from_table',null,null,'Export table:','Select the table you want to export.','T','F','T',255,'Export table:','Select the table you want to export.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','import_field',null,null,'Import Field:','This is the import field','T','F','T',255,'Import Field:','This is the import field','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','import_file',null,null,'Import file:','This is the import file you selected.','T','F','T',255,'Import file:','This is the import file you selected.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','import_heading',null,null,'First row contains column headings','Does the first row have column headings or does the first row contain data?','T','F','T',255,'First row contains column headings','Does the first row have column headings or does the first row contain data?','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','import_map_from',null,null,'Map from:','This is the column header you have selected','T','F','T',null,'Map from:','This is the column header you have selected','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','import_map_to',null,null,'To:','Pick the field in the database to which you want to map the Map from: column to.','T','F','T',null,'To:','Pick the field in the database to which you want to map the Map from: column to.','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','import_pick_address_type',null,null,'Pick an "Address Type":','Importing addresses requires an Address Type. Pick the type of address this field represents.','T','F','F',null,'Pick an "Address Type":','Importing addresses requires an Address Type. Pick the type of address this field represents.','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','import_preview',null,null,'Preview of data from: ','This window lets you preview the data in the selected file.','T','F','T',255,'Preview of data from: ','This window lets you preview the data in the selected file.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Radio','import_radio',null,null,'Import into database','Import the data into the database.','T','F','T',null,'Import into database','Import the data into the database.','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (3,'Label','to_table',null,null,'To table:','This is the table into which you are importing data.','T','F','T',255,'To table:','This is the table into which you are importing data.','T','F',255,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 4
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 4) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 4';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','address1',null,'address1','Address &1:','Enter the Customer''s Address Line 1.','T','F','T',100,'Address &1:','Enter the Customer''s Address Line 1.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','address2',null,'address2','Address &2:','Enter the Customer''s Address Line 2.','T','F','T',100,'Address &2:','Enter the Customer''s Address Line 2.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','allow_shorting',null,'allow_shorting','Allow Shorting?','This option indicates whether this customer wants to receive partial shipments or not','T','F','T',8,'Allow Shorting?','This option indicates whether this customer wants to receive partial shipments or not','T','F',8,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','Cell Phone',null,'phone_number','Ce&ll No:','Enter this Customer''s cell phone number.','T','F','T',20,'Ce&ll No:','Enter this Customer''s cell phone number.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','city',null,'city','C&ity:','Enter the city where this Customer is located.','T','F','T',50,'C&ity:','Enter the city where this Customer is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','company_name',null,'company_name','Compan&y Name:','Enter this Customer''s Company Name.','T','F','T',50,'Compan&y Name:','Enter this Customer''s Company Name.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','country',null,'country','Count&ry:','Enter the country where this Customer is headquartered.','T','F','T',50,'Count&ry:','Enter the country where this Customer is headquartered.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'List Form Name','Customer',null,null,'Customer','**','T','F','F',0,'Customer','**','T','F',0,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','customer_id',null,'customer_id','customer_id','Enter a Customer ID you will use throughout the system to identify this Customer.','T','F','T',4,'customer_id','Enter a Customer ID you will use throughout the system to identify this Customer.','T','F',4,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','customer_number',null,'customer_number','C&ustomer No.:','Enter a Customer Number you will use throughout the system to identify this Customer.','T','T','T',30,'C&ustomer No.:','Enter a Customer Number you will use throughout the system to identify this Customer.','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','date_added',null,'date_added','Date &Added:','The Date the Customer was added to the system.','T','F','T',8,'Date &Added:','The Date the Customer was added to the system.','T','F',8,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','department',null,'department','&Department:','Enter the Department in which the contact at this company works.','T','F','T',20,'&Department:','Enter the Department in which the contact at this company works.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','email',null,'email','&Email:','Enter the Email address of the contact at this company.','T','F','T',250,'&Email:','Enter the Email address of the contact at this company.','T','F',250,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','extension',null,'extension','E&xtension:','Enter the Phone Extension of the contact at this company.','T','F','T',10,'E&xtension:','Enter the Phone Extension of the contact at this company.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','fax',null,'phone_number','&Fax:','Enter the Fax number of the contact at this company.','T','F','T',20,'&Fax:','Enter the Fax number of the contact at this company.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','Home phone',null,'phone_number','Ho&me No:','Enter the Home phone number of the contact at this company.','T','F','T',20,'Ho&me No:','Enter the Home phone number of the contact at this company.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','mail_stop',null,'mail_stop','&Mail Stop:','Enter this Customer''s Mail Stop','T','F','T',20,'&Mail Stop:','Enter this Customer''s Mail Stop','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','name',null,'name','&Name:','Enter the Name of the person to  contact at this company.','T','F','T',50,'&Name:','Enter the Name of the person to  contact at this company.','T','F',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','note_text',null,'note_text','&Notes:','Enter any Notes about this company.','T','F','T',255,'&Notes:','Enter any Notes about this company.','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','phone_number',null,'phone_number','&Phone:','Enter the Phone number of the contact at this company.','T','F','T',20,'&Phone:','Enter the Phone number of the contact at this company.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','postal_code',null,'postal_code','&Postal Code:','Enter this Customer''s Postal Code.','T','F','T',10,'&Postal Code:','Enter this Customer''s Postal Code.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','record_type',null,'record_type','Address &Type:','Enter an Address type.  The address type can be one of the followings: billing, mailing, corporate shipping, etc.','T','T','F',50,'Address &Type:','Enter an Address type.  The address type can be one of the followings: billing, mailing, corporate shipping, etc.','T','T',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','state',null,'state','Stat&e:','Enter the State in which this Customer located.','T','F','T',50,'Stat&e:','Enter the State in which this Customer located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (4,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
END
ELSE
	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 4 and control = 'Label' and (field = 'customer_number' or field = 'name')  
GO
-- form 5
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 5) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 5';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','address1',null,'address1','Address &1:','Enter the Manufacturer''s address, Line 1.','T','F','T',100,'Address &1:','Enter the Manufacturer''s address, Line 1.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','address2',null,'address2','Address &2:','Enter the Manufacturer''s address, Line 2.','T','F','T',100,'Address &2:','Enter the Manufacturer''s address, Line 2.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','city',null,'city','C&ity:','Enter the city where this manufacturer is located.','T','F','T',50,'C&ity:','Enter the city where this manufacturer is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','Contact Cell Phone',null,'phone_number','Contact C&ell No:','Enter the Cell Phone number of the contact at this manufacturer.','T','F','T',20,'Contact C&ell No:','Enter the Cell Phone number of the contact at this manufacturer.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','Contact Fax',null,'phone_number','Contact &Fax:','Enter the Fax number of the contact at this manufacturer.','T','F','T',20,'Contact &Fax:','Enter the Fax number of the contact at this manufacturer.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','Contact work phone',null,'phone_number','Contact &Phone:','Enter the Phone number of the contact at this manufacturer.','T','F','T',20,'Contact &Phone:','Enter the Phone number of the contact at this manufacturer.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','Contact work phone extension',null,'extension','Contact E&xt.:','Enter the Extension of the contact at this manufacturer.','T','F','T',10,'Contact E&xt.:','Enter the Extension of the contact at this manufacturer.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','contact_name',null,'contact_name','Con&tact Name:','Enter the Name of the contact at this manufacturer.','T','F','T',50,'Con&tact Name:','Enter the Name of the contact at this manufacturer.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','country',null,'country','Co&untry:','Enter the Country for the selected address type.','T','F','T',50,'Co&untry:','Enter the Country for the selected address type.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','email',null,'email','&Email:','Enter the Email address of this manufacturer.','T','F','T',250,'&Email:','Enter the Email address of this manufacturer.','T','F',250,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','extension',null,'extension','E&xtension:','Enter the Phone extension of the contact at this manufacturer.','T','F','T',10,'E&xtension:','Enter the Phone extension of the contact at this manufacturer.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','fax',null,'phone_number','&Fax:','Enter the Fax number of this manufacturer.','T','F','T',20,'&Fax:','Enter the Fax number of this manufacturer.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','mail_stop',null,'mail_stop','&Mail Stop:','Enter Mail stop for the selected address type.','T','F','T',20,'&Mail Stop:','Enter Mail stop for the selected address type.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'List Form Name','Manufacturer',null,null,'Manufacturer','**','T','F','F',0,'Manufacturer','**','T','F',0,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','manufacturer_id',null,'manufacturer_id','manufacturer_id','**','T','F','T',30,'manufacturer_id','**','T','F',30,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','name',null,'name','&Name:','Enter the name you will use to refer to this Manufacturer.','T','T','T',50,'&Name:','Enter the name you will use to refer to this Manufacturer.','T','T',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','note_text',null,'note_text','&Notes:','Enter any Notes about this Manufacturer.','T','F','T',255,'&Notes:','Enter any Notes about this Manufacturer.','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','phone_number',null,'phone_number','&Phone:','Enter the Phone number for this manufacturer.','T','F','T',20,'&Phone:','Enter the Phone number for this manufacturer.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','postal_code',null,'postal_code','Postal Co&de:','Enter the Postal Code for this address type.','T','F','T',10,'Postal Co&de:','Enter the Postal Code for this address type.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','record_type',null,'record_type','Address &Type:','The Address type can be one of the followings: billing, mailing, corporate shipping, etc.','T','T','F',50,'Address &Type:','The Address type can be one of the followings: billing, mailing, corporate shipping, etc.','T','T',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','state',null,'state','S&tate:','Enter the State for this address type.','T','F','T',50,'S&tate:','Enter the State for this address type.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (5,'Label','website',null,'website','&Web Site:','Enter the Web site for this manufacturer.','T','F','T',255,'&Web Site:','Enter the Web site for this manufacturer.','T','F',255,null,null,null,1,1,'T','1','1','T');
END
ELSE
	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 5 and control = 'Label' and field = 'name'

GO

-- form 6
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 6) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 6';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','alt_item_number',null,'alt_item_number','Alt Item &Number:','Enter an Alternate item number, if needed.','T','F','T',30,'Alt Item &Number:','Enter an Alternate item number, if needed.','T','F',30,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','avgcost',null,'avgcost','Average Cost:','Enter the average cost for the item (calculated).','T','F','F',8,'Average Cost:','Enter the average cost for the item (calculated).','T','F',8,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','category',null,'category','Categor&y:','Select a Category or enter a new one.','T','F','T',255,'Categor&y:','Select a Category or enter a new one.','T','F',255,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','checkout_duration',null,'checkout_duration','Checkout Length:','Enter the default number of days a customer/employee can have this asset type checked out. This number is used to populate the default Check Out time.','T','F','T',4,'Checkout Length:','Enter the default number of days a customer/employee can have this asset type checked out. This number is used to populate the default Check Out time.','T','F',4,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','checkout_duration_formatted',null,'checkout_duration','Checkout Length - Formatted', null,'F','F','F',4,'Checkout Length - Formatted',null,'F','F',4,null,'F',null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','class_name',null,'class_name','Depreciation Cla&ss:','Select a Depreciation Class for this asset type.','T','F','T',50,'Depreciation Cla&ss:','Select a Depreciation Class for this asset type.','T','F',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','code',null,'code','Location',null,null,null,'T',null,'Location',null,null,null,null,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','cost',null,'cost','C&ost:','The cost to you of this asset type per unit.','T','F','F',8,'C&ost:','The cost to you of this asset type per unit.','T','F',8,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','default_location',null,'default_location_id','&Default Location:','Set a default location for the asset type. This is the line item location that will be printed on the pick ticket. This is a QuickBooks only feature.','T','F','T',null,'&Default Location:','Set a default location for the asset type. This is the line item location that will be printed on the pick ticket. This is a QuickBooks only feature.','T','F',null,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','description',null,'description','&Description:','Enter a description of this asset type.','T','F','T',255,'&Description:','Enter a description of this asset type.','T','F',255,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','dimension_unit',null,'dimension_unit','&Dimension Unit:','The units used to describe the dimentions of one of these asset types.','T','F','T',50,'&Dimension Unit:','The units used to describe the dimentions of one of these asset types.','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','height',null,'height','Hei&ght:','The Height of one of these asset types','T','F','T',50,'Hei&ght:','The Height of one of these asset types','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'List Form Name','Item',null,null,'Asset Type','**',null,null,'F',null,'Asset Type','**',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','item_id',null,'item_id','item_id','**','T','F','T',30,'item_id','**','T','F',30,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','item_number',null,'item_number','&Asset Type:','Enter a unique name for this Asset Type in this field.','T','T','T',30,'&Asset Type:','Enter a unique name for this Asset Type in this field.','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','length',null,'length','&Length:','Enter the Length of one of these asset types','T','F','T',50,'&Length:','Enter the Length of one of these asset types','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','linked_file',null,'linked_file','&File Reference:','A file with information about this asset type.','T','F','T',255,'&File Reference:','A file with information about this asset type.','T','F',255,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','list_price',null,'list_price','List P&rice:','Enter the list price for this asset type.','T','F','T',8,'List P&rice:','Enter the list price for this asset type.','T','F',8,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','manager',null,'manager','Mana&ger:','Enter the name of the manager of this asset type.','T','F','T',50,'Mana&ger:','Enter the name of the manager of this asset type.','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','manufacturer',null,'manufacturer','Manufacturer:','Select the Manufacturer of this asset type.','T','F','T',50,'Manufacturer:','Select the Manufacturer of this asset type.','T','F',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','max_stock_level',null,'max_stock_level','Ma&x Stock Level:','Enter the Maximum Stock Level for this item (maximum across all sites).','T','F','T',30,'Ma&x Stock Level:','Enter the Maximum Stock Level for this item (maximum across all sites).','T','F',30,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','min_stock_level',null,'min_stock_level','Min Stoc&k Level:','Enter the Minimum Stock Level for this item (minimum across all sites).','T','F','T',30,'Min Stoc&k Level:','Enter the Minimum Stock Level for this item (minimum across all sites).','T','F',30,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','model',null,'model','Mod&el:','Select the Model of this asset type.','T','F','T',50,'Mod&el:','Select the Model of this asset type.','T','F',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','note_text',null,'note_text','&Notes:','Enter any Notes about this asset type.','T','F','T',255,'&Notes:','Enter any Notes about this asset type.','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','qty_available',null,'qty_available','Total Available:','Total available inventory.','T','F','F',50,'Total Available:','Total available inventory.','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','qty_checked_out',null,'qty_checked_out','Total Checked-Out:','Total checked-out inventory.','T','F','F',50,'Total Checked-Out:','Total checked-out inventory.','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','qty_in_house',null,'qty_in_house','Total In-House:','Total In-House inventory.','T','F','F',50,'Total In-House:','Total In-House inventory.','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','reorder_qty',null,'reorder_qty','Reorder &Qty:','Enter the Reorder quantity for this item.','T','F','T',30,'Reorder &Qty:','Enter the Reorder quantity for this item.','T','F',30,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','require_customers',null,'track_customers','C&ustomer:','Is this item tracked by customer?','T','F','T',25,'C&ustomer:','Is this item tracked by customer?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','require_pos',null,'track_pos','&PO:','Is this item tracked by purchase order number?','T','F','T',25,'&PO:','Is this item tracked by purchase order number?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','require_suppliers',null,'track_suppliers','&Vendor','Is this item tracked by vendor?','T','F','T',25,'&Vendor','Is this item tracked by vendor?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','sale_price',null,'sale_price','Sale Price:','Enter the Sale Price for this asset type.','T','F','T',8,'Sale Price:','Enter the Sale Price for this asset type.','T','F',8,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','site_name',null,'site_name','Site',null,null,null,'T',50,'Site',null,null,null,50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','supplier',null,'supplier','Vendor Name:','Select the Vendor of this asset type.','T','F','T',50,'Vendor Name:','Select the Vendor of this asset type.','T','F',50,null,null,null,2,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','supplier_number',null,'supplier_number','Vendor Number:','Select the Vendor Number for this asset type.','T','F','T',30,'Vendor Number:','Select the Vendor Number for this asset type.','T','F',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','track_date_codes',null,'track_date_codes','&Date Code:','Is this item tracked by date code?','T','F','T',25,'&Date Code:','Is this item tracked by date code?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','track_lots',null,'track_lots','&Lot:','Is this item tracked by lot number?','T','F','T',25,'&Lot:','Is this item tracked by lot number?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','track_pallets',null,'track_pallets','P&allet:','Is this item tracked by pallet?','T','F','T',25,'P&allet:','Is this item tracked by pallet?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','track_serial_numbers',null,'track_serial_numbers','&Serial Number:','Is this item tracked by serial number?','T','F','T',25,'&Serial Number:','Is this item tracked by serial number?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','unit_of_measure',null,'unit_of_measure','Unit Of &Measure:','What units do you count this item in? By the box, gross, vial, pound, individually, etc.','T','F','T',10,'Unit Of &Measure:','What units do you count this item in? By the box, gross, vial, pound, individually, etc.','T','F',10,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','vendor',null,'supplier_number','&Vendor      Code:','Select the Vendor of this asset type.','T','F','T',50,'&Vendor      Code:','Select the Vendor of this asset type.','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','weight',null,'weight','&Weight:','The weight of one of these asset types','T','F','T',50,'&Weight:','The weight of one of these asset types','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','weight_unit',null,'weight_unit','W&eight Unit:','Enter the Units you use to measure one of these items.','T','F','T',50,'W&eight Unit:','Enter the Units you use to measure one of these items.','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','width',null,'width','Wid&th:','Enter the Width of one of these asset types','T','F','T',50,'Wid&th:','Enter the Width of one of these asset types','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','lead_time',null,'lead_time','Lead Time:','Enter a time from when an asset is checked in to when it is available for checkout again.','T','N','T',1,'Lead Time:','Enter a time from when an asset is checked in to when it is available for checkout again.','T','N',1,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','lead_time_formatted',null,'lead_time','Lead Time - Formatted', null,'F','F','F',4,'Lead Time - Formatted',null,'F','F',4,null,'F',null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (6,'Label','linked_reference',null,'linked_reference','Hyperlink:','You can include a link to an online reference or documentation of this asset type','T','F','T',1000,'Hyperlink:','You can include a link to an online reference or documentation of this asset type','T','F',1000,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN
	-- make sure that if upgrade from an previous version, we correctly show "Asset Type" (not "Item") in the import/export wizard

	IF (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 6 and control = 'List Form Name' and field = 'Item' and label = 'Item') > 0
	BEGIN
		DELETE FROM form_field_meta WHERE form_id = 6 and control = 'List Form Name' and field = 'Item' and label = 'Item'

		insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (6,'List Form Name','Item',null,null,'Asset Type','**',null,null,'F',null,'Asset Type','**',null,null,null,null,null,null,1,1,'T','1','1');
	END

	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 6 and control = 'Label' and field = 'lead_time') = 0
		INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (6,'Label','lead_time',null,'lead_time','Lead Time:','Time from when an asset is checked in to when it is available for checkout again.','T','N','T',1,'Lead Time:','Time from when an asset is checked in to when it is available for checkout again.','T','N',1,null,null,null,1,1,'T','1','1');
	
	INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (6,'Label','checkout_duration',null,'checkout_duration','Checkout Length:','The default time a customer/employee can have this asset type checked out. Used to populate the default Check Out time.','T','F','T',4,'Checkout Lengt&h:','The default time a customer/employee can have this asset type checked out. Used to populate the default Check Out time.','T','F',4,null,'F',null,1,1,'T','1','1');

	INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (6,'Label','description',null,'description','&Description:','Enter a description of this asset type.','T','F','T',255,'&Description:','Enter a description of this asset type.','T','F',255,null,null,null,1,1,'T','1','1');

	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 6 and control = 'Label' and field = 'linked_reference') = 0
		insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (6,'Label','linked_reference',null,'linked_reference','Hyperlink:','An online reference or documentation of this asset type','T','F','T',1000,'Hyperlink:','An online reference or documentation of this asset type','T','F',1000,null,null,null,1,1,'T','1','1'); 

	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 6 and control = 'Label' and field = 'lead_time_formatted') = 0
		INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (6,'Label','lead_time_formatted',null,'lead_time','Lead Time - Formatted', null,'F','F','F',4,'Lead Time - Formatted',null,'F','F',4,null,'F',null,1,1,'F','1','0');
	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 6 and control = 'Label' and field = 'checkout_duration_formatted') = 0
		INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (6,'Label','checkout_duration_formatted',null,'checkout_duration','Checkout Length - Formatted', null,'F','F','F',4,'Checkout Length - Formatted',null,'F','F',4,null,'F',null,1,1,'F','1','0');

	UPDATE form_field_meta SET tool_tip='Name of the asset type''s class.', default_tool_tip='Name of the asset type''s class.' WHERE form_id = 6 AND field = 'class_name' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='Select the Manufacturer of this asset type.', default_tool_tip='Select the Manufacturer of this asset type.', label='Manufacturer:', default_label='Manufacturer:' WHERE form_id = 6 AND field = 'manufacturer' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='Select the Model of this asset type.', default_tool_tip='Select the Model of this asset type.' WHERE form_id = 6 AND field = 'model' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='Select the Vendor Number for this asset type.', default_tool_tip='Select the Vendor Number for this asset type.', label='Vendor Number:', default_label='Vendor Number:' WHERE form_id = 6 AND field = 'supplier_number' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='The Height of one of these asset types', default_tool_tip='The Height of one of these asset types' WHERE form_id = 6 AND field = 'height' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='The Length of one of these asset types', default_tool_tip='The Length of one of these asset types' WHERE form_id = 6 AND field = 'length' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='The Width of one of these asset types', default_tool_tip='The Width of one of these asset types' WHERE form_id = 6 AND field = 'width' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='The weight of one of these asset types', default_tool_tip='The weight of one of these asset types' WHERE form_id = 6 AND field = 'weight' AND control = 'Label'
	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 6 and control = 'Label' and (field = 'item_number' or field = 'description' or field = 'manufacturer' or field = 'model' or field = 'checkout_duration' or field = 'class_name' or field = 'category' or field = 'supplier_number' or field = 'lead_time') 
	update form_field_meta set label = '&Asset Type:', tool_tip = 'Enter asset type id in this field. Asset type must be unique.', default_label = '&Asset Type:', default_tool_tip= 'Enter asset type id in this field. Asset type must be unique.' WHERE form_id = 6 and control = 'label' and field = 'item_number'
 
END
GO

-- form 7
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 7) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 7';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','code',null,'code','Locatio&n:','Enter the indentifier you will use for this location throughout the system.','T','T','T',30,'Locatio&n:','Enter the indentifier you will use for this location throughout the system.','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','description',null,'description','&Description:','Enter a Description for this location.','T','F','T',255,'&Description:','Enter a Description for this location.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'List Form Name','Location',null,null,'Location','**',null,null,'F',null,'Location','**',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','location_id',null,'location_id','location_id','**',null,null,'T',null,'location_id','**',null,null,null,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','note_text',null,'note_text','No&tes:','Enter any Notes about this location.','T','F','T',255,'No&tes:','Enter any Notes about this location.','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','site',null,'site','&Site:','Pick the Site in which this Location resides.','T','T','T',50,'&Site:','Pick the Site in which this Location resides.','T','T',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (7,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN
	UPDATE form_field_meta SET field_length=50, default_field_length=50 WHERE form_id = 7 AND field = 'site' AND control = 'Label'
	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 7 and control = 'Label' and (field = 'code' or field = 'site')  
END
GO

-- form 8
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 8) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 8';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','description',null,'description','&Description:','Enter a Description for this site.','T','F','T',255,'&Description:','Enter a Description for this location.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','note_text',null,'note_text','No&tes:','Enter any Notes about this site.','T','F','T',255,'No&tes:','Enter any Notes about this site.','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'List Form Name','Site',null,null,'Site','**',null,null,'F',null,'Site','**',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','site_id',null,'site_id','location_id','**',null,null,'T',null,'location_id','**',null,null,null,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','site_name',null,'site_name','&Site:','Pick the Site in which this asset is located.','T','T','T',50,'&Site:','Pick the Site in which this asset is located.','T','T',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (8,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN
	UPDATE form_field_meta SET tool_tip='Enter a Description for this site.', default_tool_tip='Enter a Description for this site.' WHERE form_id = 8 AND field = 'description' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='Notes about this site.', default_tool_tip='Notes about this site.' WHERE form_id = 8 AND field = 'note_text' AND control = 'Label'
	UPDATE form_field_meta SET tool_tip='Pick the Site the asset is in.', default_tool_tip='Pick the Site the asset is in.' WHERE form_id = 8 AND field = 'site_name' AND control = 'Label'
	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 8 and control = 'Label' and field = 'site_name'
END
GO
-- form 9
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 9) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 9';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','address1',null,'address1','Address &1:','Enter the Vendor''s Address line 1 for the selected address type.','T','F','T',100,'Address &1:','Enter the Vendor''s Address line 1 for the selected address type.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','address2',null,'address2','Address &2:','Enter the Vendor''s Address line 2 for the selected address type.','T','F','T',100,'Address &2:','Enter the Vendor''s Address line 2 for the selected address type.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','city',null,'city','C&ity:','Enter the City for the selected address type.','T','F','T',50,'C&ity:','Enter the City for the selected address type.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','Contact Cell Phone',null,'phone_number','Contact C&ell No:','Enter the Cell phone number for the contact.','T','F','T',20,'Contact C&ell No:','Enter the Cell phone number for the contact.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','Contact Fax',null,'phone_number','Contact &Fax:','Enter the Fax number for the contact.','T','F','T',20,'Contact &Fax:','Enter the Fax number for the contact.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','Contact work phone',null,'phone_number','Contact &Phone:','Enter the Phone number for the contact.','T','F','T',20,'Contact &Phone:','Enter the Phone number for the contact.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','Contact work phone extension',null,'extension','Contact E&xt.:','Enter the Phone extension for the contact.','T','F','T',10,'Contact E&xt.:','Enter the Phone extension for the contact.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','contact_name',null,'contact_name','&Contact Name: ','Enter the Name of a contact at this vendor.','T','F','T',50,'&Contact Name: ','Enter the Name of a contact at this vendor.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','country',null,'country','Countr&y:','Enter the Country for the selected address type.','T','F','T',50,'Countr&y:','Enter the Country for the selected address type.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','email',null,'email','&Email:','Enter the Email address for this vendor.','T','F','T',250,'&Email:','Enter the Email address for this vendor.','T','F',250,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','extension',null,'extension','E&xtension:','Enter the Phone extension for the contact.','T','F','T',10,'E&xtension:','Enter the Phone extension for the contact.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','fax',null,'phone_number','&Fax:','Enter the Fax for this vendor.','T','F','T',20,'&Fax:','Enter the Fax for this vendor.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','fax_number',null,'fax_number','&Fax:','Enterthe Fax for this vendor.','T','F','T',20,'&Fax:','Enterthe Fax for this vendor.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','mail_stop',null,'mail_stop','&Mail Stop:','Enter the Mail stop for the selected address type.','T','F','T',20,'&Mail Stop:','Enter the Mail stop for the selected address type.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','name',null,'name','&Name:','Enter the name of this vendor.','T','F','T',50,'&Name:','Enter the name of this vendor.','T','F',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','note_text',null,'note_text','&Notes:','Enter any Notes about this vendor.','T','F','T',255,'&Notes:','Enter any Notes about this vendor.','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','phone_number',null,'phone_number','P&hone:','Enter the Phone number of this vendor.','T','F','T',20,'P&hone:','Enter the Phone number of this vendor.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','postal_code',null,'postal_code','&Postal Code:','Enter the Postal Code for the selected address type.','T','F','T',10,'&Postal Code:','Enter the Postal Code for the selected address type.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','record_type',null,'record_type','Address &Type:','Address type can be one of the followings: billing, mailing, corporate shipping, etc.','T','T','F',50,'Address &Type:','Address type can be one of the followings: billing, mailing, corporate shipping, etc.','T','T',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','state',null,'state','Sta&te:','Enter the State for the selected address type.','T','F','T',50,'Sta&te:','Enter the State for the selected address type.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'List Form Name','Supplier',null,null,'Vendor',null,null,null,'F',null,'Vendor',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','supplier_id',null,'supplier_id','Vendor ID',null,'T','F','T',30,'Vendor ID',null,'T','F',30,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','supplier_number',null,'supplier_number','&Vendor Code:','Enter Vendor Code','T','T','T',30,'&Vendor Code:','Enter Vendor Code','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (9,'Label','website',null,'website','&Web Site:','Enter the Web Site for this vendor.','T','F','T',255,'&Web Site:','Enter the Web Site for this vendor.','T','F',255,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN
	if(SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 9 and control = 'Label' and field = 'fax_number') = 0
		insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (9,'Label','fax_number',null,'fax_number','&Fax:','The Fax for this vendor.','T','F','T',20,'&Fax:','The Fax for this vendor.','T','F',20,null,null,null,1,1,'T','1','1');

	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 9 and control = 'Label' and (field = 'supplier_number' or field = 'name')  
END
GO

-- form 10
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10,'List Form Name','Category',null,null,null,'**',null,null,'F',null,null,'**',null,null,null,null,null,null,1,1,'T','1','1','T');
END
GO
-- form 11
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 11) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 11';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','code',null,'code','&Location:','**','T','T','T',null,'&Location:','**','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','date_acquired',null,'date_acquired','Date &Received:','Date the item was received','T','F','T',null,'Date &Received:','Date the item was received','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','date_code',null,'date_code','&Date Code:','**','T','F','T',null,'&Date Code:','**','T','F',null,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'List Form Name','Inventory',null,null,'Inventory','**',null,null,'F',null,'Inventory','**',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','item_desc',null,'item_desc','I&tem Description:','**','T','F','F',null,'I&tem Description:','**','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','item_number',null,'item_number','&Item Number:','**','T','T','T',null,'&Item Number:','**','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','lot',null,'lot','Lo&t:','**','T','F','T',null,'Lo&t:','**','T','F',null,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','pallet',null,'pallet','&Pallet:','**','T','F','T',null,'&Pallet:','**','T','F',null,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','po',null,'po','P&O:','**','T','F','T',null,'P&O:','**','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','quantity',null,'quantity','&Quantity:','Transaction Quantity','T','T','T',null,'&Quantity:','Transaction Quantity','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','rec_id',null,'rec_id','rec_id','rec_id','F','F','F',null,'rec_id','rec_id','F','F',null,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','serial_number',null,'serial_number','S&erial Number:','**','T','F','T',null,'S&erial Number:','**','T','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','site_name',null,'site_name','&Site:','**','T','T','T',50,'&Site:','**','T','T',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (11,'Label','supplier_number',null,'supplier_number','Vendor &Code:',null,'T','F','T',null,'Vendor &Code:',null,'T','F',null,null,null,null,1,1,'T','1','1','T');
END
GO
-- form 12
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 12) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 12';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (12,'List Form Name','History',null,null,'History','**',null,null,'F',null,'History','**',null,null,null,null,null,null,1,1,'T','1','1','T');
END
GO
-- form 13
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 13) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 13';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','action_type',null,'action_type','Action','Action','T','T','T',null,'Action','Action','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','adjust_code',null,'adjust_code','Adjust Reason Code','Adjust Reason Code','T','T','T',null,'Adjust Reason Code','Adjust Reason Code','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','adjust_type',null,'adjust_type','Adjust Type','Adjust Type','T','T','T',null,'Adjust Type','Adjust Type','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','audited_qty',null,'quantity','Audited Qty','Audited Quantity','T','T','T',null,'Audited Qty','Audited Quantity','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','code',null,'code','Lo&cation:','Location','T','T','T',null,'Lo&cation:','Location','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','cost',null,'cost','&Cost:','Item Cost','T','T','T',null,'&Cost:','Item Cost','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','current_qty',null,'current_qty','Current Qty:','Current Qty','T','T','T',null,'Current Qty:','Current Qty','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','customer_id',null,'Customer_id','Custo&mer:','Customer','T','T','T',null,'Custo&mer:','Customer','T','T',null,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','date_acquired',null,'date_acquired','&DateReceived:','Date the item was received','T','T','T',null,'&DateReceived:','Date the item was received','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','date_code',null,'date_code','&Date Code:','Date Code','T','T','T',null,'&Date Code:','Date Code','T','T',null,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','description',null,'description','&Item Description:','Item Description','T','T','T',null,'&Item Description:','Item Description','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','invoice',null,'invoice','I&nvoice No.:','Invoice Number','T','T','T',null,'I&nvoice No.:','Invoice Number','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','item_number',null,'item_number','&Item Number:','Item Number','T','T','T',null,'&Item Number:','Item Number','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','Lot',null,'Lot','L&ot:','Lot','T','T','T',null,'L&ot:','Lot','T','T',null,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','name',null,'name','&Customer:','Customer','T','T','T',null,'&Customer:','Customer','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','other_location',null,'other_location','To &Location:','To Location','T','T','T',null,'To &Location:','To Location','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','pallet',null,'pallet','P&allet:','Pallet','T','T','T',null,'P&allet:','Pallet','T','T',null,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','po',null,'po','&PO:','Purchase Order','T','T','T',null,'&PO:','Purchase Order','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','quantity',null,'quantity','&Quantity:','Transaction Quantity','T','T','T',null,'&Quantity:','Transaction Quantity','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','remaining_qty',null,'remaining_qty','&Quantity Remaining:','Quantity Remaining','T','T','T',null,'&Quantity Remaining:','Quantity Remaining','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','serial_number',null,'serial_number','Serial &Number:','Serial Number','T','T','T',null,'Serial &Number:','Serial Number','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','site_name',null,'site_name','Site',null,null,null,'T',50,'Site',null,null,null,50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','supplier_id',null,'supplier_id','&Vendor:','Vendor','T','T','T',null,'&Vendor:','Vendor','T','T',null,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','supplier_number',null,'supplier_number','&Vendor:','Vendor','T','T','T',null,'&Vendor:','Vendor','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','trans_date',null,'trans_date','T&rans Date:','Transaction Date','T','T','T',null,'T&rans Date:','Transaction Date','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','trans_type',null,'trans_type','&Trans Type:','Transaction Type','T','T','T',null,'&Trans Type:','Transaction Type','T','T',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'Label','transaction_id',null,'transaction_id','transaction_id','Transaction Id','F','T','F',null,'transaction_id','Transaction Id','F','T',null,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (13,'List Form Name','Transactions',null,'Transactions',null,'**',null,null,'F',null,null,'**',null,null,null,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 15
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 15) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 15';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','cost',null,'cost','Cos&t:','The cost to you of this item per unit.','T','F','F',8,'Cos&t:','The cost to you of this item per unit.','T','F',8,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','description',null,'description','Description:','The discription of this item.','T','F','T',255,'Description:','The discription of this item.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','item_number',null,'item_number','&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T','T',30,'&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','manufacturer',null,'manufacturer','&Manufacturer:','Select the Manufacturer of this item.','T','F','T',50,'&Manufacturer:','Select the Manufacturer of this item.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','note_text',null,'note_text','&Notes:','Enter the notes for the receiving transaction of this PO','T','F','T',255,'&Notes:','Enter the notes for the receiving transaction of this PO','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','require_packlist',null,'require_packlist','&Pack List:','Is this item tracked by purchase order number?','T','F','T',25,'&Pack List:','Is this item tracked by purchase order number?','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','require_pos',null,'require_pos','&PO:','Enter the Purchase Order number.','T','F','T',25,'&PO:','Enter the Purchase Order number.','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','require_supplier',null,'require_supplier','&Vendor Code:','Select the Vendor Code for this item.','T','F','T',30,'&Vendor Code:','Select the Vendor Code for this item.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','require_vendor',null,'track_suppliers','&Vendor:','Is this item tracked by vendor?','T','F','T',25,'&Vendor:','Is this item tracked by vendor?','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','track_date_codes',null,'track_date_codes','&Date Code:','Enter the Date Code for this item.','T','F','T',25,'&Date Code:','Enter the Date Code for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','track_lots',null,'track_lots','&Lot:','Enter the Lot for this item.','T','F','T',25,'&Lot:','Enter the Lot for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','track_pallets',null,'track_pallets','P&allet:','Enter the Pallet for this item.','T','F','T',25,'P&allet:','Enter the Pallet for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (15,'Label','track_serial_numbers',null,'track_serial_numbers','&Serial Number:','Enter the Serial Number for this item.','T','F','T',25,'&Serial Number:','Enter the Serial Number for this item.','T','F',25,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 16
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 16) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 16';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','description',null,'description','Description:','The discription of this item.','T','F','T',255,'Description:','The discription of this item.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','item_number',null,'item_number','&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T','T',30,'&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','note_text',null,'note_text','&Notes:','Enter the notes for the receiving transaction of this PO','T','F','T',255,'&Notes:','Enter the notes for the receiving transaction of this PO','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','pick_ticket_number',null,'pick_ticket_number','&Pick Ticket No.:','Enter the Pick Ticket Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T','T',30,'&Pick Ticket No.:','Enter the Pick Ticket Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','require_customers',null,'track_customers','C&ustomer:','Is this item tracked by customer?','T','F','T',25,'C&ustomer:','Is this item tracked by customer?','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','track_date_codes',null,'track_date_codes','&Date Code:','Enter the Date Code for this item.','T','F','T',25,'&Date Code:','Enter the Date Code for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','track_lots',null,'track_lots','&Lot:','Enter the Lot for this item.','T','F','T',25,'&Lot:','Enter the Lot for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','track_pallets',null,'track_pallets','P&allet:','Enter the Pallet for this item.','T','F','T',25,'P&allet:','Enter the Pallet for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (16,'Label','track_serial_numbers',null,'track_serial_numbers','&Serial Number:','Enter the Serial Number for this item.','T','F','T',25,'&Serial Number:','Enter the Serial Number for this item.','T','F',25,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 17
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 17) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 17';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','asset_tag',null,'asset_tag','&Asset Tag:','Enter or select an asset tag number.','T','F','F',30,'&Asset Tag:','Enter or select an asset tag number.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','category',null,null,'Categor&y','Search for asset category.','T','F','F',100,'Categor&y','Search for asset category.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','chkComplete',null,null,'Complete:','Check to mark as complete and calculate the next maintenance date.','T','F','F',30,'Complete:','Check to mark as complete and calculate the next maintenance date.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','condition',null,null,'Condition:','Enter the Condition of asset.','T','F','F',30,'Condition:','Enter the Condition of asset.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','cost',null,'cost','Cos&t:','Enter the maintenance cost of this asset.','T','F','F',8,'Cos&t:','Enter the maintenance cost of this asset.','T','F',8,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','customer',null,null,'C&ustomer:','Filter by Customer.','T','F','F',30,'C&ustomer:','Filter by Customer.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','date_completed',null,null,'Date:','Enter the Date maintenance was completed.','T','F','F',30,'Date:','Enter the Date maintenance was completed.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','date_due',null,null,'Date Due:','Date asset is due back','T','F','F',30,'Date Due:','Date asset is due back','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','department_code',null,'code','Depa&rtment:','Department where asset is located.','T','F','F',30,'Depa&rtment:','Department where asset is located.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','description',null,null,'Descri&ption','Search for partial description','T','F','F',100,'Descri&ption','Search for partial description','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','employee',null,null,'E&mployee:','Filter by Employee','T','F','F',30,'E&mployee:','Filter by Employee','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','location',null,'location','&Location','Enter the location of the asset.','T','F','F',30,'&Location','Enter the location of the asset.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','maint_note',null,null,'Description of maintenance','Description of maintenance','T','F','F',10000,'Description of maintenance','Description of maintenance','T','F',10000,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','maint_type',null,null,'&Type','Maintenance Type','T','F','F',30,'&Type','Maintenance Type','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','po',null,'po','&Purchase Order:','Purchase order number.','T','F','F',30,'&Purchase Order:','Purchase order number.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','reason',null,null,'&Reason:','Disposal Reason','T','F','F',30,'&Reason:','Disposal Reason','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (17,'Label','to_location',null,null,'T&o Location:','Destination Location','T','F','F',30,'T&o Location:','Destination Location','T','F',30,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN
	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 17 and control = 'Label' and field = 'maint_type') = 0
		INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (17,'Label','maint_type',null,null,'&Type','Maintenance Type','T','F','F',30,'&Type','Maintenance Type','T','F',30,null,null,null,1,1,'T','1','1');
	DELETE FROM form_field_meta where form_id = 17 and control = 'Label' and field = 'to_location'
	INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (17,'Label','to_location',null,null,'T&o Location:','Destination Location','T','F','F',30,'T&o Location:','Destination Location','T','F',30,null,null,null,1,1,'T','1','1');
	DELETE FROM form_field_meta where form_id = 17 and control = 'Label' and field = 'department_code'
	INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (17,'Label','department_code',null,'code','Depa&rtment:','Department where asset is located.','T','F','F',30,'Depa&rtment:','Department where asset is located.','T','F',30,null,null,null,1,1,'T','1','1');
	DELETE FROM form_field_meta where form_id = 17 and control = 'Label' and field = 'employee'
	INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (17,'Label','employee',null,null,'E&mployee:','Filter by Employee','T','F','F',30,'E&mployee:','Filter by Employee','T','F',30,null,null,null,1,1,'T','1','1');
	DELETE FROM form_field_meta where form_id = 17 and control = 'Label' and field = 'cost'
	insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (17,'Label','cost',null,'cost','Cos&t:','The maintenance cost of this asset.','T','F','F',8,'Cos&t:','The maintenance cost of this asset.','T','F',8,null,null,null,1,1,'T','1','1');
END
GO

-- form 18
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 18) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 18';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (18,'Label','description',null,'description','Description:','The discription of this item.','T','F','T',255,'Description:','The discription of this item.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (18,'Label','item_number',null,'item_number','&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T','T',30,'&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (18,'Label','require_customers',null,'track_customers','C&ustomer:','Pick a customer from the list or enter the customer number.','T','F','T',25,'C&ustomer:','Pick a customer from the list or enter the customer number.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (18,'Label','track_date_codes',null,'track_date_codes','&Date Code:','Enter the Date Code for this item.','T','F','T',25,'&Date Code:','Enter the Date Code for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (18,'Label','track_lots',null,'track_lots','&Lot:','Enter the Lot for this item.','T','F','T',25,'&Lot:','Enter the Lot for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (18,'Label','track_pallets',null,'track_pallets','P&allet:','Enter the Pallet for this item.','T','F','T',25,'P&allet:','Enter the Pallet for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (18,'Label','track_serial_numbers',null,'track_serial_numbers','&Serial Number:','Enter the Serial Number for this item.','T','F','T',25,'&Serial Number:','Enter the Serial Number for this item.','T','F',25,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 19
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 19) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 19';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','checkout_duration',null,'checkout_duration','Checkout Lengt&h:','The default number of days a customer/employee can have this item checked out. Used to populate the default Check Out time.','T','F','T',4,'Checkout Lengt&h:','The default number of days a customer/employee can have this item checked out. Used to populate the default Check Out time.','T','F',4,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','description',null,'description','Description:','The discription of this item.','T','F','T',255,'Description:','The discription of this item.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','item_number',null,'item_number','&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T','T',30,'&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','require_customers',null,'track_customers','C&ustomer:','Pick a customer from the list or enter the customer number.','T','F','T',25,'C&ustomer:','Pick a customer from the list or enter the customer number.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','track_date_codes',null,'track_date_codes','&Date Code:','Enter the Date Code for this item.','T','F','T',25,'&Date Code:','Enter the Date Code for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','track_lots',null,'track_lots','&Lot:','Enter the Lot for this item.','T','F','T',25,'&Lot:','Enter the Lot for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','track_pallets',null,'track_pallets','P&allet:','Enter the Pallet for this item.','T','F','T',25,'P&allet:','Enter the Pallet for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (19,'Label','track_serial_numbers',null,'track_serial_numbers','&Serial Number:','Enter the Serial Number for this item.','T','F','T',25,'&Serial Number:','Enter the Serial Number for this item.','T','F',25,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 20
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 20) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 20';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (20,'Label','description',null,'description','Description:','The discription of this item.','T','F','T',255,'Description:','The discription of this item.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (20,'Label','item_number',null,'item_number','&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T','T',30,'&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (20,'Label','track_date_codes',null,'track_date_codes','&Date Code:','Enter the Date Code for this item.','T','F','T',25,'&Date Code:','Enter the Date Code for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (20,'Label','track_lots',null,'track_lots','&Lot:','Enter the Lot for this item.','T','F','T',25,'&Lot:','Enter the Lot for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (20,'Label','track_pallets',null,'track_pallets','P&allet:','Enter the Pallet for this item.','T','F','T',25,'P&allet:','Enter the Pallet for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (20,'Label','track_serial_numbers',null,'track_serial_numbers','&Serial Number:','Enter the Serial Number for this item.','T','F','T',25,'&Serial Number:','Enter the Serial Number for this item.','T','F',25,null,null,null,1,1,'T','1','1','T');
END

-- form 21
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 21) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 21';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','absolute_adjust',null,'absolute_adjust','By Counts','Pick a reason from the list for adjustment','T','F','T',25,'By Counts','Pick a reason from the list for adjustment','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','adjust_reason',null,'adjust_reason','&Reason:','Pick a reason from the list for adjustment','T','F','T',25,'&Reason:','Pick a reason from the list for adjustment','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','description',null,'description','Description:','The discription of this item.','T','F','T',255,'Description:','The discription of this item.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','item_number',null,'item_number','&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T','T',30,'&Item Number:','Enter the Item Number. You can pick from the list, enter the number through the keyboard or scan it in.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','relative_adjust',null,'relative_adjust','By Difference','Pick a reason from the list for adjustment','T','F','T',25,'By Difference','Pick a reason from the list for adjustment','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','track_date_codes',null,'track_date_codes','&Date Code:','Enter the Date Code for this item.','T','F','T',25,'&Date Code:','Enter the Date Code for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','track_lots',null,'track_lots','&Lot:','Enter the Lot for this item.','T','F','T',25,'&Lot:','Enter the Lot for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','track_pallets',null,'track_pallets','P&allet:','Enter the Pallet for this item.','T','F','T',25,'P&allet:','Enter the Pallet for this item.','T','F',25,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (21,'Label','track_serial_numbers',null,'track_serial_numbers','&Serial Number:','Enter the Serial Number for this item.','T','F','T',25,'&Serial Number:','Enter the Serial Number for this item.','T','F',25,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 22
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 22) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 22';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','customer_name',null,'customer_name','Customer Name',null,null,null,'T',null,'Customer Name',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','customer_number',null,'customer_number','Customer No.',null,null,null,'T',null,'Customer No.',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','due_date',null,'due_date','Due Date',null,null,null,'T',null,'Due Date',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','po_status',null,'po_status','Status',null,null,null,'T',null,'Status',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','po_type',null,'po_type','Type',null,'F',null,'T',null,'Type',null,'F',null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'List Form Name','PurchaseOrder',null,'**','Purchase Order','**','T','F','T',0,'Purchase Order','**','T','F',0,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','record_status',null,'record_status','Record Status',null,null,null,'T',null,'Record Status',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','ref_number',null,'ref_number','Number',null,null,null,'T',null,'Number',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','supplier_name',null,'supplier_name','Vendor  Name',null,null,null,'T',null,'Vendor  Name',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (22,'Label','supplier_number',null,'supplier_number','Vendor No.',null,null,null,'T',null,'Vendor No.',null,null,null,null,null,null,null,1,1,'T','1','1','T');
END

-- form 23
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 23) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 23';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','child_bo',null,'child_bo','Backorder',null,null,null,'T',null,'Backorder',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','customer_name',null,'customer_name','Customer Name',null,null,null,'T',null,'Customer Name',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','customer_number',null,'customer_number','Customer No.',null,null,null,'T',null,'Customer No.',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','due_date',null,'due_date','Due Date',null,null,null,'T',null,'Due Date',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'List Form Name','Invoice',null,null,'Invoice','**','T','F','T',0,'Invoice','**','T','F',0,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','invoice_status',null,'invoice_status','Status',null,null,null,'T',null,'Status',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','invoice_type',null,'has_bo','Has B.O.?',null,null,null,'T',null,'Has B.O.?',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','parent_bo',null,'parent_bo','Backorder From',null,null,null,'T',null,'Backorder From',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','po_number',null,'po_number','PO Number',null,null,null,'T',null,'PO Number',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','record_status',null,'record_status','Record Status',null,null,null,'T',null,'Record Status',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (23,'Label','ref_number',null,'ref_number','Number',null,null,null,'T',null,'Number',null,null,null,null,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 24
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 24) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 24';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (24,'Label','picked_quantity',null,null,'Picked Qty',null,null,null,'T',null,'Picked Qty',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (24,'Label','quantity',null,null,'Quantity',null,null,null,'T',null,'Quantity',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (24,'Label','quantity_received',null,null,'Recv''d Qty',null,null,null,'T',null,'Recv''d Qty',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (24,'Label','shorted',null,null,'Shorted?',null,null,null,'T',null,'Shorted?',null,null,null,null,null,null,null,1,1,'T','1','1','T');
END

-- form 25
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 25) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 25';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (25,'Label','quantity',null,null,'Quantity',null,null,null,'T',null,'Quantity',null,null,null,null,null,null,null,1,1,'T','1','1','T');
END

-- form 26
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 26) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 26';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','asset_life_months',null,'asset_life_months','Asset Life Months:','Asset Depreciation Life Months','T','N','F',4,'Asset Life Months:','Asset Depreciation Life Months','T','N',4,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','asset_life_years',null,'asset_life_years','Asset Life Years:','Asset Depreciation Life Years','T','N','F',4,'Asset Life Years:','Asset Depreciation Life Years','T','N',4,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'List Form Name','Class',null,null,'Depreciation Class','Asset Depreciation Class List',null,null,'F',null,'Depreciation Class','Asset Depreciation Class List',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','class_name',null,'class_name','Name:','Depreciation Class Name','T','T','T',50,'Name:','Depreciation Class Name','T','T',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','depreciation_custom_percent',null,'depreciation_custom_percent','Custom Percentage:','Custom Percentage to apply to the depreciation method','T','T','T',3,'Custom Percentage:','Custom Percentage to apply to the depreciation method','T','T',3,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','depreciation_method',null,'depreciation_method','Depreciation Method:','Asset Deprecation Method','T','T','T',50,'Depreciation Method:','Asset Deprecation Method','T','T',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','depreciation_period',null,null,'Depreciation Period:','Asset Deprecation Period','T','T','F',4,'Depreciation Period:','Asset Deprecation Period','T','T',4,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','deprec_to_salvage',null,'deprec_to_salvage','Fully depreciate to salvage value','Adjust the final year depreciation to ensure asset value reaches its specified salvage value. (This only applies to double or custom declining method)','T','F','T',1,'Fully depreciate to salvage value','Adjust the final year depreciation to ensure asset value reaches its specified salvage value. (This only applies to double or custom declining method)','T','F',1,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','lblClass',null,'class_name','Name:','Depreciation Class Name','T','F','T',50,'Name:','Depreciation Class Name','T','F',50,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','lblDepMethod',null,'depreciation_method','Depreciation Method:','Asset Depreciation Class Method','T','F','T',4,'Depreciation Method:','Asset Depreciation Class Method','T','F',4,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','lblDepPeriod',null,null,'Depreciation Period:','Asset Depreciation Period','T','F','F',4,'Depreciation Period:','Asset Depreciation Period','T','F',4,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','lblLife',null,null,'&Life:','Depreciation Class Life','T','F','T',4,'&Life:','Depreciation Class Life','T','F',4,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','lblMonths',null,null,'Months','Depreciation Class Life Months','T','F','F',4,'Months','Depreciation Class Life Months','T','F',4,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','lblYears',null,null,'Years','Depreciation Class Life Years','T','F','F',4,'Years','Depreciation Class Life Years','T','F',4,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','rbMonths',null,null,'Years','Depreciation in Months','T','F','F',4,'Years','Depreciation in Months','T','F',4,null,null,null,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (26,'Label','rbYears',null,null,'Years','Depreciation in Years','T','F','F',4,'Years','Depreciation in Years','T','F',4,null,null,null,2,1,'T','1','1','T');
END
GO

-- form 27
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 27 AND field not like 'usrdef%') = 0 
BEGIN
	PRINT '.. insert form_field_meta for form id: 27';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'List Form Name','Asset',null,null,'Asset','Asset List',null,null,'F',null,'Asset','Asset List',null,null,null,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','asset_contains',null,'child_id','Child Asset(s): ','Select the child assets.','T','F','T',100,'Child Asset(s): ','Select the child assets.','T','F',100,null,'F',null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','asset_part_of',null,'parent_id','Parent Asset: ','Enter the parent asset tag.','T','F','T',100,'Parent Asset: ','Enter the parent asset tag.','T','F',100,null,'T',null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','asset_tag',null,'asset_tag','Asset Tag:','Enter a unique asset tag number.','T','T','T',30,'Asset Tag:','Enter a unique asset tag number.','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','assigned_to',null,null,'Assigned to:','Enter the person to whom this maintenance is assigned.','T','F','T',30,'Assigned to:','Enter the person to whom this maintenance is assigned.','T','F',30,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','cadescription',null,'cadescription','Category:','Enter the category of the asset type.','T','F','T',50,'Category:','Enter the category of the asset type.','T','F',50,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','check_to_audit',null,'','','','F','F','F',1,'','','F','F',1,null,'F',null,1,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','checkout_duration',null,'checkout_duration','Checkout Length:','Enter the default number of days a customer/employee can have this asset checked out. Used to populate the default Check Out time.','T','F','T',4,'Checkout Length:','Enter the default number of days a customer/employee can have this asset checked out. Used to populate the default Check Out time.','T','F',4,null,'T',null,1,1,'T','1','2','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','class_info',null,null,'Class Info:','This view only field displays information about the asset type''s class.','T','F','F',50,'Class Info:','This view only field displays information about the asset type''s class.','T','F',50,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','class_name',null,'class_name','Depreciation Class:','Select the asset''s class.','T','F','F',50,'Depreciation Class:','Select the asset''s class.','T','F',50,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','code',null,'code','Department Code:','Select the Department where the asset is located.','T','F','T',30,'Department Code:','Select the Department where the asset is located.','T','F',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','condition',null,'condition','Condition:','Condition of asset.','T','F','T',30,'Condition:','Condition of asset.','T','F',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','current_depreciation',null,'current_depreciation','Current Depreciation:','Current amount of depreciation.','T','F','T',8,'Current Depreciation:','Current amount of depreciation.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','days_of_week_fri',null,null,'Fri','Select day of week.','T','F','T',7,'Fri','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','days_of_week_mon',null,null,'Mon','Select day of week.','T','F','T',7,'Mon','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','days_of_week_sat',null,null,'Sat','Select day of week.','T','F','T',7,'Sat','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','days_of_week_sun',null,null,'Sun','Select day of week.','T','F','T',7,'Sun','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','days_of_week_thu',null,null,'Thu','Select day of week.','T','F','T',7,'Thu','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','days_of_week_tue',null,null,'Tue','Select day of week.','T','F','T',7,'Tue','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','days_of_week_wed',null,null,'Wed','Select day of week.','T','F','T',7,'Wed','Select day of week.','T','F',7,null,'F',null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','depreciated_value',null,'depreciated_value','Book Value:','Cost of asset less depreciation.','T','F','T',8,'Book Value:','Cost of asset less depreciation.','T','F',8,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','depreciation_begin_date',null,'depreciation_begin_date','Depreciation Begin Date:','Date depreciation of asset started.','T','F','T',8,'Depreciation Begin Date:','Date depreciation of asset started.','T','F',8,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','description',null,'description','Asset Type Description:','Description of Asset Type.','T','F','F',255,'Asset Type Description:','Description of Asset Type.','T','F',255,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','is_checked_out',null,'is_checked_out','Checked Out:','Checked out status.','T','F','T',1,'Checked Out:','Checked out status.','T','F',1,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','item_info',null,null,'Asset Type Information:','Information about the Asset Type.','T','F','F',0,'Asset Type Information:','Information about the Asset Type.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','item_number',null,'item_number','Asset Type:','Type of Asset','T','T','T',30,'Asset Type:','Type of Asset','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','last_depreciation_date',null,'last_depreciation_date','Last Depreciation Date:','Date of last depreciation calculation.','T','F','T',8,'Last Depreciation Date:','Date of last depreciation calculation.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','last_audit_date',null,'last_audit_date','Last Audit Date:','Date of last audit is conducted on this asset.','T','F','T',8,'Last Audit Date:','Date of last audit is conducted on this asset.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','linking_indicator',null,'linking_indicator','Linking','Indicates whether the asset is linked to other assets','T','F','F',1,'Linking','Indicates whether the asset is linked to other assets','T','F',1,null,'F',null,1,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','location',null,'location','Location:','Enter the location of the asset.','T','T','T',30,'Location:','Enter the location of the asset.','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maintain_asset',null,null,'Maintain Asset:','Check if asset needs maintenance.','T','F','T',0,'Maintain Asset:','Check if asset needs maintenance.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maintain_tasks',null,null,'Instructions:','Instructions for performing maintenance.','T','F','T',1000,'Instructions:','Instructions for performing maintenance.','T','F',1000,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maintenance_date',null,null,null,'Maintenance date.','T','F','F',8,null,'Maintenance date.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maintenance_start_dt',null,null,'Maint Start:','Maintenance start date.','T','F','T',8,'Maint Start:','Maintenance start date.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maintenance_start_dy',null,null,'Maint Start:','Maintenance start date.','T','F','T',8,'Maint Start:','Maintenance start date.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maintenance_start_mo',null,null,'Sched: Start:','The schedule will start on or after (according to your settings) this date and run until you turn it off.','T','F','T',8,'Sched. Start:','The schedule will start on or after (according to your settings) this date and run until you turn it off.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maintenance_start_wk',null,null,'Maint Start:','Maintenance start date.','T','F','T',8,'Maint Start:','Maintenance start date.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','manufacturer',null,'manufacturer','Manufacturer:','Select the Manufacturer for this asset.','T','F','F',50,'Manufacturer:','Select the Manufacturer for this asset.','T','F',50,null,'T',null,1,1,'T','1','2','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','model',null,'model','Model:','Enter the Model of this asset.','T','F','F',50,'Model:','Enter the Model of this asset.','T','F',50,null,'T',null,1,1,'T','1','2','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','monthly_date',null,null,'of every','Date of month.','T','F','F',0,'of every','Date of month.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','monthly_day',null,null,'of every','Day of month.','T','F','F',0,'of every','Day of month.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','monthly_days',null,null,'of every','Day of week.','T','F','F',0,'of every','Day of week.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','monthly_type_date',null,null,'Day','Maintenance on specified date in month.','T','F','T',0,'Day','Maintenance on specified date in month.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','monthly_type_day',null,null,null,'Maintenance is scheduled for a specified day in month.','T','F','F',0,null,'Maintenance is scheduled for a specified day in month.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','note_text',null,'note_text','Additional Info:','Enter any Additional information about the asset.','T','F','T',32767,'Additional Info:','Enter any Additional information about the asset.','T','F',32767,null,'F',null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs',null,'occurs','Occurs','Maintenance occurs every','T','F','T',8,'Occurs:','Maintenance occurs every','T','F',8,null,'F',null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs_daily',null,null,'Daily','Maintain daily.','T','F','T',0,'Daily','Maintain daily.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs_date',null,null,'Date','Maintenance on specified date.','T','F','T',0,'Date','Maintenance on specified date.','T','F',0,null,'F',null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs_every_day',null,null,'day(s)','Daily maintenance frequency.','T','F','T',4,'day(s)','Daily maintenance frequency.','T','F',4,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs_every_mo',null,null,'month(s)','Number of months.','T','F','F',0,'month(s)','Number of months.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs_every_week',null,null,'week(s) on:','Weekly maintenance frequency.','T','F','T',4,'week(s) on:','Weekly maintenance frequency.','T','F',4,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs_monthly',null,null,'Monthly','Maintain monthly.','T','F','T',0,'Monthly','Maintain monthly.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','occurs_weekly',null,null,'Weekly','Maintain weekly.','T','F','T',0,'Weekly','Maintain weekly.','T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','parent_tag',null,'parent_tag','Parent Tag:','Asset Tag of Parent Asset','T','F','T',30,'Parent Tag:','Asset Tag of Parent Asset','T','F',30,null,'F',null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','po',null,'po','Purchase Order:','Purchase order number.','T','F','T',30,'Purchase Order:','Purchase order number.','T','F',30,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','purchase_cost',null,'purchase_cost','Purchase Cost:','Asset purchase cost.','T','F','T',8,'Purchase Cost:','Asset purchase cost.','T','F',8,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','purchase_date',null,'purchase_date','Purchase Date:','Date asset was purchased.','T','F','T',8,'Purchase Date:','Date asset was purchased.','T','F',8,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','salvage_value',null,'salvage_value','Salvage Value:','Salvage value of asset.','T','F','T',8,'Salvage Value:','Salvage value of asset.','T','F',8,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','schedule_date',null,'schedule_date','Next Date:','Date of next maintenance.','T','F','T',8,'Next Date:','Date of next maintenance.','T','F',8,null,'F',null,1,1,'0','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','Select',null,null,'Select',null,'T','F','F',0,'Select',null,'T','F',0,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','serial_number',null,'serial_number','Serial No:','Serial number of asset.','T','F','T',30,'Serial No:','Serial number of asset.','T','F',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','should_depreciate',null,'should_depreciate','Depreciate Asset:','Check to depreciate asset.','T','F','T',1,'Depreciate Asset:','Check to depreciate asset.','T','F',1,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','asset_description',null,'asset_description','Asset Description:','The description of this asset.','T','F','T',255,'Asset Description:','The description of this asset.','T','F',255,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','supplier_number',null,'supplier_number','Vendor Number:','Select the Vendor Number for this asset.','T','F','F',30,'Vendor Number:','Select the Vendor Number for this asset.','T','F',30,null,'T',null,1,1,'T','1','2','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','site_name',null,'site_name','Site:','Site where asset is located.','T','T','T',50,'Site:','Site where asset is located.','T','T',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','total_depreciation',null,'total_depreciation','Total Depreciation:','Total amount of depreciation.','T','F','T',8,'Total Depreciation:','Total amount of depreciation.','T','F',8,null,'F',null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','transact_as_whole',null,'transact_as_whole','Transact As Whole','Indicates whether all assets that this one contains are transacted together as a group.','T','F','F',1,'Transact As Whole','Indicates whether all assets that this one contains are transacted together as a group.','T','F',1,null,'T',null,1,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','warranty_begin_date',null,'warranty_begin_date','Warranty Begin:','Enter the warranty start date.','T','F','T',8,'Warranty Begin:','Enter the warranty start date.','T','F',8,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','warranty_end_date',null,'warranty_end_date','Warranty End:','Enter the warranty end date.','T','F','T',8,'Warranty End:','Enter the warranty end date.','T','F',8,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','warranty_provider',null,'warranty_provider','Warranty Provider:','Name of the warranty provider.','T','F','T',50,'Warranty Provider:','Name of the warranty provider.','T','F',50,null,'F',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','lead_time',null,'lead_time','Lead Time:','Time from when an asset is checked in to when it is available for checkout again.','T','N','T',1,'Lead Time:','Time from when an asset is checked in to when it is available for checkout again.','T','N',1,null,'T',null,1,1,'T','1','2','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','linked_reference',null,'linked_reference','Hyperlink:','An online reference or documentation of this asset','T','F','T',1000,'Hyperlink:','An online reference or documentation of this asset','T','F',1000,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','date_acquired',null,'date_acquired','Due Date','Due Date of Checked Out Asset','T','F','T',1000,'Due Date','Due Date of Checked Out Asset','T','F',1000,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','customer_name',null,'customer_name','Customer Name','Customer who Checked Out Asset','T','F','T',1000,'Customer Name','Customer who Checked Out Asset','T','F',1000,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','employee_name',null,'employee_name','Employee Name','Employee who Checked Out Asset','T','F','T',1000,'Employee Name','Employee who Checked Out Asset','T','F',1000,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','customer_number',null,'customer_number','Customer No.','Customer who Checked Out Asset','T','F','T',1000,'Customer No.','Customer who Checked Out Asset','T','F',1000,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','employee_number',null,'employee_number','Employee No.','Employee who Checked Out Asset','T','F','T',1000,'Employee No.','Employee who Checked Out Asset','T','F',1000,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','trans_date',null,'trans_date','Date',null,'T','F','T',1000,'Date',null,'T','F',1000,null,null,null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','done_by',null,'done_by','Done By','Who maintained the asset','T','F','T',1000,'Done By','Who maintained the asset','T','F',1000,null,null,null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','Complete',null,'Complete','Complete',null,'T','F','T',1000,'Complete',null,'T','F',1000,null,null,null,1,1,'F','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','maint_description',null,'maint_description','Description:','Maintenance description.','T','F','T',8,'Description:','Maintenance Description.','T','F',8,null,'F',null,1,1,'F','1','0','T');
END
GO

IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 27 AND field like 'usrdef%') = 0 
BEGIN
	PRINT '.. insert form_field_meta for form id: 27  usrdef%';
	
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (27,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,'T',null,1,1,'T','1','1','T');
END
GO

-- form 28
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 28) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 28';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (28,'Label','code',null,'code','&Department Code:','Department where this asset is located.','T','T','T',30,'&Department Code:','Department where this asset is located.','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (28,'List Form Name','Department',null,' ','Department','Department List',null,null,'F',null,'Department','Department List',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (28,'Label','name',null,'name','Department &Name:','Name of Department','T','T','T',255,'Department &Name:','Name of Department','T','T',255,null,'T',null,1,1,'T','1','1','T');
END
ELSE
	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 28 and control = 'Label' and (field = 'code' or field = 'name')  
GO

-- form 29
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 29) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 29';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','first_name',null,'first_name','First Name:','','T','F','F',50,'First Name:','','T','F',50,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','last_name',null,'last_name','Last Name:',null,'T','F','F',50,'Last Name:',null,'T','F',50,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','title',null,'title','Title:',null,'T','F','F',50,'Title:',null,'T','F',50,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','date_updated',null,'date_updated','Last Updated: ',null,'T','F','F',50,'Last Updated: ',null,'T','F',50,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','department',null,'department','Department: ',null,'T','F','F',50,'Department: ',null,'T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','email',null,'email','Email: ',null,'T','F','F',50,'Email: ',null,'T','F',50,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','group_name',null,'group_name','Group: ',null,'T','F','F',50,'Group: ',null,'T','F',50,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','group_description',null,'group_description','Group Description: ',null,'T','F','F',500,'Group Description: ',null,'T','F',500,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','manager',null,'manager','Manager: ',null,'T','F','F',50,'Manager: ',null,'T','F',50,null,null,null,1,1,'T','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','user_logon',null,'user_logon','User Name:',null,'T','F','F',50,'User Name:',null,'T','F',50,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','status',null,'status','Status:',null,'T','F','F',50,'Status:',null,'T','F',50,null,null,null,1,1,'T','1','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (29,'Label','changed_password',null,'changed_password','Windows Authentication Account?','Indicates whether this account is automatically created in Windows Authentication Mode','T','F','F',50,'Windows Authentication Account?','Indicates whether this account is automatically created in Windows Authentication Mode','T','F',50,null,null,null,1,1,'T','1','0','T');
END
GO

-- form 30
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 30) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 30';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','address1',null,'address1','Address &1:','Enter this employee''s Address Line 1.','T','F','T',100,'Address &1:','Enter this employee''s Address Line 1.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','address2',null,'address2','Address &2:','Enter this employee''s Address Line 2.','T','F','T',100,'Address &2:','Enter this employee''s Address Line 2.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','city',null,'city','C&ity:','Enter the City in which this employee is located.','T','F','T',50,'C&ity:','Enter the City in which this employee is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','code',null,'code','Department:','Enter the employee''s department.','T','F','T',30,'Department:','Enter the employee''s department.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','country',null,'country','Count&ry:','Enter the country in which this employee resides.','T','F','T',50,'Count&ry:','Enter the country in which this employee resides.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','email',null,'email','Email:','Enter the employee''s email address.','T','F','T',250,'Email:','Enter the employee''s email address.','T','F',250,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'List Form Name','Employee',null,null,'Employee','Employee List',null,null,'F',null,'Employee','Employee List',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','employee_id',null,'employee_id','Employee:','Enter the employee ID.  The employee ID must be unique.','T','F','F',10,'Employee:','Enter the employee ID.  The employee ID must be unique.','T','F',10,null,null,null,1,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','employee_number',null,'employee_number','Employee No:','Enter the employee number.  The employee number must be unique.','T','T','T',30,'Employee No:','Enter the employee number.  The employee number must be unique.','T','T',30,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','extension',null,'extension','Ext:','Enter the employee''s phone extension.','T','F','T',10,'Ext:','Enter the employee''s phone extension.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','first_name',null,'first_name','First Name:','Enter the employee''s first name.','T','T','T',50,'First Name:','Enter the employee''s first name.','T','T',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','last_name',null,'last_name','Last Name:','Enter the employee''s last name.','T','T','T',50,'Last Name:','Enter the employee''s last name.','T','T',50,null,'T',null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','mail_stop',null,'mail_stop','&Mail Stop:','This the employee''s mail stop.','T','F','T',20,'&Mail Stop:','This the employee''s mail stop.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','manager_id',null,'manager_id','Manager:','Enter the employee''s manager.','T','F','T',100,'Manager:','Enter the employee''s manager.','T','F',100,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','manager_number',null,'manager_number','Manager No:','Enter the Manager No of this employee.','T','F','F',30,'Manager No:','Enter the Manager No of this employee.','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','note_text',null,'note_text','&Notes:','Enter any notes about this Employee.','T','F','T',255,'&Notes:','Enter any notes about this Employee.','T','F',255,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','phone_number',null,'phone_number','Phone:','Enter the employee''s phone number.','T','F','T',20,'Phone:','Enter the employee''s phone number.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','phone_type',null,'record_type','Phone Type:','Enter type of phone (business, cell,etc)for employee.','T','F','T',50,'Phone Type:','Enter type of phone (business, cell,etc)for employee.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','postal_code',null,'postal_code','&Postal Code:','Enter this employee''s postal code.','T','F','T',10,'&Postal Code:','Enter this employee''s postal code.','T','F',10,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','record_type',null,'record_type','Address &Type:','Enter an address for this employee and select an address type (business, home).','T','T','F',50,'Address &Type:','Enter an address for this employee and select an address type (business, home).','T','T',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','state',null,'state','Stat&e:','Enter the state in which the employee is located.','T','F','T',50,'Stat&e:','Enter the state in which the employee is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','title',null,'title','Title:','Enter the employee''s title.','T','F','T',50,'Title:','Enter the employee''s title.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1:','Enter a custom date.','F','F','T',20,'Custom &Date 1:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2:','Enter a custom date.','F','F','T',20,'Custom D&ate 2:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3:','Enter a custom date.','F','F','T',20,'Custom Da&te 3:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4:','Enter a custom date.','F','F','T',20,'Custom Dat&e 4:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5:','Enter a custom date.','F','F','T',20,'Custom Date &5:','Enter a custom date.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1:','Enter a custom number.','F','F','T',20,'Custom &Number 1:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2:','Enter a custom number.','F','F','T',20,'Custom N&umber 2:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3:','Enter a custom number.','F','F','T',20,'Custom Nu&mber 3:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4:','Enter a custom number.','F','F','T',20,'Custom Num&ber 4:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5:','Enter a custom number.','F','F','T',20,'Custom Numbe&r 5:','Enter a custom number.','F','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1:','Enter custom text.','F','F','T',100,'Custom Text &1:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext10',null,'usrdeftext10','Custom Text 1&0:','Enter custom text.','F','F','T',100,'Custom Text 1&0:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2:','Enter custom text.','F','F','T',100,'Custom Text &2:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3:','Enter custom text.','F','F','T',100,'Custom Text &3:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4:','Enter custom text.','F','F','T',100,'Custom Text &4:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5:','Enter custom text.','F','F','T',100,'Custom Text &5:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6:','Enter custom text.','F','F','T',100,'Custom Text &6:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7:','Enter custom text.','F','F','T',100,'Custom Text &7:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8:','Enter custom text.','F','F','T',100,'Custom Text &8:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (30,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9:','Enter custom text.','F','F','T',100,'Custom Text &9:','Enter custom text.','F','F',100,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN
	UPDATE form_field_meta SET db_field = 'code' WHERE form_id = 30 and field = 'code'
	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 30 and control = 'Label' and field = 'manager_number') = 0
		insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (30,'Label','manager_number',null,'manager_number','Manager No:',NULL,'T','F','F',30,'Manager No:',NULL,'T','F',30,null,null,null,1,1,'T','1','1');

	UPDATE form_field_meta SET send_to_palm = 'T' WHERE form_id = 30 and control = 'Label' and (field = 'employee_number' or field = 'first_name' or field = 'last_name')  
END
GO

-- form 32
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 32 AND field not like 'usrdef%') = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 32';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','asset_count',null,'asset_count','Asset Count','The number of assets associated with this contract.','T','F','T',15,'Asset Count','The number of assets associated with this contract.','T','F',15,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','begin_date',null,'begin_date','Begin Date','Enter the date this contract was established.','T','F','F',20,'Begin Date','Enter the date this contract was established.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','contract_description',null,'contract_description','Description','Enter a short description of this contract.','T','F','T',1000,'Description','Enter a short description of this contract.','T','F',1000,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','contract_number',null,'contract_number','Contract Number','The number used to identify this contract. (Can be alphanumeric)','T','T','T',255,'Contract Number','The number used to identify this contract. (Can be alphanumeric)','T','T',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'List Form Name','Contracts',null,null,'Contracts','**','T','F','T',0,'Contracts','**','T','F',0,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','end_date',null,'end_date','End Date','The date this contract expires.','T','F','F',20,'End Date','The date this contract expires.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','internal_contact',null,'internal_contact','Internal Contact','The person in charge of this contract.','T','F','T',255,'Internal Contact','The person in charge of this contract.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','is_software',null,'is_software','Software','If this contract represents a software contract or license agrement, check this box.','T','F','T',2,'Software','If this contract represents a software contract or license agrement, check this box.','T','F',2,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','no_end_date',null,'no_end_date','No End Date','If the contract does not expire, check this box.','F','F','F',2,'No End Date','If the contract does not expire, check this box.','F','F',2,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','num_licenses',null,'num_licenses','Licenses','The number of licenses represented by this contract.','T','F','T',20,'Licenses','The number of licenses represented by this contract.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','vendor_id',null,'vendor_id','Vendor ID','The vendor id that sold or maintains this contract.','F','F','T',20,'Vendor ID','The vendor id that sold or maintains this contract.','F','F',20,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','vendor_name',null,'vendor_name','Vendor Name','The name of the vendor that sold or  maintains this contract.','T','F','T',255,'Vendor Name','The name of the vendor that sold or  maintains this contract.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','vendor_number',null,'vendor_number','Vendor Number','The number used to identify the vendor that sold or maintains this contract.','T','F','T',30,'Vendor Number','The number used to identify the vendor that sold or maintains this contract.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','vendor_combo',null,'vendor_combo','Vendor','The name of the vendor that sold or  maintains this contract.','T','F','T',255,'Vendor','The name of the vendor that sold or  maintains this contract.','T','F',255,null,null,null,1,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','linked_reference',null,'linked_reference','Hyperlink','An online reference or documentation of this contract','T','F','T',1000,'Hyperlink','An online reference or documentation of this contract','T','F',1000,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','cost',null,'cost','Cost','Enter the cost of this contract','T','F','T',200,'Cost','Enter the cost of this contract','T','F',200,null,null,null,1,1,'T','1','1','T');
END

IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 32 AND field like 'usrdef%') = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 32 usrdef%';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefdate1',null,'usrdefdate1','Custom &Date 1',null,'F','F','T',null,'Custom &Date 1',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefdate2',null,'usrdefdate2','Custom D&ate 2',null,'F','F','T',null,'Custom D&ate 2',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefdate3',null,'usrdefdate3','Custom Da&te 3',null,'F','F','T',null,'Custom Da&te 3',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefdate4',null,'usrdefdate4','Custom Dat&e 4',null,'F','F','T',null,'Custom Dat&e 4',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefdate5',null,'usrdefdate5','Custom Date &5',null,'F','F','T',null,'Custom Date &5',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefnumber1',null,'usrdefnumber1','Custom &Number 1',null,'F','F','T',null,'Custom &Number 1',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefnumber2',null,'usrdefnumber2','Custom N&umber 2',null,'F','F','T',null,'Custom N&umber 2',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefnumber3',null,'usrdefnumber3','Custom Nu&mber 3',null,'F','F','T',null,'Custom Nu&mber 3',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefnumber4',null,'usrdefnumber4','Custom Num&ber 4',null,'F','F','T',null,'Custom Num&ber 4',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdefnumber5',null,'usrdefnumber5','Custom Numbe&r 5',null,'F','F','T',null,'Custom Numbe&r 5',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext1',null,'usrdeftext1','Custom Text &1',null,'F','F','T',null,'Custom Text &1',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext10',null,'usrdeftext10','Custom Text &10',null,'F','F','T',null,'Custom Text &10',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext2',null,'usrdeftext2','Custom Text &2',null,'F','F','T',null,'Custom Text &2',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext3',null,'usrdeftext3','Custom Text &3',null,'F','F','T',null,'Custom Text &3',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext4',null,'usrdeftext4','Custom Text &4',null,'F','F','T',null,'Custom Text &4',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext5',null,'usrdeftext5','Custom Text &5',null,'F','F','T',null,'Custom Text &5',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext6',null,'usrdeftext6','Custom Text &6',null,'F','F','T',null,'Custom Text &6',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext7',null,'usrdeftext7','Custom Text &7',null,'F','F','T',null,'Custom Text &7',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext8',null,'usrdeftext8','Custom Text &8',null,'F','F','T',null,'Custom Text &8',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (32,'Label','usrdeftext9',null,'usrdeftext9','Custom Text &9',null,'F','F','T',null,'Custom Text &9',null,'F','F',null,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 38
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 38) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 38';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'List Form Name','AssetTransactions',null,null,'Transactions','Transaction List',null,null,'F',null,'Transactions','Transaction List',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','transaction_id',null,'transaction_id','Trans ID','Transaction ID','T','F','T',100,'Trans ID','Transaction ID','T','F',100,null,null,null,1,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','trans_description',null,'trans_description','Trans Type','Transaction Type','T','F','T',90,'Trans Type','Transaction Type','T','F',90,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','asset_tag',null,'asset_tag','Asset Tag','Asset Tag','T','F','T',100,'Asset Tag','Asset Tag','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','location_code',null,'location_code','Location','Location','T','F','T',100,'Location','Location','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','other_location_code',null,'other_location_code','Other Location','Other Location','T','F','T',100,'Other Location','Other Location','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','user_logon',null,'user_logon','User','User','T','F','T',100,'User','User','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','code',null,'code','Department','Department Code','T','F','T',120,'Department','Department Code','T','F',120,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','reason',null,'reason','Reason','Reason Description','T','F','T',100,'Reason','Reason','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','entry_date',null,'entry_date','Entry Date','Entry Date','T','F','T',100,'Entry Date','Entry Date','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','trans_date',null,'trans_date','Trans Date','Transaction Date','T','F','T',100,'Trans Date','Transaction Date','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','date_acquired',null,'date_acquired','Date Acquired','Date Acquired','T','F','T',100,'Date Acquired','Date Acquired','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','maint_date',null,'maint_date','Maint Date','Maintenance Date','T','F','T',100,'Maint Date','Maintenance Date','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','maint_complete',null,'maint_complete','Maint Complete','Maintenance Complete Date','T','F','T',120,'Maint Complete','Maintenance Complete Date','T','F',120,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','condition',null,'condition','Condition','Condition','T','F','T',100,'Condition','Condition','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','cost',null,'cost','Cost','Cost','T','F','T',80,'Cost','Cost','T','F',80,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','customer_name',null,'customer_name','Customer Name','Customer Name','T','F','T',100,'Customer Name','Customer Name','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','employee_name',null,'employee_name','Employee Name','Employee Name','T','F','T',100,'Employee Name','Employee Name','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','customer_number',null,'customer_number','Customer No.','Customer Number','T','F','T',100,'Customer No.','Customer Number','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','employee_number',null,'employee_number','Employee No.','Employee Number','T','F','T',100,'Employee No.','Employee Number','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','supplier',null,'supplier','Supplier','Supplier','T','F','T',100,'Supplier','Supplier','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','serial_number',null,'serial_number','Serial #','Serial Number','T','F','T',100,'Serial #','Serial Number','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (38,'Label','record_source',null,'record_source','Record Source','Record Source','T','F','T',100,'Record Source','Record Source','T','F',100,null,null,null,1,1,'T','1','1','T');
END
GO

-- form 39
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 39) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 39';

insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','approver',null,'approver','Approver:',null,'T','F','T',50,'Approver:',null,'T','F',50,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','created_by',null,'created_by','Created By:',null,'T','F','T',50,'Created By:',null,'T','F',50,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','customer_name',null,'customer_name','Customer Name:','Select customer.','T','F','T',50,'Customer Name:','Select customer.','T','F',50,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','customer_number',null,'customer_number','Customer No:','Select customer.','T','F','T',30,'Customer No:','Select customer.','T','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','employee_name',null,'employee_name','Employee Name:','Select employee.','T','F','T',100,'Employee Name:','Select employee.','T','F',100,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','employee_number',null,'employee_number','Employee No:','Select employee.','T','F','T',30,'Employee No:','Select employee.','T','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','for',null,'for','For: ','Reserved For','T','F','F',10,'For: ','Reserved For','T','F',10,null,'F',null,1,1,'F','F','F','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','notify_change',null,'notify_change','Notify of Status Change:','Check to be notified of a status change in this reservation.','T','F','T',10,'Notify of Status Change:','Check to be notified of a status change in this reservation.','T','F',10,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','reference_number',null,'reference_number','Reference No:','Enter reference number.','T','F','T',50,'Reference No:','Enter reference number.','T','F',50,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','request_status_text',null,'request_status_text','Request Status:','Request status of reservation.','T','F','T',30,'Request Status:','Request status of reservation.','T','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','reservation_id',null,'reservation_id','Reservation ID',null,'T','F','F',100,'Reservation ID',null,'T','F',100,null,null,null,1,1,'F','0','0','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','reservation_number',null,'reservation_number','Reservation No:','Enter reservation number.','T','T','T',50,'Reservation No:','Enter reservation number.','T','T',50,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'List Form Name','Reservations',null,null,'Reservations','Manage Reservations',null,null,'F',null,'Reservations','Manage Reservations',null,null,null,null,null,null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','urgency_text',null,'urgency_text','Urgency:','Select urgency.','T','F','T',30,'Urgency:','Select urgency.','T','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','notes',null,'notes','Notes:','Enter notes here.','T','F','T',1000,'Notes:','Enter notes here.','T','F',1000,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (39,'Label','earliest_due',null,'earliest_due','Earliest Due:','Earliest Reserved Asset','T','F','F',100,'Earliest Due:','Earliest Reserved Asset','T','F',100,null,'F',null,1,1,'T','1','0','T');
END
GO

-- form 40
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 40) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 40';

insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','asset_description',null,'asset_description','Asset Description','Enter asset description.','T','F','F',255,'Asset Description','Enter asset description.','T','F',255,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','asset_id',null,'asset_id','asset_id',null,'F','F','F',30,'asset_id',null,'F','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','asset_tag',null,'asset_tag','Asset Tag','Enter asset tag or select one from the list.','T','F','F',30,'Asset Tag','Enter asset tag or select one from the list.','T','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','asset_type_id',null,'asset_type_id','asset_type_id',null,'F','F','F',30,'asset_type_id',null,'F','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','assigned_asset_id',null,'assigned_asset_id','assigned_asset_id',null,'F','F','F',30,'assigned_asset_id',null,'F','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','detail_id',null,'detail_id','detail_id',null,'F','F','F',30,'detail_id',null,'F','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','item_description',null,'item_description','Asset Type','Asset type description','T','F','F',255,'Asset Type','Asset type description','T','F',255,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','item_number',null,'item_number','Asset Type:','Enter asset type or select from list.','T','F','F',31,'Asset Type:','Enter asset type or select from list.','T','F',31,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','last_updated',null,'last_updated','Last Updated','Last Updated','T','F','F',30,'Last Updated','Last Updated','T','F',30,null,'F',1,1,1,'F','1','0','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','quantity',null,'quantity','Quantity','Quantity','T','F','F',30,'Quantity','Quantity','T','F',30,null,'F',null,1,1,'F','1','0','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','ready',null,'ready',' ','Ready for Checkout','T','F','F',30,' ','Ready for Checkout','T','F',30,null,'F',null,1,1,'F','1','0','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','reference_number',null,'reference_number','Reference Number','Reference number','F','F','F',100,'Reference Number','Reference number','F','F',100,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','request_status_id',null,'request_status_id','request_status_id',null,'F','F','F',30,'request_status_id',null,'F','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','reservation_end',null,'reservation_end','End','Reservation ends on this date and time','T','F','F',30,'End','Reservation ends on this date and time','T','F',30,null,'F',null,1,1,'F','1','0','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','reservation_id',null,'reservation_id','reservation_id',null,'F','F','F',30,'reservation_id',null,'F','F',30,null,'F',null,1,1,'T','1','1','T');
insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (40,'Label','reservation_start',null,'reservation_start','Start','Reservation starts on this date and time','T','F','F',30,'Start','Reservation starts on this date and time','T','F',30,null,'F',null,1,1,'F','1','0','T');
END
GO

-- form 100
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 100) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 100';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin Advanced Find','FindAdvanced','17','Advanced Find',null,'T',null,'T',null,'Advanced Find',null,'T',null,null,7,'F',101,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin Find','Find','7','Find',null,'T',null,'F',null,'Find',null,'T',null,null,2,'F',1,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New','New','8','New',null,'T',null,'F',null,'New',null,'T',null,null,2,'T',3,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Asset','New','18','Admin New Asset',null,'T',null,'T',null,'Admin New Asset',null,'T',null,null,8,'T',200,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Class','Class','136','Admin New Class',null,'T',null,'T',null,'Admin New Class',null,'T',null,null,8,'T',208,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Customer','New','19','Admin New Customer',null,'T',null,'T',null,'Admin New Customer',null,'T',null,null,8,'T',201,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Department','Dempartment','20','Admin New Department',null,'T',null,'T',null,'Admin New Department',null,'T',null,null,8,'T',202,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Employee','Employee','23','Admin New Employee',null,'T',null,'T',null,'Admin New Employee',null,'T',null,null,8,'T',205,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Location','New_Location','21','Admin New Location',null,'T',null,'T',null,'Admin New Location',null,'T',null,null,8,'T',203,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Manufacturer','New_Manufacturer','24','Admin New Manufacturer',null,'T',null,'T',null,'Admin New Manufacturer',null,'T',null,null,8,'T',207,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin New Site','New_Site','22','Admin New Site',null,'T',null,'T',null,'Admin New Site',null,'T',null,null,8,'T',204,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Admin Simple Find','Find','16','Simple Find',null,'T',null,'T',null,'Simple Find',null,'T',null,null,7,'F',100,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Administration',null,'2','Administration','Click to view the Administration menu','T',null,'F',null,'Administration','Click to view the Administration menu','T',null,null,0,'T',3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','App New',null,'170','New','Click to view the New menu','T',null,'T',null,'New','Click to view the New menu','T',null,null,0,'T',7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Advanced Find','FindAdvanced','53','Advanced Find','Click to launch the advanced find','T',null,'T',null,'Advanced Find','Click to launch the advanced find','T',null,null,44,'F',101,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Find','Find','44','Find','Click to find information','T',null,'F',null,'Find','Click to find information','T',null,null,1,'F',10,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Management',null,'1','Asset Management','Click to view the Asset Management menu','T',null,'F',null,'Asset Management','Click to view the Asset Management menu','T',null,null,0,'T',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Mgmt List','Lists_Asset','201','List Assets','Click to view the Asset List.','T',null,'T',null,'List Assets','Click to view the Asset List.','T',null,null,1,'T',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Mgmt New','Asset','202','New Asset','Create a new asset','T',null,'T',null,'New Asset','Create a new asset','T',null,null,1,'T',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Asset','Asset','54','Asset','Click to create a new asset','T',null,'T',null,'Asset','Click to create a new asset','T',null,null,170,'T',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Class','Class','131','Depreciation Class','Click to create a new depreciation class','T',null,'T',null,'Depreciation Class','Click to create a new depreciation class','T',null,null,170,'T',6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Contract','Contract','83','Contract/License','Click to create a new contract/software license','T',null,'T',null,'Contract/License','Click to create a new contract/software license','T',null,null,170,'T',3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Customer','New','55','Customer','Click to create a new customer','T',null,'T',null,'Customer','Click to create a new customer','T',null,null,170,'T',4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Department','Department','56','Department','Click to create a new department','T',null,'T',null,'Department','Click to create a new department','T',null,null,170,'T',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Employee','Employee','59','Employee','Click to create a new employee','T',null,'T',null,'Employee','Click to create a new employee','T',null,null,170,'T',7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Item','Item','61','Asset Type','Click to create a new asset type','T',null,'T',null,'Asset Type','Click to create a new asset type','T',null,null,170,'T',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Location','New_Location','57','Location','Click to create a new location','T',null,'T',null,'Location','Click to create a new location','T',null,null,170,'T',8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Manufacturer','New_Manufacturer','60','Manufacturer','Click to create a new manufacturer','T',null,'T',null,'Manufacturer','Click to create a new manufacturer','T',null,null,170,'T',9,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Site','New_Site','58','Site','Click to create a new site','T',null,'T',null,'Site','Click to create a new site','T',null,null,170,'T',10,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset New Supplier','Supplier','82','Vendor','Click to create a new vendor','T',null,'T',null,'Vendor','Click to create a new vendor','T',null,null,170,'T',11,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Reports','Reports_64','85','Asset Reports',null,'T',null,'T',null,'Asset Reports',null,'T',null,null,4,'T',1,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Simple Find','Find','52','Simple Find','Click to launch the simple find','T',null,'F',null,'Simple Find','Click to launch the simple find','T',null,null,44,'F',100,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'List Form Name','asset_transactions',null,null,'Asset Transactions',null,null,null,'T',null,'Asset Transactions',null,null,null,null,null,null,null,1,1,'0','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Assets by Employee','Reports','92','Assets by Employee',null,'T',null,'T',null,'Assets by Employee',null,'T',null,null,4,'T',102,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Assets by Location','Reports','91','Assets by Location',null,'T',null,'T',null,'Assets by Location',null,'T',null,null,4,'T',101,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Assets by Serial Number','Reports','93','Assets by Serial Number',null,'T',null,'T',null,'Assets by Serial Number',null,'T',null,null,4,'T',103,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Assets by Site','Reports','90','Assets by Site',null,'T',null,'T',null,'Assets by Site',null,'T',null,null,4,'T',100,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Audit','Audit','51','Audit','Click to audit/verify an assets location','T',null,'T',null,'Audit','Click to audit/verify an assets location','T',null,null,1,'F',6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Audit History','Reports','96','Audit History',null,'T',null,'F',null,'Audit History',null,'T',null,null,4,'T',300,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Audit Reports','Reports','87','Audit Reports',null,'T',null,'T',null,'Audit Reports',null,'T',null,null,4,'T',3,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Audit Unreconciled','Reports','97','Audit Unreconciled',null,'T',null,'T',null,'Audit Unreconciled',null,'T',null,null,4,'T',301,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Backup','Backup','122','Backup','Click to backup the MobileAsset database','T',null,'F',null,'Backup','Click to backup the MobileAsset database','T',null,null,6,'F',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Calculate Depreciation','Depreciate','200','Calculate Depreciation','Click to calculate depreciation for assets','T',null,'T',null,'Calculate Depreciation','Click to calculate depreciation for assets','T',null,null,1,'F',9,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Change Password','ChangePassword','126','Change Password','Click to change password','T',null,'T',null,'Change Password','Click to change password','T',null,null,12,'T',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-In','CheckIn','49','Check-In','Click to check-in a previously checked-out asset','T',null,'T',null,'Check-In','Click to check-in a previously checked-out asset','T',null,null,1,'T',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Transfer Check-Out','Transfer','49','Transfer Check-Out','Click to transfer asset or modify a check-out asset','T',null,'T',null,'Transfer Check-Out','Click to transfer asset or modify a check-out asset','T',null,null,1,'T',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-In By Asset','CheckIn','69','Check-In By Asset Tag',null,'T',null,'T',null,'Check-In By Asset Tag',null,'T',null,null,49,'T',1,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-In By Customer','CheckIn','70','Check-In By Customer',null,'T',null,'T',null,'Check-In By Customer',null,'T',null,null,49,'T',2,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-In By Employee','CheckIn','71','Check-In By Employee',null,'T',null,'T',null,'Check-In By Employee',null,'T',null,null,49,'T',3,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-Out','CheckOut','50','Check-Out','Click to check-out an asset to an employee or customer','T',null,'T',null,'Check-Out','Click to check-out an asset to an employee or customer','T',null,null,1,'T',4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-Out Reports','Reports','86','Check-Out Reports',null,'T',null,'T',null,'Check-Out Reports',null,'T',null,null,4,'T',2,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-Out To Customer','CheckOut','72','Check-Out To Customer',null,'T',null,'T',null,'Check-Out To Customer',null,'T',null,null,50,'T',1,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Check-Out To Employee','CheckOut','73','Check-Out To Employee',null,'T',null,'T',null,'Check-Out To Employee',null,'T',null,null,50,'T',2,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Checked Out By Customer','Reports','94','Checked Out By Customer',null,'T',null,'T',null,'Checked Out By Customer',null,'T',null,null,4,'T',200,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Checked Out Overdue','Reports','95','Checked Out Overdue',null,'T',null,'T',null,'Checked Out Overdue',null,'T',null,null,4,'T',201,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Company Information','Company_Info','9','Company Information','Click to edit your company information','T',null,'T',null,'Company Information','Click to edit your company information','T',null,null,2,'F',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Customize Names','Customize_Names','13','Customize Names','Click to change the names of menus','T',null,'T',null,'Customize Names','Click to change the names of menus','T',null,null,2,'F',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Database Management','Database_Management','6','Database Management','Click to  backup or restore a MobileAsset database','T',null,'F',null,'Database Management','Click to  backup or restore a MobileAsset database','T',null,null,2,'F',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Dispose','Dispose','47','Dispose','Click to dispose/remove an asset','T',null,'T',null,'Dispose','Click to dispose/remove an asset','T',null,null,1,'T',7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Dispose By Location','Dispose','62','Dispose By Location',null,'T',null,'T',null,'Dispose By Location',null,'T',null,null,47,'T',400,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Dispose By Serial Number','Dispose','63','Dispose By Serial Number',null,'T',null,'T',null,'Dispose By Serial Number',null,'T',null,null,47,'T',401,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Dispose By Site','Dispose','64','Dispose By Site',null,'T',null,'T',null,'Dispose By Site',null,'T',null,null,47,'T',402,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'List Form Name','employees',null,null,'Employees','Employee List',null,null,'F',null,'Employees','Employee List',null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Export Wizard','Export_Wizard','37','Export Wizard','Click to export data to an external file','T',null,'F',null,'Export Wizard','Click to export data to an external file','T',null,null,11,'F',501,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Import / Export Wizard','ImportExport_Wizard','11','Import / Export Wizard','Click to import or export data FROM or to an external file','T',null,'T',null,'Import / Export Wizard','Click to import or export data FROM or to an external file','T',null,null,2,'F',4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Import Wizard','Import_Wizard','36','Import Wizard','Click to import data FROM an external file','T',null,'F',null,'Import Wizard','Click to import data FROM an external file','T',null,null,11,'F',500,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Labels',null,'3','Labels','Click to view Labels','T',null,'F',null,'Labels','Click to view Labels','T',null,null,0,'F',4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','License Management','License_Management','14','License Management','Click to manage user and mobile device licenses','T',null,'T',null,'License Management','Click to manage user and mobile device licenses','T',null,null,2,'F',8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Assets','Lists_Asset','26','Assets','Click to view assets','T',null,'T',null,'Assets','Click to view assets','T',null,null,10,'T',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Classes','Lists_Class','135','Depreciation Classes','Click to view classes','T',null,'T',null,'Depreciation Classes','Click to view classes','T',null,null,10,'T',6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Contracts','Lists_Contract','35','Contracts/Licenses','Click to view contracts/software licenses','T',null,'T',null,'Contracts/Licenses','Click to view contracts/software licenses','T',null,null,10,'T',3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Customers','Lists_Customer','28','Customers','Click to view customers','T',null,'T',null,'Customers','Click to view customers','T',null,null,10,'T',4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Departments','Lists_Department','29','Departments','Click to view departments','T',null,'T',null,'Departments','Click to view departments','T',null,null,10,'T',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Employees','Lists_Employee','32','Employees','Click to view employees','T',null,'T',null,'Employees','Click to view employees','T',null,null,10,'T',7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Item','Lists_AssetType','137','Asset Types','Click to view asset types','T',null,'T',null,'Asset Types','Click to view asset types','T',null,null,10,'T',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Locations','Lists_Location','30','Locations','Click to view locations','T',null,'T',null,'Locations','Click to view locations','T',null,null,10,'T',8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Manufacturers','Lists_Manuf','34','Manufacturers','Click to view manufacturers','T',null,'T',null,'Manufacturers','Click to view manufacturers','T',null,null,10,'T',9,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Sites','Lists_Site','31','Sites','Click to view sites','T',null,'T',null,'Sites','Click to view sites','T',null,null,10,'T',10,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Suppliers','Lists_Vendor','33','Vendors','Click to view vendors','T',null,'T',null,'Vendors','Click to view vendors','T',null,null,10,'T',12,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','List Transactions','Lists_Transaction','350','Transactions','Click to view transactions','T',null,'T',null,'Transactions','Click to view transactions','T',null,null,10,'T',11,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Lists',null,'10','List Forms','Click to view lists of the data in your system.','T','T','F',30,'List Forms','Click to view lists of the data in your system.','T','T',30,0,'T',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Location By Company','Reports','99','Location By Company',null,'T',null,'T',null,'Location By Company',null,'T',null,null,4,'T',401,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Location By Site','Reports','98','Location By Site',null,'T',null,'T',null,'Location By Site',null,'T',null,null,4,'T',400,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Location Reports','Reports','88','Location Reports',null,'T',null,'T',null,'Location Reports',null,'T',null,null,4,'T',4,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Login As Different User','LoginDiffUser','127','Login As Different User','Click to logoff of MobileAsset','T',null,'T',null,'Login As Different User','Click to logoff of MobileAsset','T',null,null,12,'F',6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Maintenance','Maintenance','160','Maintenance Entry','Click to enter maintenance for assets','T',null,'T',null,'Maintenance Entry','Click to enter maintenance for assets','T',null,null,1,'T',8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Mobe By Asset Number','Move','67','Move By Site',null,'T',null,'T',null,'Move By Site',null,'T',null,null,48,'T',1,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Mobe By Department','Move','67','Move By Cost Center',null,'T',null,'T',null,'Move By Cost Center',null,'T',null,null,48,'T',4,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Mobility',null,'5','Mobility','Click to view the Mobility menu','T',null,'F',null,'Mobility','Click to view the Mobility menu','T',null,null,0,'F',6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Move','Move','48','Move','Click to move an asset FROM one location to another','T',null,'T',null,'Move','Click to move an asset FROM one location to another','T',null,null,1,'T',3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Move By Location','Move','65','Move By Location',null,'T',null,'T',null,'Move By Location',null,'T',null,null,48,'T',2,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Move By Serial Number','Move','66','Move By Serial Number',null,'T',null,'T',null,'Move By Serial Number',null,'T',null,null,48,'T',3,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Options','Options','15','Options','Click to set MobileAsset options','T',null,'T',null,'Options','Click to set MobileAsset options','T',null,null,2,'T',6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','PDA','PDA','105','Palm PDA','Click to view the palm device menu','T',null,'T',null,'Palm PDA','Click to view the palm device menu','T',null,null,5,'F',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','PDA Create Database','PDACreate','111','Create PDA Database','Click to create a palm database','T',null,'T',null,'Create PDA Database','Click to create a palm database','T',null,null,105,'F',102,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','PDA Customize PDA Interface','PDA_Customize','110','Customize PDA Interface',null,'T',null,'T',null,'Customize PDA Interface',null,'T',null,null,105,'F',101,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','PDA PDA to PC','PDATo','113','PDA PDA to PC',null,'T',null,'T',null,'PDA PDA to PC',null,'T',null,null,105,'F',104,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','PDA Setup','PDA_Setup','109','PDA Setup','Click to setup a palm device','T',null,'T',null,'PDA Setup','Click to setup a palm device','T',null,null,105,'F',100,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','PDA Synchronize','PDA_Synchronize','112','Synchronize PDA','Click to  synchronize the palm device with the pc','T',null,'T',null,'Synchronize PDA','Click to  synchronize the palm device with the pc','T',null,null,105,'F',103,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Pocket PC','PKPC','140','Windows Mobile / CE','Click to view the Windows Mobile / CE device menu','T',null,'T',null,'Windows Mobile / CE','Click to view the Windows Mobile / CE device menu','T',null,null,5,'F',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Pocket PC Create Database','PKPC_Create','143','Create Windows Mobile / CE Database','Click to create a Windows Mobile / CE database','T',null,'T',null,'Create Windows Mobile / CE Database','Click to create a Windows Mobile / CE database','T',null,null,140,'F',102,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Pocket PC Customize Labels','PKPC_Customize','142','Customize Windows Mobile / CE Interface',null,'T',null,'T',null,'Customize Windows Mobile / CE Interface',null,'T',null,null,140,'F',101,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Pocket PC Setup','PKPC_Setup','141','Windows Mobile / CE Setup','Click to setup a Windows Mobile / CE device','T',null,'T',null,'Windows Mobile / CE Setup','Click to setup a Windows Mobile / CE device','T',null,null,140,'F',100,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Pocket PC Synchronize','PKPC_Synchronize','144','Synchronize Windows Mobile / CE','Click to synchronize the Windows Mobile / CE device with the pc','T',null,'T',null,'Synchronize Windows Mobile / CE','Click to  synchronize the Windows Mobile / CE device with the pc','T',null,null,140,'F',103,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Process Mobile Device Data','ProcessMobileData','108','Process Mobile Device Data','Click to process mobile device data','T',null,'T',null,'Process Mobile Device Data','Click to process mobile device data','T',null,null,5,'F',4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Rename Add','Add','38','Rename Add',null,'T',null,'T',null,'Rename Add',null,'T',null,null,13,'F',1,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Rename Audit','Audit','39','Rename Audit','Click to rename the Audit menu','T',null,'T',null,'Rename Audit','Click to rename the Audit menu','T',null,null,13,'F',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Rename Check-In','CheckIn','40','Rename Check-In','Click to rename the Check-In menu','T',null,'T',null,'Rename Check-In','Click to rename the Check-In menu','T',null,null,13,'F',3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Rename Check-Out','CheckOut','41','Rename Check-Out','Click to rename the Check-Out menu','T',null,'T',null,'Rename Check-Out','Click to rename the Check-Out menu','T',null,null,13,'F',4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Rename Transfer Check-Out','Transfer','45','Rename Transfer Check-Out','Click to rename the Transfer Check-Out menu','T',null,'T',null,'Rename Transfer Check-Out','Click to rename the Transfer Check-Out menu','T',null,null,13,'F',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Rename Dispose','Dispose','42','Rename Dispose','Click to rename the Dispose menu','T',null,'T',null,'Rename Dispose','Click to rename the Dispose menu','T',null,null,13,'F',6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Rename Move','Move','43','Rename Move','Click to rename the Move menu','T',null,'T',null,'Rename Move','Click to rename the Move menu','T',null,null,13,'F',7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Reports',null,'4','Reports','Click to view Reports','T',null,'F',null,'Reports','Click to view Reports','T',null,null,0,'T',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Reset All Labels','Reset_All_Labels','125','Reset All Field Names','Click to reset all the field names and menu to their defaults','T',null,'T',null,'Reset All Field Names','Click to reset all the field names and menu to their defaults','T',null,null,13,'F',8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Restore','Restore','123','Restore','Click to restore a previous backup of MobileAsset','T',null,'T',null,'Restore','Click to restore a previous backup of MobileAsset','T',null,null,6,'F',2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Security','Security','12','Security','Click to manage the security of users.','T','T','F',30,'Security','Click to manage the security of users.','T','T',30,2,'T',3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Select Site','SetDefaultWorkingSite','200','Set Default Working Site','Click to set default source and destination sites.','T','T','T',null,'Set Default Working Site','Click to set default source and destination sites.','T','T',null,2,'T',5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Set Seed Value','Set_Seed_Value','203','Set Next Asset Tag Number','Click to change the next Asset Tag number','T',null,'T',null,'Set Next Asset Tag Number','Click to change the next Asset Tag number','T',null,null,2,'T',7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Transaction - Add','Reports','100','Transaction - Add',null,'T',null,'T',null,'Transaction - Add',null,'T',null,null,4,'T',500,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Transaction - Check-In','Reports','104','Transaction - Check-In',null,'T',null,'T',null,'Transaction - Check-In',null,'T',null,null,4,'T',504,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Transaction - Check-Out','Reports','103','Transaction - Check-Out',null,'T',null,'T',null,'Transaction - Check-Out',null,'T',null,null,4,'T',503,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Transaction - Dispose','Reports','101','Transaction - Dispose',null,'T',null,'T',null,'Transaction - Dispose',null,'T',null,null,4,'T',501,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Transaction - Move','Reports','102','Transaction - Move',null,'T',null,'T',null,'Transaction - Move',null,'T',null,null,4,'T',502,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Transaction Reports','Reports','89','Transaction Reports',null,'T',null,'T',null,'Transaction Reports',null,'T',null,null,4,'T',5,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','User Management','UserManager','130','User Manager','Click to add/edit users security','T',null,'T',null,'User Manager','Click to add/edit users security','T',null,null,12,'T',1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Group Management','GroupManager','128','Group Manager','Click to add/edit group security','T',null,'T',null,'Group Manager','Click to add/edit group security','T',null,null,12,'T',1,1,1,'T','1','1','T');
-- Reservation
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Reservation','Reservation_64','150','Reservations','Click to view the Asset Reservation menu','T',null,'F',null,'Reservations','Click to view the Asset Reservation menu','T',null,null,0,'F',8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Create New Reservation','Reservation_new','151','Make A New Reservation','Click to make a new asset reservation','T','F','F',50,'Make A New Reservation','Click to make a new asset reservation','T','F',50,150,'T',1,1,1,'F','F','F','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Manage My Reservations','Reservation_manage','152','Manage My Reservations','Click to manage existing asset reservations.','T','F','F',50,'Manage My Reservations','Click to manage existing asset reservations.','T','F',50,150,'T',2,1,1,'F','F','F','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Approval','Reservation_approve','153','Approval','Click to approve or reject asset reservations.','T','F','F',50,'Approval','Click to approve or reject asset reservations.','T','F',50,150,'T',3,1,1,'F','F','F','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (100,'TreeNode','Asset Availability Lookup','Reservation_lookup','155','Asset Availability Lookup','Click to view asset availability over a specified time period.','T','F','F',50,'Asset Availability Lookup','Click to view asset availability over a specified time period.','T','F',50,150,'T',4,1,1,'F','F','F','T');
END
ELSE
BEGIN
	-- archive 
	if (SELECT COUNT(form_id) FROM form_field_meta WHERE form_id = 100 and control = 'TreeNode' and field = 'Archive') = 0
		insert into form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import) values (100,'TreeNode','Archive','Archive','124','Archive','Click to archive unused transactions.','T',null,'T',null,'Archive','Click to archive unused transactions','T',null,null,6,null,3,1,1,'T','1','1');	
		
	-- Changing the functionality of the labels tree from print to edit.
	update form_field_meta set tool_tip = 'Click to edit Labels' where form_id = 100 and field = 'Labels'

END	
go

-- form 101
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 101) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 101';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Address1',null,'address1','Address &1:','Enter the address of your company, line 1.','T','F','T',100,'Address &1:','Enter the address of your company, line 1.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Address2',null,'address2','Address &2:','Enter the address of your company, line 2.','T','F','T',100,'Address &2:','Enter the address of your company, line 2.','T','F',100,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','City',null,'City','Cit&y:','Enter the city in which your company is located.','T','F','T',50,'Cit&y:','Enter the city in which your company is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Company',null,'Company','Company &Name:','Enter the name of your company.','T','F','T',50,'Company &Name:','Enter the name of your company.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Country',null,'Country','Co&untry:','Enter the country in which your company is located.','T','F','T',50,'Co&untry:','Enter the country in which your company is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Email',null,'Email','&Email:','Enter your company email address.','T','F','T',250,'&Email:','Enter your company email address.','T','F',250,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Fax',null,'Fax','&Fax:','Enter your company fax number.','T','F','T',20,'&Fax:','Enter your company fax number.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Form Name','FormName',null,null,null,'**','T','F','F',30,null,'**','T','F',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Phone',null,'phone_number','&Phone:','Enter your company phone number.','T','F','T',20,'&Phone:','Enter your company phone number.','T','F',20,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','State',null,'State','&State:','Enter the state in which your company is located.','T','F','T',50,'&State:','Enter the state in which your company is located.','T','F',50,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','Website',null,'Website','&Website:','Enter your company website.','T','F','T',255,'&Website:','Enter your company website.','T','F',255,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (101,'Label','ZipCode',null,'postal_code','&Postal Code:','Enter your company postal code.','T','F','T',10,'&Postal Code:','Enter your company postal code.','T','F',10,null,null,null,1,1,'T','1','1','T');
END
ELSE
BEGIN

UPDATE form_field_meta SET tool_tip = 'The address of your company, line 1.', default_tool_tip = 'The address of your company, line 1.' WHERE form_id = 101 and field = 'Address1'
UPDATE form_field_meta SET tool_tip = 'The address of your company, line 2.', default_tool_tip = 'The address of your company, line 2.' WHERE form_id = 101 and field = 'Address2'

END
GO

-- form 1000
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1000) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1000';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Title','Add',null,'na','Receive','na',null,null,'T',null,'Receive','na',null,null,null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','location',null,'location','Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','po',null,'po','PO:','PO',null,null,'T',null,'PO:','PO',null,null,null,null,null,5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','quantity',null,'quantity','Qty:','Receive Qty',null,null,'T',null,'Qty:','Receive Qty',null,null,null,null,null,8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1000,'Label','supplier',null,'supplier','Vendor:',null,null,null,'T',null,'Vendor:',null,null,null,null,null,null,6,1,1,'T','1','1','T');
END

-- form 1001
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1001) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1001';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','customer',null,'customer','Invoice#:','Invoice Number',null,null,'T',null,'Invoice#:','Invoice Number',null,null,null,null,null,5,2,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','location',null,'location','Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','po',null,'po','Invoice#:','Invoice Number',null,null,'T',null,'Invoice#:','Invoice Number',null,null,null,null,null,5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','quantity',null,'quantity','Qty:','Quantity',null,null,'T',null,'Qty:','Quantity',null,null,null,null,null,7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Title','Remove',null,'na','Pick','na',null,null,'T',null,'Pick','na',null,null,null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1001,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,6,1,1,'T','1','1','T');
END
GO

-- form 1002
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1002) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1002';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Label','from_location',null,'from_location','From:','From',null,null,'T',null,'From:','From',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Title','Move',null,'na','Move','na',null,null,'T',null,'Move','na',null,null,null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Label','quantity',null,'quantity','Mov Qty:','Mov Qty',null,null,'T',null,'Mov Qty:','Mov Qty',null,null,null,null,null,7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1002,'Label','to_location',null,'to_location','To:','To Location',null,null,'T',null,'To:','To Location',null,null,null,null,null,5,1,1,'T','1','1','T');
END

-- form 1003
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1003) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1003';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1003,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1003,'Title','Audit',null,'na','Audit','na',null,null,'T',null,'Audit','na',null,null,null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1003,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1003,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1003,'Label','location',null,'location','Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1003,'Label','quantity',null,'quantity','Count:','Count',null,null,'T',null,'Count:','Count',null,null,null,null,null,6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1003,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,5,1,1,'T','1','1','T');
END
GO

-- form 1004
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1004) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1004';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','absolute_adjust',null,'absolute_adjust','By Count','Pick a reason from the list for adjustment','T','F','T',25,'By Count','Pick a reason from the list for adjustment','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Title','Adjust',null,'na','Adjust','na',null,null,'T',null,'Adjust','na',null,null,null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','diff_type',null,'diff_type','Adjust:','Adjust Type',null,null,'T',null,'Adjust:','Adjust Type',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','location',null,'location','Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','quantity',null,'quantity','Qty:','Qty',null,null,'T',null,'Qty:','Qty',null,null,null,null,null,6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','reason',null,'reason','Reason:','Reason',null,null,'T',null,'Reason:','Reason',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','relative_adjust',null,'relative_adjust','By Diff','Pick a reason from the list for adjustment','T','F','T',25,'By Diff','Pick a reason from the list for adjustment','T','F',25,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1004,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,5,1,1,'T','1','1','T');
END

-- form 1005
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1005) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1005';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1005,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1005,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1005,'Title','Details',null,'na','Details','na',null,null,'T',null,'Details','na',null,null,null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1005,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1005,'Label','location',null,'location','Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1005,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,5,1,1,'T','1','1','T');
END
GO

-- form 1006
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1006) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1006';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','location',null,'location','Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','po',null,'po','PO:','PO',null,null,'T',null,'PO:','PO',null,null,null,null,null,5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','quantity',null,'quantity','Add Qty:','Add Qty',null,null,'T',null,'Add Qty:','Add Qty',null,null,null,null,null,8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Title','Review - Add',null,'na','Review Receive','na','T','T','T',null,'Review Receive','na','T','T',null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1006,'Label','supplier',null,'supplier','Vendor:',null,null,null,'T',null,'Vendor:',null,null,null,null,null,null,6,1,1,'T','1','1','T');
END

-- form 1007
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 1007) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 1007';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Label','alt_item_number',null,'alt_item_number','Alt #:','Alt Item Number','T','T','T',30,'Alt #:','Alt Item Number','T','T',30,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Label','customer',null,'customer','Invoice#:','Invoice Number',null,null,'T',null,'Invoice#:','Invoice Number',null,null,null,null,null,5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Label','desc',null,'description','Desc:','Description','T','T','T',30,'Desc:','Description','T','T',30,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Label','item_number',null,'item_number','Item #:','Item Number','T','T','T',30,'Item #:','Item Number','T','T',30,null,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Label','location',null,'location','Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Label','quantity',null,'quantity','Qty:','Quantity',null,null,'T',null,'Qty:','Quantity',null,null,null,null,null,7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Title','Review - Remove',null,'na','Review Pick','na','T','T','T',null,'Review Pick','na','T','T',null,null,null,0,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (1007,'Label','serial_no',null,'serial_number','Serial #:','Serial Number',null,null,'T',null,'Serial #:','Serial Number',null,null,null,null,null,6,1,1,'T','1','1','T');
END
GO

-- form 2000
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 2000) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 2000';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','BuildInfo',null,'BuildInfo','Build#:',null,null,null,'T',null,'Build#:',null,null,null,null,null,null,2,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','ButtonClear',null,'ButtonClear','Clear',null,null,null,'T',null,'Clear',null,null,null,null,null,null,7,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','ButtonOk',null,'ButtonOk','Ok',null,null,null,'T',null,'Ok',null,null,null,null,null,null,6,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','LabelLogInto',null,'LabelLogInto','Log into MobileAsset:',null,null,null,'T',null,'Log into MobileAsset:',null,null,null,null,null,null,3,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','LabelPassword',null,'LabelPassword','Password:',null,null,null,'T',null,'Password:',null,null,null,null,null,null,5,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','LabelUser',null,'LabelUser','User Name:',null,null,null,'T',null,'User Name:',null,null,null,null,null,null,4,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','MsgBadLogin',null,'MsgBadLogin','Invalid user name and password',null,null,null,'T',null,'Invalid user name and password',null,null,null,null,null,null,8,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2000,'Label','Title',null,'Title','MobileAsset',null,null,null,'T',null,'MobileAsset',null,null,null,null,null,null,1,1,1,'T','1','1','T');
END

-- form 2001
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 2001) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 2001';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','ButtonAddNew',null,'ButtonAddNew','Add New',null,null,null,'T',null,'Add New',null,null,null,null,null,null,10,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','ButtonAuditAssets',null,'ButtonAuditAssets','Audit',null,null,null,'T',null,'Audit',null,null,null,null,null,null,15,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','ButtonCheckIn',null,'ButtonCheckIn','Check-In',null,null,null,'T',null,'Check-In',null,null,null,null,null,null,14,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','ButtonCheckOut',null,'ButtonCheckOut','Check-Out',null,null,null,'T',null,'Check-Out',null,null,null,null,null,null,13,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','ButtonDispose',null,'ButtonDispose','Dispose',null,null,null,'T',null,'Dispose',null,null,null,null,null,null,16,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','ButtonEdit',null,'ButtonEdit','Edit',null,null,null,'T',null,'Edit',null,null,null,null,null,null,11,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','ButtonMove',null,'ButtonMove','Move',null,null,null,'T',null,'Move',null,null,null,null,null,null,12,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2001,'Label','Title',null,'Title','MobileAsset',null,null,null,'T',null,'MobileAsset',null,null,null,null,null,null,9,1,1,'T','1','1','T');
END
GO

-- form 2002
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 2002) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 2002';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','ButtonClose',null,'ButtonClose','Close',null,null,null,'T',null,'Close',null,null,null,null,null,null,26,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','ButtonI',null,'ButtonI','i',null,null,null,'T',null,'i',null,null,null,null,null,null,27,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','ButtonOK',null,'ButtonOK','OK',null,null,null,'T',null,'OK',null,null,null,null,null,null,25,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','LabelDepartment',null,'LabelDepartment','Dept:',null,null,null,'T',null,'Dept:',null,null,null,null,null,null,24,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','LabelDesc',null,'LabelDesc','Description: ',null,null,null,'T',null,'Description: ',null,null,null,null,null,null,22,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','LabelItemId',null,'LabelItemId','Asset Type:',null,null,null,'T',null,'Asset Type:',null,null,null,null,null,null,21,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','LabelLocation',null,'LabelLocation','Location:',null,null,null,'T',null,'Location:',null,null,null,null,null,null,19,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','LabelSite',null,'LabelSite','Site:',null,null,null,'T',null,'Site:',null,null,null,null,null,null,18,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','LabelSN',null,'LabelSN','Serial #:',null,null,null,'T',null,'Serial #:',null,null,null,null,null,null,23,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','LabelTag',null,'LabelTag','Asset Tag:',null,null,null,'T',null,'Asset Tag:',null,null,null,null,null,null,20,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgEnterItemId',null,'MsgEnterItemId','Enter Asset Type',null,null,null,'T',null,'Enter Asset Type',null,null,null,null,null,null,33,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgEnterLoc',null,'MsgEnterLoc','Enter Location',null,null,null,'T',null,'Enter Location',null,null,null,null,null,null,31,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgEnterSite',null,'MsgEnterSite','Enter Site',null,null,null,'T',null,'Enter Site',null,null,null,null,null,null,30,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgEnterSN',null,'MsgEnterSN','Enter Serial Number',null,null,null,'T',null,'Enter Serial Number',null,null,null,null,null,null,34,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgEnterTag',null,'MsgEnterTag','Enter Asset Tag',null,null,null,'T',null,'Enter Asset Tag',null,null,null,null,null,null,32,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgNewLoc',null,'MsgNewLoc','Do you want to add this new location',null,null,null,'T',null,'Do you want to add this new location',null,null,null,null,null,null,29,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgSiteNF',null,'MsgSiteNF','Site not found',null,null,null,'T',null,'Site not found',null,null,null,null,null,null,28,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','MsgTagExists',null,'MsgTagExists','Asset Tag already exists',null,null,null,'T',null,'Asset Tag already exists',null,null,null,null,null,null,35,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2002,'Label','Title',null,'Title','New Asset',null,null,null,'T',null,'New Asset',null,null,null,null,null,null,17,1,1,'T','1','1','T');
END

-- form 2003
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 2003) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 2003';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','ButtonCancel',null,'ButtonCancel','Cancel',null,null,null,'T',null,'Cancel',null,null,null,null,null,null,45,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','ButtonOK',null,'ButtonOK','OK',null,null,null,'T',null,'OK',null,null,null,null,null,null,44,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','LabelClass',null,'LabelClass','Depr.Class:',null,null,null,'T',null,'Depr.Class:',null,null,null,null,null,null,39,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','LabelCOD',null,'LabelCOD','CO Duration:',null,null,null,'T',null,'CO Duration:',null,null,null,null,null,null,43,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','LabelCTG',null,'LabelCTG','Category:',null,null,null,'T',null,'Category:',null,null,null,null,null,null,40,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','LabelDesc',null,'LabelDesc','Description: ',null,null,null,'T',null,'Description: ',null,null,null,null,null,null,38,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','LabelItemId',null,'LabelItemId','Asset Type:',null,null,null,'T',null,'Asset Type:',null,null,null,null,null,null,37,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','LabelMfg',null,'LabelMfg','Mfg:',null,null,null,'T',null,'Mfg:',null,null,null,null,null,null,41,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','LabelModelInfo',null,'LabelModelInfo','Model#:',null,null,null,'T',null,'Model#:',null,null,null,null,null,null,42,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','PromptCategory',null,'PromptCategory','Enter Category',null,null,null,'T',null,'Enter Category',null,null,null,null,null,null,49,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','PromptClass',null,'PromptClass','Enter Class',null,null,null,'T',null,'Enter Class',null,null,null,null,null,null,48,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','PromptCOD',null,'PromptCOD','Enter CO Duration',null,null,null,'T',null,'Enter CO Duration',null,null,null,null,null,null,52,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','PromptDesc',null,'PromptDesc','Enter Description',null,null,null,'T',null,'Enter Description',null,null,null,null,null,null,47,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','PromptItemId',null,'PromptItemId','Enter Asset Type',null,null,null,'T',null,'Enter Asset Type',null,null,null,null,null,null,46,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','PromptMfg',null,'PromptMfg','Enter Mfg',null,null,null,'T',null,'Enter Mfg',null,null,null,null,null,null,50,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','PromptModelNo',null,'PromptModelNo','Enter Model #',null,null,null,'T',null,'Enter Model #',null,null,null,null,null,null,51,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2003,'Label','Title',null,'Title','New Asset Type',null,null,null,'T',null,'New Asset Type',null,null,null,null,null,null,36,1,1,'T','1','1','T');
END
GO

-- form 2004
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 2004) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 2004';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','ButtonCancel',null,'ButtonCancel','Cancel',null,null,null,'T',null,'Cancel',null,null,null,null,null,null,61,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','ButtonFind',null,'ButtonFind','Find',null,null,null,'T',null,'Find',null,null,null,null,null,null,59,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','ButtonNew',null,'ButtonNew','New',null,null,null,'T',null,'New',null,null,null,null,null,null,62,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','ButtonOK',null,'ButtonOK','OK',null,null,null,'T',null,'OK',null,null,null,null,null,null,60,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','TitleAssets',null,'TitleAssets','Search Assets',null,null,null,'T',null,'Search Assets',null,null,null,null,null,null,53,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','TitleCustomers',null,'TitleCustomers','Search Customers',null,null,null,'T',null,'Search Customers',null,null,null,null,null,null,54,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','TitleEmployees',null,'TitleEmployees','Search Employees',null,null,null,'T',null,'Search Employees',null,null,null,null,null,null,55,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','TitleItems',null,'TitleItems','Search Asset Type',null,null,null,'T',null,'Search Asset Type',null,null,null,null,null,null,56,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','TitleLocations',null,'TitleLocations','Search Locations',null,null,null,'T',null,'Search Locations',null,null,null,null,null,null,57,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (2004,'Label','TitleSites',null,'TitleSites','Search Sites',null,null,null,'T',null,'Search Sites',null,null,null,null,null,null,58,1,1,'T','1','1','T');
END

-- form 10000
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10000) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10000';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'about',null,null,'About',null,null,null,'T',null,'About',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'add',null,null,'Add',null,null,null,'T',null,'Add',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'adjust',null,null,'Adjust',null,null,null,'T',null,'Adjust',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'audit',null,null,'Audit',null,null,null,'T',null,'Audit',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'details',null,null,'Details',null,null,null,'T',null,'Details',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'move',null,null,'Move',null,null,null,'T',null,'Move',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'recv_from_pc',null,null,'Receive From PC',null,null,null,'T',null,'Receive From PC',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'remove',null,null,'Remove',null,null,null,'T',null,'Remove',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'send_to_pc',null,null,'Send To PC',null,null,null,'T',null,'Send To PC',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'site_config',null,null,'Site Config',null,null,null,'T',null,'Site Config',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10000,null,'title',null,null,'MobileInventory',null,null,null,'T',null,'MobileInventory',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10001
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10001) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10001';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'date_code',null,null,'Date Code:',null,null,null,'T',null,'Date Code:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'item_no',null,null,'Item #:',null,null,null,'T',null,'Item #:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'location',null,null,'Location:',null,null,null,'T',null,'Location:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'lot',null,null,'Lot:',null,null,null,'T',null,'Lot:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'pallet',null,null,'Pallet:',null,null,null,'T',null,'Pallet:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'po',null,null,'PO:',null,null,null,'T',null,'PO:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'quantity',null,null,'Qty:',null,null,null,'T',null,'Qty:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'sn',null,null,'SN:',null,null,null,'T',null,'SN:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'supplier',null,null,'Vendor:',null,null,null,'T',null,'Vendor:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10001,null,'title',null,null,'Add',null,null,null,'T',null,'Add',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10002
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10002) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10002';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'customer',null,null,'Customer:',null,null,null,'T',null,'Customer:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'date_code',null,null,'Date Code:',null,null,null,'T',null,'Date Code:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'item_no',null,null,'Item #:',null,null,null,'T',null,'Item #:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'location',null,null,'Location:',null,null,null,'T',null,'Location:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'lot',null,null,'Lot:',null,null,null,'T',null,'Lot:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'pallet',null,null,'Pallet:',null,null,null,'T',null,'Pallet:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'quantity',null,null,'Qty:',null,null,null,'T',null,'Qty:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'sn',null,null,'SN:',null,null,null,'T',null,'SN:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10002,null,'title',null,null,'Remove',null,null,null,'T',null,'Remove',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10003
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10003) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10003';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'date_code',null,null,'Date Code:',null,null,null,'T',null,'Date Code:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'from',null,null,'From:',null,null,null,'T',null,'From:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'item_no',null,null,'Item #:',null,null,null,'T',null,'Item #:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'lot',null,null,'Lot:',null,null,null,'T',null,'Lot:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'pallet',null,null,'Pallet:',null,null,null,'T',null,'Pallet:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'quantity',null,null,'Qty:',null,null,null,'T',null,'Qty:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'sn',null,null,'SN:',null,null,null,'T',null,'SN:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'title',null,null,'Move',null,null,null,'T',null,'Move',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10003,null,'to',null,null,'To:',null,null,null,'T',null,'To:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10004
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10004) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10004';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'date_code',null,null,'Date Code:',null,null,null,'T',null,'Date Code:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'item_no',null,null,'Item #:',null,null,null,'T',null,'Item #:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'location',null,null,'Location:',null,null,null,'T',null,'Location:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'lot',null,null,'Lot:',null,null,null,'T',null,'Lot:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'pallet',null,null,'Pallet:',null,null,null,'T',null,'Pallet:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'quantity',null,null,'Qty:',null,null,null,'T',null,'Qty:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'sn',null,null,'SN:',null,null,null,'T',null,'SN:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10004,null,'title',null,null,'Adjust',null,null,null,'T',null,'Adjust',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10005
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10005) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10005';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10005,null,'date_code',null,null,'Date Code:',null,null,null,'T',null,'Date Code:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10005,null,'item_no',null,null,'Item #:',null,null,null,'T',null,'Item #:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10005,null,'location',null,null,'Location:',null,null,null,'T',null,'Location:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10005,null,'lot',null,null,'Lot:',null,null,null,'T',null,'Lot:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10005,null,'pallet',null,null,'Pallet:',null,null,null,'T',null,'Pallet:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10005,null,'sn',null,null,'SN:',null,null,null,'T',null,'SN:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10005,null,'title',null,null,'Details',null,null,null,'T',null,'Details',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10006
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10006) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10006';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'date_code',null,null,'Date Code:',null,null,null,'T',null,'Date Code:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'item_no',null,null,'Item #:',null,null,null,'T',null,'Item #:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'location',null,null,'Location:',null,null,null,'T',null,'Location:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'lot',null,null,'Lot:',null,null,null,'T',null,'Lot:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'pallet',null,null,'Pallet:',null,null,null,'T',null,'Pallet:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'quantity',null,null,'Qty:',null,null,null,'T',null,'Qty:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'sn',null,null,'SN:',null,null,null,'T',null,'SN:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10006,null,'title',null,null,'Audit',null,null,null,'T',null,'Audit',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10008
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10008) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10008';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10008,null,'source_site',null,null,'Source Site',null,null,null,'T',null,'Source Site',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10008,null,'title',null,null,'Site Configuration',null,null,null,'T',null,'Site Configuration',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10008,null,'to_site',null,null,'Destination Site',null,null,null,'T',null,'Destination Site',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10010
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10010) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10010';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10010,null,'count',null,null,'Count:',null,null,null,'T',null,'Count:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10010,null,'sn',null,null,'SN:',null,null,null,'T',null,'SN:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10011
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10011) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10011';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10011,null,'quantity',null,null,'Quantity:',null,null,null,'T',null,'Quantity:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10011,null,'quantity_total',null,null,'Quantity Total:',null,null,null,'T',null,'Quantity Total:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10012
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10012) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10012';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10012,null,'item_no',null,null,'Item #:',null,null,null,'T',null,'Item #:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10012,null,'quantity',null,null,'Quantity:',null,null,null,'T',null,'Quantity:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10012,null,'transaction_count',null,null,'Transaction Count:',null,null,null,'T',null,'Transaction Count:',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10100
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10100) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10100';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'about',null,null,'About',null,null,null,'T',null,'About',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'add',null,null,'Add',null,null,null,'T',null,'Add',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'adjust',null,null,'Adjust',null,null,null,'T',null,'Adjust',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'audit',null,null,'Audit',null,null,null,'T',null,'Audit',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'details',null,null,'Details',null,null,null,'T',null,'Details',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'logout',null,null,'LOGOUT',null,null,null,'T',null,'LOGOUT',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'move',null,null,'Move',null,null,null,'T',null,'Move',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'recv_from_pc',null,null,'Receive from PC',null,null,null,'T',null,'Receive from PC',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'remove',null,null,'Remove',null,null,null,'T',null,'Remove',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'send_to_pc',null,null,'Send to PC',null,null,null,'T',null,'Send to PC',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'site_config',null,null,'Site Config',null,null,null,'T',null,'Site Config',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10100,null,'title',null,null,'MobileInventory',null,null,null,'T',null,'MobileInventory',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10101
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10101) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10101';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'date_code',null,null,'Date Code',null,null,null,'T',null,'Date Code',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'item_no',null,null,'Item #',null,null,null,'T',null,'Item #',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'location',null,null,'Location',null,null,null,'T',null,'Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'lot',null,null,'Lot',null,null,null,'T',null,'Lot',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'pallet',null,null,'Pallet',null,null,null,'T',null,'Pallet',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'po',null,null,'PO',null,null,null,'T',null,'PO',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'quantity',null,null,'Qty',null,null,null,'T',null,'Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'sn',null,null,'SN',null,null,null,'T',null,'SN',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'supplier',null,null,'Vendor',null,null,null,'T',null,'Vendor',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10101,null,'title',null,null,'Add',null,null,null,'T',null,'Add',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10102
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10102) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10102';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'customer',null,null,'Customer',null,null,null,'T',null,'Customer',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'date_code',null,null,'Date Code',null,null,null,'T',null,'Date Code',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'item_no',null,null,'Item #',null,null,null,'T',null,'Item #',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'location',null,null,'Location',null,null,null,'T',null,'Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'lot',null,null,'Lot',null,null,null,'T',null,'Lot',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'pallet',null,null,'Pallet',null,null,null,'T',null,'Pallet',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'quantity',null,null,'Qty',null,null,null,'T',null,'Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'sn',null,null,'SN',null,null,null,'T',null,'SN',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10102,null,'title',null,null,'Remove',null,null,null,'T',null,'Remove',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10103
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10103) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10103';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'date_code',null,null,'Date Code',null,null,null,'T',null,'Date Code',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'from',null,null,'From',null,null,null,'T',null,'From',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'item_no',null,null,'Item #',null,null,null,'T',null,'Item #',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'lot',null,null,'Lot',null,null,null,'T',null,'Lot',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'pallet',null,null,'Pallet',null,null,null,'T',null,'Pallet',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'quantity',null,null,'Qty',null,null,null,'T',null,'Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'sn',null,null,'SN',null,null,null,'T',null,'SN',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'title',null,null,'Move',null,null,null,'T',null,'Move',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10103,null,'to',null,null,'To',null,null,null,'T',null,'To',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10104
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10104) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10104';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'date_code',null,null,'Date Code',null,null,null,'T',null,'Date Code',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'item_no',null,null,'Item #',null,null,null,'T',null,'Item #',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'location',null,null,'Location',null,null,null,'T',null,'Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'lot',null,null,'Lot',null,null,null,'T',null,'Lot',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'pallet',null,null,'Pallet',null,null,null,'T',null,'Pallet',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'quantity',null,null,'Qty',null,null,null,'T',null,'Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'sn',null,null,'SN',null,null,null,'T',null,'SN',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10104,null,'title',null,null,'Adjust',null,null,null,'T',null,'Adjust',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10105
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10105) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10105';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10105,null,'date_code',null,null,'Date Code',null,null,null,'T',null,'Date Code',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10105,null,'item_no',null,null,'Item #',null,null,null,'T',null,'Item #',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10105,null,'location',null,null,'Location',null,null,null,'T',null,'Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10105,null,'lot',null,null,'Lot',null,null,null,'T',null,'Lot',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10105,null,'pallet',null,null,'Pallet',null,null,null,'T',null,'Pallet',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10105,null,'sn',null,null,'SN',null,null,null,'T',null,'SN',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10105,null,'title',null,null,'Details',null,null,null,'T',null,'Details',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10106
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10106) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10106';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'date_code',null,null,'Date Code',null,null,null,'T',null,'Date Code',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'item_no',null,null,'Item #',null,null,null,'T',null,'Item #',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'location',null,null,'Location',null,null,null,'T',null,'Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'lot',null,null,'Lot',null,null,null,'T',null,'Lot',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'pallet',null,null,'Pallet',null,null,null,'T',null,'Pallet',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'quantity',null,null,'Qty',null,null,null,'T',null,'Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'sn',null,null,'SN',null,null,null,'T',null,'SN',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10106,null,'title',null,null,'Audit',null,null,null,'T',null,'Audit',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10108
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10108) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10108';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10108,null,'source_site',null,null,'Source Site',null,null,null,'T',null,'Source Site',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10108,null,'title',null,null,'Site Configuration',null,null,null,'T',null,'Site Configuration',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10108,null,'to_site',null,null,'Destination Site',null,null,null,'T',null,'Destination Site',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10110
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10110) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10110';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10110,null,'count',null,null,'Count',null,null,null,'T',null,'Count',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10110,null,'sn',null,null,'SN',null,null,null,'T',null,'SN',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10111
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10111) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10111';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10111,null,'quantity',null,null,'Quantity',null,null,null,'T',null,'Quantity',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10111,null,'quantity_total',null,null,'Quantity Total',null,null,null,'T',null,'Quantity Total',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10112
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10112) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10112';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10112,null,'item_no',null,null,'Item #',null,null,null,'T',null,'Item #',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10112,null,'quantity',null,null,'Quantity',null,null,null,'T',null,'Quantity',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10112,null,'transaction_count',null,null,'Transaction Count',null,null,null,'T',null,'Transaction Count',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10200
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10200) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10200';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'audit',null,null,'Audit','Audit',null,null,'T',null,'Audit','Audit',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'check-in',null,null,'Check-In','Check-In',null,null,'T',null,'Check-In','Check-In',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'check-out',null,null,'Check-Out','Check-Out',null,null,'T',null,'Check-Out','Check-Out',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'dispose',null,null,'Dispose','Dispose',null,null,'T',null,'Dispose','Dispose',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'edit asset',null,null,'Edit Asset','Edit Asset',null,null,'T',null,'Edit Asset','Edit Asset',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'maintenance',null,null,'Maintenance','Maintenance',null,null,'T',null,'Maintenance','Maintenance',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'move',null,null,'Move','Move',null,null,'T',null,'Move','Move',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10200,null,'new asset',null,null,'New Asset','New Asset',null,null,'T',null,'New Asset','New Asset',null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10201
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10201) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10201';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'category',null,null,'Category:','Category',null,null,'T',null,'Category:','Category',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'class_name',null,null,'Depr.Class:','Class',null,null,'T',null,'Depr.Class:','Class',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'supplier_number',null,null,'Vendor:','Vendor',null,null,'T',null,'Vendor:','Vendor',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'checkout_duration',null,null,'C.O. Length:','Check Out Length',null,null,'T',null,'C.O. Length:','Check Out Length',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'lead_time',null,null,'Lead Time:','Lead Time',null,null,'T',null,'Lead Time:','Lead Time',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'asset_contains',null,null,'Child Assets:','Child Assets',null,null,'T',null,'Child Assets:','Child Assets',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'department',null,null,'Department:','Department',null,null,'T',null,'Department:','Department',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'desc',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'item_number',null,null,'Asset Type:','Asset Type',null,null,'T',null,'Asset Type:','Asset Type',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'manufacturer',null,null,'Manufacturer:','Manufacturer',null,null,'T',null,'Manufacturer:','Manufacturer',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'model',null,null,'Model #:','Model #',null,null,'T',null,'Model #:','Model #',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'asset_part_of',null,null,'Parent Asset:','Parent Asset',null,null,'T',null,'Parent Asset:','Parent Asset',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'reason',null,null,'Reason:','Reason',null,null,'T',null,'Reason:','Reason',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'serial_number',null,null,'Serial #:','Serial #',null,null,'T',null,'Serial #:','Serial #',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'site_name',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'transact_as_whole',null,null,'Transact As Whole','Transact As Whole',null,null,'T',null,'Transact As Whole','Transact As Whole',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefdate1',null,null,'Custom Date 1:','Enter a custom date.',null,null,'T',null,'Custom Date 1:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefdate2',null,null,'Custom Date 2:','Enter a custom date.',null,null,'T',null,'Custom Date 2:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefdate3',null,null,'Custom Date 3:','Enter a custom date.',null,null,'T',null,'Custom Date 3:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefdate4',null,null,'Custom Date 4:','Enter a custom date.',null,null,'T',null,'Custom Date 4:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefdate5',null,null,'Custom Date 5:','Enter a custom date.',null,null,'T',null,'Custom Date 5:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefnumber1',null,null,'Custom No 1:','Enter a custom number.',null,null,'T',null,'Custom No 1:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefnumber2',null,null,'Custom No 2:','Enter a custom number.',null,null,'T',null,'Custom No 2:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefnumber3',null,null,'Custom No 3:','Enter a custom number.',null,null,'T',null,'Custom No 3:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefnumber4',null,null,'Custom No 4:','Enter a custom number.',null,null,'T',null,'Custom No 4:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdefnumber5',null,null,'Custom No 5:','Enter a custom number.',null,null,'T',null,'Custom No 5:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext1',null,null,'Custom Text 1:','Enter a custom text.',null,null,'T',null,'Custom Text 1:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext10',null,null,'Custom Text10:','Enter a custom text.',null,null,'T',null,'Custom Text10:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext2',null,null,'Custom Text 2:','Enter a custom text.',null,null,'T',null,'Custom Text 2:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext3',null,null,'Custom Text 3:','Enter a custom text.',null,null,'T',null,'Custom Text 3:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext4',null,null,'Custom Text 4:','Enter a custom text.',null,null,'T',null,'Custom Text 4:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext5',null,null,'Custom Text 5:','Enter a custom text.',null,null,'T',null,'Custom Text 5:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext6',null,null,'Custom Text 6:','Enter a custom text.',null,null,'T',null,'Custom Text 6:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext7',null,null,'Custom Text 7:','Enter a custom text.',null,null,'T',null,'Custom Text 7:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext8',null,null,'Custom Text 8:','Enter a custom text.',null,null,'T',null,'Custom Text 8:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10201,null,'usrdeftext9',null,null,'Custom Text 9:','Enter a custom text.',null,null,'T',null,'Custom Text 9:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10202
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10202) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10202';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'category',null,null,'Category:','Category',null,null,'T',null,'Category:','Category',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'supplier_number',null,null,'Vendor:','Vendor',null,null,'T',null,'Vendor:','Vendor',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'checkout_duration',null,null,'Check Out Length:','Check Out Length',null,null,'T',null,'Check Out Length:','Check Out Length',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'lead_time',null,null,'Lead Time:','Lead Time',null,null,'T',null,'Lead Time:','Lead Time',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'class_name',null,null,'Depr.Class:','Class',null,null,'T',null,'Depr.Class:','Class',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'condition',null,null,'Condition:','Condition',null,null,'T',null,'Condition:','Condition',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'asset_contains',null,null,'Child Assets:','Child Assets',null,null,'T',null,'Child Assets:','Child Assets',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'department',null,null,'Department:','Department',null,null,'T',null,'Department:','Department',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'item_number',null,null,'Asset Type:','Asset Type',null,null,'T',null,'Asset Type:','Asset Type',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'manufacturer',null,null,'Manufacturer:','Manufacturer',null,null,'T',null,'Manufacturer:','Manufacturer',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'model',null,null,'Model #:','Model #',null,null,'T',null,'Model #:','Model #',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'asset_part_of',null,null,'Parent Asset:','Parent Asset',null,null,'T',null,'Parent Asset:','Parent Asset',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'serial_number',null,null,'Serial #:','Serial #',null,null,'T',null,'Serial #:','Serial #',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'site_name',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'transact_as_whole',null,null,'Transact As Whole','Transact As Whole',null,null,'T',null,'Transact As Whole','Transact As Whole',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefdate1',null,null,'Custom Date 1:','Enter a custom date.',null,null,'T',null,'Custom Date 1:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefdate2',null,null,'Custom Date 2:','Enter a custom date.',null,null,'T',null,'Custom Date 2:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefdate3',null,null,'Custom Date 3:','Enter a custom date.',null,null,'T',null,'Custom Date 3:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefdate4',null,null,'Custom Date 4:','Enter a custom date.',null,null,'T',null,'Custom Date 4:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefdate5',null,null,'Custom Date 5:','Enter a custom date.',null,null,'T',null,'Custom Date 5:','Enter a custom date.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefnumber1',null,null,'Custom No 1:','Enter a custom number.',null,null,'T',null,'Custom No 1:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefnumber2',null,null,'Custom No 2:','Enter a custom number.',null,null,'T',null,'Custom No 2:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefnumber3',null,null,'Custom No 3:','Enter a custom number.',null,null,'T',null,'Custom No 3:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefnumber4',null,null,'Custom No 4:','Enter a custom number.',null,null,'T',null,'Custom No 4:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdefnumber5',null,null,'Custom No 5:','Enter a custom number.',null,null,'T',null,'Custom No 5:','Enter a custom number.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext1',null,null,'Custom Text 1:','Enter a custom text.',null,null,'T',null,'Custom Text 1:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext10',null,null,'Custom Text10:','Enter a custom text.',null,null,'T',null,'Custom Text10:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext2',null,null,'Custom Text 2:','Enter a custom text.',null,null,'T',null,'Custom Text 2:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext3',null,null,'Custom Text 3:','Enter a custom text.',null,null,'T',null,'Custom Text 3:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext4',null,null,'Custom Text 4:','Enter a custom text.',null,null,'T',null,'Custom Text 4:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext5',null,null,'Custom Text 5:','Enter a custom text.',null,null,'T',null,'Custom Text 5:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext6',null,null,'Custom Text 6:','Enter a custom text.',null,null,'T',null,'Custom Text 6:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext7',null,null,'Custom Text 7:','Enter a custom text.',null,null,'T',null,'Custom Text 7:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext8',null,null,'Custom Text 8:','Enter a custom text.',null,null,'T',null,'Custom Text 8:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10202,null,'usrdeftext9',null,null,'Custom Text 9:','Enter a custom text.',null,null,'T',null,'Custom Text 9:','Enter a custom text.',null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10203
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10203) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10203';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10203,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10203,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10203,null,'serial_number',null,null,'Serial #:','Serial #',null,null,'T',null,'Serial #:','Serial #',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10203,null,'site_name',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10204
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10204) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10204';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10204,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10204,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10204,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10204,null,'site_name',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10205
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10205) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10205';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'customer',null,null,'Customer #:','Customer #',null,null,'T',null,'Customer #:','Customer #',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'customer_name',null,null,'Name:','Customer Name',null,null,'T',null,'Name:','Customer Name',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'due_date',null,null,'Due Date:','Due Date',null,null,'T',null,'Due Date:','Due Date',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'due_time',null,null,'Due Time:','Due Time',null,null,'T',null,'Due Time:','Due Time',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'employee',null,null,'Employee #:','Employee #',null,null,'T',null,'Employee #:','Employee #',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'first_name',null,null,'First Name:','First Name',null,null,'T',null,'First Name:','First Name',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'last_name',null,null,'Last Name:','Last Name',null,null,'T',null,'Last Name:','Last Name',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10205,null,'site_name',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10206
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10206) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10206';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10206,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10206,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10206,null,'location',null,null,'Location:','Location',null,null,'T',null,'Location:','Location',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10206,null,'site_name',null,null,'Site:','Site',null,null,'T',null,'Site:','Site',null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO

-- form 10207
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10207) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10207';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10207,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10207,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10207,null,'from_loc',null,null,'From Location:','From Location',null,null,'T',null,'From Location:','From Location',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10207,null,'from_site',null,null,'From Site:','From Site',null,null,'T',null,'From Site:','From Site',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10207,null,'to_location',null,null,'To Location:','To Location',null,null,'T',null,'To Location:','To Location',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10207,null,'to_site',null,null,'To Site:','To Site',null,null,'T',null,'To Site:','To Site',null,null,null,null,null,null,null,1,'T','1','1','T');
END

-- form 10208
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 10208) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 10208';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10208,null,'asset_tag',null,null,'Asset Tag:','Asset Tag',null,null,'T',null,'Asset Tag:','Asset Tag',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10208,null,'completed',null,null,'Completed:','Completed',null,null,'T',null,'Completed:','Completed',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10208,null,'completed_on',null,null,'Completed On:','Completed on',null,null,'T',null,'Completed on:','Completed on',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10208,null,'condition',null,null,'Condition:','Condition',null,null,'T',null,'Condition:','Condition',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10208,null,'description',null,null,'Description:','Description',null,null,'T',null,'Description:','Description',null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (10208,null,'notes',null,null,'Notes:','Note',null,null,'T',null,'Notes:','Note',null,null,null,null,null,null,null,1,'T','1','1','T');
END
GO
-- end of 102xx


-- form 90000
IF (SELECT COUNT(*) FROM form_field_meta WHERE form_id = 90000) = 0
BEGIN
	PRINT '.. insert form_field_meta for form id: 90000';

INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','accepted_qty',null,'accepted_qty','Accepted Qty',null,null,null,'T',null,'Accepted Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','adjust_date',null,'adjust_date','Adjust Date',null,null,null,'T',null,'Adjust Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','assigned_to',null,'assigned_to','Assigned To',null,null,null,'T',null,'Assigned To',null,null,null,null,null,null,null,null,null,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','audit_date',null,'audit_date','Audit Date',null,null,null,'T',null,'Audit Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','audited_qty',null,'audited_qty','Audited Qty',null,null,null,'T',null,'Audited Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','back_order',null,'back_order','Back Order',null,null,null,'T',null,'Back Order',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','bill_to',null,'bill_to','BILL TO',null,null,null,'T',null,'BILL TO',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','checked-out',null,'checked-out','Checked-Out',null,null,null,'T',null,'Checked-Out',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','checkin_date',null,'checkin_date','Check-In Date',null,null,null,'T',null,'Check-In Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','checkout_date',null,'checkout_date','Check-Out Date',null,null,null,'T',null,'Check-Out Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','completed',null,'completed','Completed',null,null,null,'T',null,'Completed',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','current_qty',null,'current_qty','Current Qty',null,null,null,'T',null,'Current Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','currentl_site_location',null,'current_site_location','Current Site Location',null,null,null,'T',null,'Current Site Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','customer',null,'customer','Customer',null,null,null,'T',null,'Customer',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','customer_message',null,'customer_message','Customer Message',null,null,null,'T',null,'Customer Message',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','customer_name',null,'customer_name','Customer Name',null,null,null,'T',null,'Customer Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','daily',null,'daily','Daily',null,null,null,'T',null,'Daily',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','date',null,'date','Date',null,'T','T','T',null,'Date',null,'T','T',null,62,null,1,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','date_acquired',null,'date_acquired','Date Acquired',null,null,null,'T',null,'Date Acquired',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','date_added',null,'date_added','Date Added',null,null,null,'T',null,'Date Added',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','date_audited',null,'date_audited','Date Audited',null,null,null,'T',null,'Date Audited',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','date_disposed',null,'date_disposed','Date Disposed',null,null,null,'T',null,'Date Disposed',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','date_moved',null,'date_moved','Date Moved',null,null,null,'T',null,'Date Moved',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','date_started',null,'date_started','Date Started',null,null,null,'T',null,'Date Started',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','department',null,'department','Department',null,null,null,'T',null,'Department',null,null,null,null,null,null,null,null,null,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','description',null,'description','Description',null,null,null,'T',null,'Description',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','discrepancy',null,'discrepancy','Discrepancy',null,null,null,'T',null,'Discrepancy',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','due_date',null,'due_date','Due Date',null,null,null,'T',null,'Due Date',null,null,null,null,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','dvalue',null,'dvalue','Dvalue',null,null,null,'T',null,'Dvalue',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','employee_first_name',null,'employee_first_name','Employee First Name',null,null,null,'T',null,'Employee First Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','purchase_cost',null,'purchase_cost','Purchase Cost',null,null,null,'T',null,'Purchase Cost',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','employee_last_name',null,'employee_last_name','Employee Last Name',null,null,null,'T',null,'Employee Last Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','employee_name',null,'employee_name','Employee Name','Enter employee number.  Employee number must be unique.','T','T','T',30,'Employee Name','Enter employee number.  Employee number must be unique.','T','T',30,null,null,null,1,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','error_description',null,'error_description','Error Description',null,null,null,'T',null,'Error Description',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','error_number',null,'error_number','Error Number',null,null,null,'T',null,'Error Number',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','error_type',null,'error_type','Error Type',null,null,null,'T',null,'Error Type',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','expected_date',null,'expected_date','Expected Date',null,null,null,'T',null,'Expected Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','extension',null,'extension','Extension',null,null,null,'T',null,'Extension',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','first_name',null,'first_name','First Name',null,null,null,'T',null,'First Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','from',null,'from','From',null,null,null,'T',null,'From',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','grand_total',null,'grand_total','Grand Total',null,null,null,'T',null,'Grand Total',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','id_reference',null,'id_reference','ID/Reference',null,null,null,'T',null,'ID/Reference',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','in_progress',null,'in_progress','In Progress',null,null,null,'T',null,'In Progress',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','internal_id',null,'internal_id','Internal ID',null,null,null,'T',null,'Internal ID',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','invoice_status',null,'invoice_status','Invoice Status',null,null,null,'T',null,'Invoice Status',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','item',null,'item','Asset Type',null,null,null,'T',null,'Asset Type',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','item_information',null,'item_information','Item Information',null,null,null,'T',null,'Item Information',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','last_audit_date',null,'last_audit_date','Last Audit Date',null,null,null,'T',null,'Last Audit Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','last_name',null,'last_name','Last Name',null,null,null,'T',null,'Last Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','line_item_count',null,'line_item_count','Line Item Count',null,null,null,'T',null,'Line Item Count',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','login_name',null,'login_name','Login Name',null,null,null,'T',null,'Login Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','maintenance',null,'maintenance','Maintenance',null,null,null,'T',null,'Maintenance',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','memo',null,'memo','Memo',null,null,null,'T',null,'Memo',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','monthly',null,'monthly','Monthly',null,null,null,'T',null,'Monthly',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','move_date',null,'move_date','Move Date',null,null,null,'T',null,'Move Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','never_audited',null,'never_audited','Never Audited',null,null,null,'T',null,'Never Audited',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','no',null,'no','No',null,null,null,'T',null,'No',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','no_of_assets',null,'no_of_assets','Number of Assets',null,null,null,'T',null,'Number of Assets',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','notes',null,'notes','Notes',null,null,null,'T',null,'Notes',null,null,null,null,null,null,null,null,1,'F','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','object_type',null,'object_type','Object Type',null,null,null,'T',null,'Object Type',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','occurs_every',null,'occurs_every','Occurs Every',null,null,null,'T',null,'Occurs Every',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','occurs_type',null,'occurs_type','Frequency',null,null,null,'T',null,'Frequency',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','order_quantity',null,'order_quantity','Original Order Qty',null,null,null,'T',null,'Original Order Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','original_data',null,'original_data','Original Data',null,null,null,'T',null,'Original Data',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','original_qty',null,'original_qty','Original Qty',null,null,null,'T',null,'Original Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','original_site_location',null,'original_site_location','Original Site Location',null,null,null,'T',null,'Original Site Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','originating',null,'originating','Originating',null,null,null,'T',null,'Originating',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','out_date',null,'out_date','Out Date',null,null,null,'T',null,'Out Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','parent',null,'parent','Parent',null,null,null,'T',null,'Parent',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','phone_number',null,'phone_number','Phone Number',null,null,null,'T',null,'Phone Number',null,null,null,null,null,null,null,null,null,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','pick_date',null,'pick_date','Pick Date',null,null,null,'T',null,'Pick Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','po_status',null,'po_status','PO Status',null,null,null,'T',null,'PO Status',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','process_type',null,'process_type','Process Type',null,null,null,'T',null,'Process Type',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','putaway_location',null,'putaway_location','Put-away Location',null,null,null,'T',null,'Put-away Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','putaway_site',null,'putaway_site','Put-away Site',null,null,null,'T',null,'Put-away Site',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','receive_date',null,'receive_date','Receive Date',null,null,null,'T',null,'Receive Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','received_quantity',null,'received_quantity','Received Qty',null,null,null,'T',null,'Received Qty',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','security_options',null,'security_options','Security Options',null,null,null,'T',null,'Security Options',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','ship_quantity',null,'ship_quantity','Ship Quantity',null,null,null,'T',null,'Ship Quantity',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','ship_to',null,'ship_to','SHIP TO',null,null,null,'T',null,'SHIP TO',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','specific_date',null,'specific_date','Specific Date',null,null,null,'T',null,'Specific Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','status',null,'status','Status',null,null,null,'T',null,'Status',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','to',null,'to','To',null,null,null,'T',null,'To',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','total',null,'total','Total',null,null,null,'T',null,'Total',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','transaction_date',null,'transaction_date','Transaction Date',null,null,null,'T',null,'Transaction Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','type',null,'type','Type',null,null,null,'T',null,'Type',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','user_first_name',null,'user_first_name','User First Name',null,null,null,'T',null,'User First Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','user_last_name',null,'user_last_name','User Last Name',null,null,null,'T',null,'User Last Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','user_logon_name',null,'user_logon_name','User Logon Name',null,null,null,'T',null,'User Logon Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','user_name',null,'user_name','User Name',null,null,null,'T',null,'User Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','vendor',null,'vendor','Vendor',null,null,null,'T',null,'Vendor',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','weekly',null,'weekly','Weekly',null,null,null,'T',null,'Weekly',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','yes',null,'yes','Yes',null,null,null,'T',null,'Yes',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','original_location',null,'original_location','Original Location',null,null,null,'T',null,'Original Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','audit_location',null,'audit_location','Audit Location',null,null,null,'T',null,'Audit Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','audited_to_location',null,'audited_to_location','Audited to Location',null,null,null,'T',null,'Audited to Location',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','audited_to_site',null,'audited_to_site','Audited to Site',null,null,null,'T',null,'Audited to Site',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','name',null,'name','Name',null,null,null,'T',null,'Name',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','all_sites',null,'all_sites','Can access all current and future site.',null,null,null,'F',null,'Can access all current and future site.',null,null,null,null,null,null,null,null,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','accessible_sites',null,'accessible_sites','Accessible Sites:',null,null,null,'F',null,'Accessible Sites:',null,null,null,null,null,null,null,null,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','no_site',null,'no_site','No permission to access any sites.',null,null,null,'F',null,'No permission to access any sites.',null,null,null,null,null,null,null,null,1,'F','0','0','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','total_depreciation',null,'total_depreciation','Total Depreciation',null,null,null,'T',null,'Total Depreciation',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','depreciated_value',null,'depreciated_value','Book Value',null,null,null,'T',null,'Book Value',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','current_depreciation',null,'current_depreciation','Current Depreciation',null,null,null,'T',null,'Current Depreciation',null,null,null,null,null,null,null,null,1,'T','1','1','T');
INSERT INTO form_field_meta (form_id,control,field,image_name,db_field,label,tool_tip,visible,required,user_editable,field_length,default_label,default_tool_tip,default_visible,default_required,default_field_length,data_type,send_to_palm,sort_order,record_status,company_id,should_find,should_export,should_import,usrdef_allow_user_key_in_value) values (90000,'CR','last_depreciation_date',null,'last_depreciation_date','Last Depreciation Date',null,null,null,'T',null,'Last Depreciation Date',null,null,null,null,null,null,null,null,1,'T','1','1','T');
END

GO

UPDATE form_field_meta SET usrdef_allow_user_key_in_value='T' where usrdef_allow_user_key_in_value is NULL

---  '_id' fields that have should_find bit to T, change them to F
UPDATE form_field_meta SET should_find = 'F' WHERE form_id < 40 and should_find = 'T' and field like '%_id'

GO


if ( SELECT COUNT(manufacturer_id) FROM [manufacturer] WHERE manufacturer_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [manufacturer] ON;
   INSERT INTO manufacturer (manufacturer_id,name,email,website,contact_name,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10,record_status,company_id,date_updated) VALUES (0,' ','','','',null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,0,null);
   SET IDENTITY_INSERT [manufacturer] OFF;
END
GO


----------------------------------------------------
-- Table Name: label_names
----------------------------------------------------
DELETE FROM label_names
go
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (201,1001,2,'Location Labels','Location Labels','Location Labels',null,'Labels_Location');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (101,-2000,1,'Asset Tag New','Asset Tag NewDB','Asset Tag New',null,'Label');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (301,1001,3,'Employee Badges','Employee Badges','Employee Badges',null,'Labels_Employee');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (1001,1001,4,'Launch Labeler','Launch Labeler','Launch Labeler',null,'Launch_Labeler');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (1002,1001,5,'Browse to Label File','Browse to Label File','Browse to Label File',null,'Labels_Browse');
INSERT INTO label_names (lbl_id,lbl_type,lbl_display_order,lbl_name,lbl_file_name,lbl_default_name,lbl_tool_tips,lbl_image_name) values (203,1001,1,'Asset Tags','Asset Tags','Asset Tags',null,'Labels_Asset_Tags');
GO



----------------------------------------------------
-- Table Name: not_avail_reason
----------------------------------------------------
DELETE FROM not_avail_reason;
insert into not_avail_reason (na_reason_id,na_reason_text,record_status,company_id) values (1,'Checked Out',1,1);
insert into not_avail_reason (na_reason_id,na_reason_text,record_status,company_id) values (2,'Reserved For Checkout',1,1);
insert into not_avail_reason (na_reason_id,na_reason_text,record_status,company_id) values (3,'Approved',1,1);
insert into not_avail_reason (na_reason_id,na_reason_text,record_status,company_id) values (4,'Requested',1,1);
insert into not_avail_reason (na_reason_id,na_reason_text,record_status,company_id) values (5,'Lead Time',1,1);
GO




----------------------------------------------------
-- Table Name: notes
-- Due to a previous application bug: imported assets may not have a corresponding notes
-- record in the notes table 
----------------------------------------------------
INSERT INTO [notes]
SELECT asset_id, 'asset', '', GetDate(), 1, 1, 1 FROM asset WHERE asset_id NOT IN (SELECT note_id FROM notes WHERE table_name = 'asset') and record_status = 1 and company_id = 1
GO




DELETE FROM reasons;
SET IDENTITY_INSERT [reasons] ON;
INSERT INTO reasons (reason_id,sort_order,description,company_id,record_status,date_updated) VALUES (1,1,'Sale',1,1,null);
INSERT INTO reasons (reason_id,sort_order,description,company_id,record_status,date_updated) VALUES (2,2,'Lost',1,1,null);
INSERT INTO reasons (reason_id,sort_order,description,company_id,record_status,date_updated) VALUES (3,3,'Damaged',1,1,null);
INSERT INTO reasons (reason_id,sort_order,description,company_id,record_status,date_updated) VALUES (4,4,'Trade In',1,1,null);
INSERT INTO reasons (reason_id,sort_order,description,company_id,record_status,date_updated) VALUES (5,5,'Stolen',1,1,null);
INSERT INTO reasons (reason_id,sort_order,description,company_id,record_status,date_updated) VALUES (6,6,'Other',1,1,null);
SET IDENTITY_INSERT [reasons] OFF;
GO


DELETE FROM record_status;
INSERT INTO record_status (status_id,description) VALUES (1,'Active');
INSERT INTO record_status (status_id,description) VALUES (2,'Inactive');
INSERT INTO record_status (status_id,description) VALUES (3,'Delete');
INSERT INTO record_status (status_id,description) VALUES (4,'Pending');
GO

DELETE FROM report_hidden_fields;
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('action_type                                       ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('category_id                                       ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('Company_id                                        ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('Customer_id                                       ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('inventory_id                                      ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('item_id                                           ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('location_id                                       ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('manufacturer_id                                   ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('other_id                                          ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('phone_id                                          ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('record_source                                     ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('record_status                                     ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('record_type                                       ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('site_id                                           ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('supplier_id                                       ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('trans_type                                        ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('transaction_id                                    ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('update_user_id                                    ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('user_id                                           ');
INSERT INTO report_hidden_fields (hidden_fields) VALUES ('employee_id                                       ');
GO


----------------------------------------------------
-- Table Name: report_label_types
----------------------------------------------------
DELETE FROM report_label_types
go
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (1,10,'Asset Type Reports','Asset Type Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (14,2,'Asset Depreciation Reports','Asset Depreciation Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (3,11,'Location Reports','Location Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (4,8,'Customer Reports','Customer Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (5,5,'Check-Out to Customer Reports','Check-Out to Customer Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (6,12,'Transaction Reports','Transaction Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (15,3,'Asset Maintenance Reports','Asset Maintenance Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (16,6,'Check-Out to Employee Reports','Check-Out to Employee Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (10,13,'Other Reports','Other Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (11,4,'Audit Reports','Audit Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (1001,1,'Labels','Labels');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (12,1,'Asset Reports','Asset Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (13,9,'Employee Reports','Employee Reports');
INSERT INTO report_label_types (type_id,type_display_order,type_name,type_default_name) values (17,7,'Contract/License Reports','Contract/License Reports');
go



----------------------------------------------------
-- Table Name: report_labels
----------------------------------------------------
-- data_type correlations: 0 - bool, 1 - int, 2 - string, 3 - datetime

DELETE FROM report_labels
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'site_name',null,'MoveFrom',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'fax',null,'Manufacturer',5,null,'fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'quantity',null,'Item',90000,'original_order_qty',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'site_name1',null,'Item Receive',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'ref_number',null,'Invoice Pick',0,null,null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'phone_number',null,'Supplier',4,null,'phone_number',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'address1',null,'Supplier',9,'address1',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'extension',null,'Supplier',9,null,'extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'last_name',null,'User',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'address1',null,'Supplier',9,'address1',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'last_name',null,'User',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'allow_shorting',null,'vInvoiceInfo',4,'allow_shorting',null,0);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'picked_quantity',null,'Item',90000,'ship_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (803,'ref_number',null,'Item Receive',1000,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'website',null,'Supplier',9,'website',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'city',null,'Supplier',9,'city',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (705,'ref_number',null,'Invoice Pick',1001,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'trans_date',null,'Inventory',13,'trans_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'postal_code',null,'Supplier',9,'postal_code',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'address1',null,'Manufacturer',5,'address1',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'ccell',null,'Supplier',9,null,'Contact Cell Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'lot',null,'Inventory',11,'lot',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'employee_first_name',null,'Employee',30,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'employee_extension',null,'Employee',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'customer_phone_number',null,'Customer',90000,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'name',null,'Supplier',9,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'address2',null,'Supplier',9,'address2',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1501,'condition',null,'vAssetMaintenance',27,'condition',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1301,'phone_number',null,'Supplier',90000,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'ccell',null,'Supplier',4,null,'Cell Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'city',null,'Supplier',9,'city',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (403,'name',null,'Customer',9,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'phone_number',null,'Supplier',90000,'phone_number',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'manager_last_name',null,'Manager',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (403,'phone_number',null,'Supplier',4,null,'phone_number',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (403,'ccell',null,'Supplier',4,null,'cell phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (404,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'po',null,'Inventory',11,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'trans_date',null,'Inventory',90000,'checkout_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'trans_date',null,'Inventory',90000,'checkout_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'user_last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (105,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (105,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'location',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (806,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (806,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (806,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (806,'quantity_received',null,'Item Receive',90000,'received_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (806,'po_type',null,'vPOinfo',22,'po_type',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (806,'ref_number',null,'Item Receive',1000,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (104,'manufacturer',null,'vItemSummary',27,'manufacturer',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (0,'note_text',null,'SpSumNotes4Items;1',4,'note_text',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (0,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (105,'cost',null,'Item',6,'cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (105,'catagory',null,'vItemSummary',27,'category',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (105,'alt_item_number',null,'item',6,'alt_item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (106,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (106,'cost',null,'Item',6,'cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (106,'manufacturer',null,'vItemSummary',27,'manufacturer',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (106,'alt_item_number',null,'item',6,'alt_item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (0,'cost',null,'Item',6,'cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (0,'supplier',null,'vItemSummary',6,'supplier',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (0,'alt_item_number',null,'item',6,'alt_item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (107,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (107,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (107,'cost',null,'Item',6,'cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (107,'alt_item_number',null,'item',6,'alt_item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'customer_phone_number',null,'Customer',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'customer_extension',null,'Customer',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'quantity',null,'Item',90000,'order_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10012,'ref_number',null,'Item Receipt',1000,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'cphone',null,'Supplier',9,null,'Contact work phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'location',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'site_name',null,'MoveFrom',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'is_checked_out',null,'vAssetInfo',27,'is_checked_out',null,0);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1103,'last_audit_date',null,'vAssetAudit',90000,'last_audit_date',null,3);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'current_qty',null,'Inventory',13,'current_qty',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (704,'ref_number',null,'Invoice Pick',1001,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (704,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'pallet',null,'Inventory',11,'pallet',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'begin_date',null,'Contract',32,'begin_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'trans_date',null,'Inventory',90000,'checkin_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1206,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (801,'description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'cextension',null,'Supplier',9,null,'Contact work phone extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'first_name',null,'User',90000,'user_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'qty',null,'Inventory',90000,'ship_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'contact_name',null,'Manufacturer',5,'contact_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'ccell',null,'Manufacturer',5,null,'Contact Cell Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1004,'user_logon',null,'User',90000,'user_logon_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10008,'original_data',null,'import_QB_errors',90000,'id_reference',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'website',null,'Supplier',9,'website',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'location1',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (707,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'quantity',null,'Order',90000,'order_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1210,'warranty_end_date',null,'asset',27,'warranty_end_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (104,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (104,'class_name',null,'vItemSummary',6,'class_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1201,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'depreciated_value',null,'vAssetDepreciation',27,'depreciated_value',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'customer_extension',null,'Customer',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'customer_extension',null,'Customer',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'customer_phone_number',null,'Customer',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'customer_name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'state',null,'Supplier',9,'state',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'fax',null,'Supplier',4,' ','Fax',2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (403,'postal_code',null,'Supplier',9,'postal_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (404,'phone_number',null,'Supplier',4,null,'phone_number',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (404,'state',null,'Supplier',9,'state',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'customer_name',null,'Customer',90000,'customer_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'trans_date',null,'Inventory',90000,'date_added',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'employee_last_name',null,'Employee',90000,'employee_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'employee_phone_number',null,'Employee',90000,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'email',null,'Manufacturer',5,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'website',null,'Manufacturer',5,'website',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'date_added',null,'Customer',4,'date_added',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'date_added',null,'Customer',4,'date_added',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (404,'extension',null,'Supplier',4,null,'extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (301,'site_desc',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (301,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'trans_date',null,'Inventory',13,'trans_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'lot',null,'Inventory',11,'lot',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'pallet',null,'Inventory',11,'pallet',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'date_code',null,'Inventory',11,'date_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'lot',null,'Inventory',11,'lot',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'pallet',null,'Inventory',11,'pallet',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'date_code',null,'Inventory',11,'date_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (804,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'trans_date',null,'Inventory',90000,'checkin_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'employee_first_name',null,'Employee',90000,'employee_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1101,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (705,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'cextension',null,'Manufacturer',5,null,'Contact work phone extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'date_code',null,'Inventory',11,'date_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'customer_name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1210,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'first_name',null,'User',90000,'user_first_name',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (801,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (707,'customer_name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'user_first_name',null,'User',90000,'user_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'entry_date',null,'Entry',90000,'move_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'state',null,'Supplier',9,'state',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (704,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'employee_last_name',null,'Employee',90000,'employee_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'trans_date',null,'Inventory',90000,'date_disposed',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'moveto_site_name',null,'MoveTo',6,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'cfax',null,'Supplier',9,null,'Contact Fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'cphone',null,'Manufacturer',5,null,'Contact work phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'address2',null,'Supplier',9,'address2',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'customer_name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'employee_first_name',null,'Employee',30,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10008,'error_description',null,'import_QB_errors',90000,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'extension',null,'Supplier',9,null,'extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'lot',null,'Inventory',11,'lot',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'remaining_quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'remaining_qty',null,'Inventory',13,'remaining_qty',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'site_description',null,'Site',8,'description',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'CheckedoutQty',null,'Item',6,'qty_checked_out',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'customer_extension',null,'Customer',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'customer_phone_number',null,'Customer',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'extension',null,'Supplier',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (0,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (107,'supplier',null,'vItemSummary',6,'supplier',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'name',null,'Supplier',9,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (106,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'supplier_number',null,'Supplier',9,'supplier_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'website',null,'Supplier',9,'website',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'address2',null,'Manufacturer',5,'address2',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1101,'last_audit_date',null,'vAssetAudit',90000,'last_audit_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1203,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1203,'category',null,'vAssetInfo',6,'category',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'purchase_date',null,'vAssetInfo',27,'purchase_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'location',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'is_checked_out',null,'vAssetInfo',27,'is_checked_out',null,0);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10007,'process_id',null,'import_QB_errors',90000,'error_type',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1208,'purchase_date',null,'vAssetInfo',27,'purchase_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'website',null,'Manufacturer',5,'website',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'code',null,'MoveFrom',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'mail_stop',null,'Supplier',9,'mail_stop',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'contact_name',null,'Supplier',9,'contact_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'trans_date',null,'Inventory',13,'trans_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'lot',null,'Inventory',11,'lot',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'description',null,'asset',27,'asset_description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (801,'ref_number',null,'Item Receive',1000,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'customer_email',null,'Customer',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'country',null,'Manufacturer',5,'country',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10008,'error_number',null,'import_QB_errors',90000,'object_type',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (704,'description',null,'Item',6,'description',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'contract_description',null,'Contract',32,'contract_description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'internal_contact',null,'vContractInfo',32,'internal_contact',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'ref_number',null,'Invoice Pick',1001,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1101,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'address2',null,'Supplier',9,'address2',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (804,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'contact_name',null,'Supplier',9,'contact_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'ref_number',null,'Invoice Pick',1001,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'code',null,'MoveFrom',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'employee_extension',null,'Employee',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'postal_code',null,'Supplier',9,'postal_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'mail_stop',null,'Supplier',9,'mail_stop',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1101,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'fax',null,'Supplier',9,null,'fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'pallet',null,'Inventory',11,'pallet',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1201,'purchase_date',null,'vAssetInfo',27,'purchase_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'occurs_type',null,'vAssetMaintenance',90000,'occurs_type',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'condition',null,'vAssetMaintenance',27,'condition',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'condition',null,'vAssetMaintenance',27,'condition',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'hphone',null,'Customer',4,' ','Home Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'extension',null,'Supplier',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (403,'extension',null,'Supplier',4,null,'extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (403,'fax',null,'Supplier',4,null,'Fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'moveto_site_name',null,'MoveTo',6,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'customer_phone_number',null,'Customer',90000,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'employee_extension',null,'Employee',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'user_first_name',null,'User',90000,'user_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'cphone',null,'Supplier',9,null,'Contact work phone',2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1004,'manager',null,'vUserSecurityInfo',6,'manager',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'country',null,'Supplier',9,'country',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'hphone',null,'Customer',4,' ','Home Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'state',null,'Supplier',9,'state',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'postal_code',null,'Supplier',9,'postal_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (403,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (404,'name',null,'Supplier',9,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'customer_email',null,'Customer',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (301,'location_desc',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'date_code',null,'Inventory',11,'date_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'pallet',null,'Inventory',11,'pallet',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'last_name',null,'User',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'adjust_type',null,'Inventory',13,'adjust_type',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'assigned_to',null,'vAssetMaintenance',90000,'assigned_to',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'maint_complete',null,'Maint',90000,'status',null,0);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'postal_code',null,'Manufacturer',5,'postal_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1203,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (704,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1203,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'Bill_address1',null,'Bill',2,'address1',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'country',null,'Supplier',9,'country',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'contract_number',null,'vContractInfo',32,'contract_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'begin_date',null,'vContractInfo',32,'begin_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'end_date',null,'vContractInfo',32,'end_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'city',null,'Supplier',9,'city',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (704,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'address2',null,'Supplier',9,'address2',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'employee_first_name',null,'Employee',90000,'employee_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'employee_phone_number',null,'Employee',90000,'phone_number',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'employee_extension',null,'Employee',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'state',null,'Supplier',9,'state',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'ccell',null,'Supplier',9,null,'Contact Cell Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'customer_email',null,'Customer',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'customer_extension',null,'Customer',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'employee_extension',null,'Employee',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'trans_date',null,'Inventory',90000,'transout',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'fax',null,'Supplier',4,' ','Fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'address2',null,'Supplier',9,'address2',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (404,'fax',null,'Supplier',4,null,'fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (404,'ccell',null,'Supplier',4,null,'cell phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1004,'title',null,'vUserSecurityInfo',30,'title',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'cfax',null,'Manufacturer',5,null,'Contact Fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'state',null,'Manufacturer',5,'state',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'country',null,'Supplier',9,'country',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (301,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (205,'adjust_code',null,'Adjust Reason',13,'adjust_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'remaining_quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (204,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'remaining_qty',null,'Inventory',13,'remaining_qty',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (203,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (202,'description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'CheckedoutQty',null,'Item',6,'qty_checked_out',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (201,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1203,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1206,'purchase_date',null,'vAssetInfo',27,'purchase_date',null,3);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1206,'manufacturer_name',null,'Manufacturer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1207,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1210,'warranty_begin_date',null,'asset',27,'warranty_begin_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1210,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1501,'schedule_date',null,'vAssetMaintenance',27,'schedule_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (505,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (706,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1104,'location0',null,'Original',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'extension',null,'Supplier',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'manager_first_name',null,'Manager',30,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (803,'quantity_received',null,'PO Receive',90000,'received_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'quantity_received1','Received Quantity','PO Receive',0,null,null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'quantity_received2',null,'Item Receive',90000,'received_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'due_date1',null,'Item Receive',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'phone_number',null,'Supplier',9,null,null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1210,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1501,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'supplier_number',null,'Supplier',9,'supplier_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'cextension','Cextension','Supplier',9,null,'Contact work phone extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'condition',null,'vAssetMaintenance',27,'condition',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'current_qty',null,'Inventory',13,'current_qty',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1004,'first_name',null,'User',90000,'user_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'site_name',null,'MoveFrom',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'extension',null,'Manufacturer',5,null,'extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1501,'occurs_type',null,'vAssetMaintenance',90000,'occurs_type',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'ref_number',null,'PO Receive',1000,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'contract_number',null,'Contract',32,'contract_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1206,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1208,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'contract_description',null,'Contract',32,'contract_description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'customer_phone_number',null,'Customer',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'mail_stop',null,'Supplier',9,'mail_stop',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1302,'phone_number',null,'Supplier',90000,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'moveto_location',null,'MoveTo',17,'location',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'employee_first_name',null,'Employee',30,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1201,'po',null,'Inventory',11,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1204,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1204,'purchase_date',null,'vAssetInfo',27,'purchase_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1207,'po',null,'Inventory',11,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10012,'description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'quantity',null,'Inventory',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'cfax','Cfax','Supplier',9,null,'Contact Fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'supplier_number',null,'Supplier',9,'supplier_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'fax',null,'Supplier',9,null,'fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'customer_name',null,'Customer',90000,'customer_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1301,'last_name',null,'User',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1301,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1302,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'customer_extension',null,'Customer',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'city',null,'Manufacturer',5,'city',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (804,'ref_number',null,'Item Receive',15,'require_pos',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10008,'process_id',null,'import_QB_errors',90000,'error_type',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (803,'quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10012,'po_type',null,'vPOinfo',22,'po_type',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1201,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (708,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'ref_number','Invoice #','Invoice Pick',0,null,null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1104,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (804,'quantity_received',null,'Item Receive',90000,'received_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1104,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'last_name',null,'User',90000,'last_name',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'fax','Fax','Supplier',9,null,'fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'name',null,'Supplier',9,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1208,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1104,'site0',null,'Original',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'current_depreciation',null,'vAssetDepreciation',27,'current_depreciation',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'postal_code',null,'Supplier',9,'postal_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'customer_name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'phone_number',null,'Supplier',4,null,'phone_number',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1101,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'address1',null,'Supplier',9,'address1',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10012,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10012,'quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'trans_date',null,'Inventory',90000,'date_audited',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'address1',null,'Supplier',9,'address1',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1204,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (803,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'ref_number1','Invoice #','Invoice Pick',0,null,null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'picked_quantity',null,'Invoice Pick',11,'quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'pallet',null,'Inventory',11,'pallet',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'current_qty',null,'Inventory',13,'current_qty',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1501,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (613,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10007,'original_data',null,'import_QB_errors',90000,'id_reference',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10007,'error_number',null,'import_QB_errors',90000,'object_type',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10007,'error_description',null,'import_QB_errors',90000,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1104,'site1',null,'Current',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'name',null,'Manufacturer',5,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1201,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'reason',null,'vAddInventory',1004,'reason',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'date_code',null,'Inventory',11,'date_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'cphone','Cphone','Supplier',9,null,'Contact work phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1203,'purchase_date',null,'vAssetInfo',27,'purchase_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'due_date',null,'Invoice Pick',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'site_name',null,'Site',8,'site_name',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (706,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'end_date',null,'Contract',32,'end_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'customer_email',null,'Customer',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1501,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'ccell','Cell Phone','Supplier',9,null,'Contact Cell Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1302,'extension',null,'Supplier',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'date_code',null,'Inventory',11,'date_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (706,'customer_name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'due_date',null,'Invoice Pick',22,'due_date',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'date_code',null,'Inventory',11,'date_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'lot',null,'Inventory',11,'lot',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1201,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'trans_date',null,'Inventory',13,'trans_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (707,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'user_first_name',null,'User',90000,'user_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'employee_extension',null,'Employee',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (611,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'moveto_location',null,'MoveTo',17,'location',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'mail_stop',null,'Manufacturer',5,'mail_stop',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1004,'department',null,'vUserSecurityInfo',4,'department',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1001,'phone_number',null,'Supplier',9,null,'phone_number',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'extension',null,'Supplier',9,null,'extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1206,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1206,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1207,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'description',null,'Item',6,'description',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (10012,'due_date',null,'Item Receipt',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'pallet',null,'Inventory',11,'pallet',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1104,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1302,'last_name',null,'User',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (104,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'customer_email',null,'Customer',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (607,'user_first_name',null,'User',90000,'user_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'customer_name',null,'Customer',4,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'customer_phone_number',null,'Customer',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'site_description',null,'Site',8,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (802,'qty',null,'Inventory',90000,'received_quantity',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (801,'quantity',null,'Item',6,'qty_available',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (801,'due_date',null,'Item Receive',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'trans_date',null,'Inventory',13,'trans_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1104,'location1',null,'Current',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (701,'ref_number',null,'Invoice Pick',1001,'po',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1004,'last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'current_qty',null,'Inventory',13,'current_qty',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'phone_number','Phone Number','Supplier',9,null,null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1108,'lot',null,'Inventory',11,'lot',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1204,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1206,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1208,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (803,'due_date',null,'Item Receive',22,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'internal_contact',null,'Contract',32,'internal_contact',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'num_licenses',null,'Contract',32,'num_licenses',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1502,'schedule_date',null,'vAssetMaintenance',27,'schedule_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'state',null,'Supplier',9,'state',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1301,'extension',null,'Supplier',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1302,'department_name',null,'Department',90000,'department',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1102,'code',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'name',null,'Supplier',9,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (605,'user_last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'cextension',null,'Supplier',9,null,'Contact work phone extension',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'user_last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (703,'location',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1203,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'contact_name',null,'Supplier',9,'contact_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1204,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1207,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1207,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (803,'description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (702,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'quantity',null,'Inventory',11,'quantity',null,1);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'vendor_name',null,'Contract',32,'vendor_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (501,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1208,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1208,'supplier_number',null,'Supplier',9,'supplier_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'cfax',null,'Supplier',9,null,'Contact Fax',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'city',null,'Supplier',9,'city',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1003,'country',null,'Supplier',9,'country',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (608,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1002,'phone_number',null,'Manufacturer',5,null,'phone_number',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1207,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1208,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1302,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'maint_date',null,'Maint',90000,'date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1107,'location_description',null,'Location',7,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (609,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (604,'user_last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (503,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (504,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'location',null,'Location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1701,'site_name',null,'MoveFrom',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1204,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1205,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1207,'purchase_date',null,'vAssetInfo',27,'purchase_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1210,'warranty_provider',null,'asset',27,'warranty_provider',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'name',null,'Department',90000,'department',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'last_name',null,'User',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'site_name',null,'Site',8,'site_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1301,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1301,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1302,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'last_name',null,'Employee',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'first_name',null,'Employee',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1303,'email',null,'Supplier',9,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (104,'supplier_number',null,'Supplier',9,'supplier_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1201,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'location',null,'location',7,'code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'file_data',null,'File',0,'',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'supplier_number',null,'Supplier',9,'supplier_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'manufacturer',null,'vItemSummary',27,'manufacturer',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'model',null,'vAssetPictures',6,'model',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1202,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'total_depreciation',null,'vAssetDepreciation',27,'total_depreciation',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1401,'last_depreciation_date',null,'vAssetDepreciation',27,'last_depreciation_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1501,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1504,'maint_date',null,'Maint',90000,'date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1503,'maint_complete',null,'Maint',90000,'status',null,0);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'customer_number',null,'Customer',4,'customer_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (502,'customer_email',null,'Customer',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'customer_email',null,'Customer',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (506,'customer_extension',null,'Customer',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'employee_first_name',null,'Employee',30,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (508,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'employee_first_name',null,'Employee',30,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (507,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (509,'employee_extension',null,'Employee',4,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (510,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'name',null,'Supplier',9,'name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'ccell',null,'Supplier',4,null,'Cell Phone',2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'city',null,'Supplier',9,'city',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (402,'postal_code',null,'Supplier',9,'postal_code',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (401,'address1',null,'Supplier',9,'address1',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'employee_first_name',null,'Employee',90000,'employee_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'employee_extension',null,'Employee',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'purchase_cost',null,'vAssetInfo',27,'purchase_cost',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'employee_first_name',null,'Employee',90000,'employee_first_name',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1602,'employee_extension',null,'Employee',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'employee_first_name',null,'Employee',90000,'employee_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1603,'employee_extension',null,'Employee',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1601,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'employee_first_name',null,'Employee',90000,'employee_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1604,'employee_extension',null,'Employee',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'trans_date',null,'Inventory',90000,'out_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'date_acquired',null,'Inventory',90000,'due_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'employee_number',null,'vCheckOutInfo',30,'employee_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'employee_last_name',null,'Employee',30,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'employee_first_name',null,'Employee',90000,'employee_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'employee_email',null,'Employee',2,'email',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'employee_phone_number',null,'Employee',2,'phone_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1605,'employee_extension',null,'Employee',90000,'extension',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'num_licenses',null,'vContractInfo',32,'num_licenses',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'vendor_name',null,'vContractInfo',32,'vendor_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1702,'description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1703,'contract_number',null,'vContractInfo',32,'contract_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1703,'contract_description',null,'vContractInfo',32,'contract_description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1703,'internal_contact',null,'vContractInfo',32,'internal_contact',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1703,'begin_date',null,'vContractInfo',32,'begin_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1703,'end_date',null,'vContractInfo',32,'end_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1703,'num_licenses',null,'vContractInfo',32,'num_licenses',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1703,'name',null,'Supplier',32,'vendor_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1220,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1220,'item_number',null,'Item',6,'item_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1220,'description',null,'Item',6,'description',null,2);
GO
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'trans_date',null,'Entry',90000,'transaction_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (610,'trans_type_description',null,'Entry',90000,'type',null,2);

INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'last_name',null,'User',90000,'user_last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'first_name',null,'User',90000,'user_first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'serial_number',null,'Inventory',11,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'trans_date',null,'Inventory',90000,'date_disposed',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'reason',null,'vAddInventory',1004,'reason',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'item_description',null,'Item',6,'description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (614,'item_number',null,'Item',6,'item_number',null,2);

INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'trans_date',null,'Inventory',90000,'date_audited',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'asset_tag',null,'vCheckOutInfo',17,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'location2',null,'Audited to Location',90000,'audited_to_location',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'sitename2',null,'Audited to Site',90000,'audited_to_site',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'first_name',null,'User',90000,'first_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'last_name',null,'User',90000,'last_name',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1105,'description',null,'asset',27,'asset_description',null,2);

INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'asset_tag',null,'asset',27,'asset_tag',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'item_description',null,'asset',27,'asset_description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'purchase_cost',null,'asset',27,'purchase_cost',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'total_depreciation',null,'asset',27,'total_depreciation',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'depreciated_value',null,'asset',27,'depreciated_value',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'current_depreciation',null,'asset',27,'current_depreciation',null,1);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'last_depreciation_date',null,'asset',27,'last_depreciation_date',null,3);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'serial_number',null,'asset',27,'serial_number',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1402,'trans_date',null,'asset_transactions',90000,'date_disposed',null,3);

INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1006,'group_description',null,'vSecurityGroups',29,'group_description',null,2);
INSERT INTO report_labels (rpt_id,db_field_report,rpt_label,rpt_label2,form_id,db_field,field,data_type) VALUES (1006,'group_name',null,'vSecurityGroups',29,'group_name',null,2);
GO
 


----------------------------------------------------
-- Table Name: report_names
----------------------------------------------------
DELETE FROM report_names
GO
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (103,1,-1,'Item Reorder Report','Item Reorder Report','Item Reorder Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (105,1,-5,'Items by Category Report','Items by Category Report','Items by Category Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (107,1,-7,'Items by Vendor Report ','Items by Vendor Report','Items by Vendor Report ','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1204,12,4,'Assets by Asset Type Report','Assets By Asset Type Report','Assets by Asset Type Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1205,12,5,'Assets by Location Report','Assets By Location Report','Assets by Location Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1208,12,8,'Assets by Vendor Report','Assets By Vendor Report','Assets by Vendor Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (301,3,1,'Location List Report','Location List Report','Location List Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (401,4,1,'Customers by Number Report','Customers By ID Report','Customers by Number Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (402,4,2,'Customers by Name Report','Customers By Name Report','Customers by Name Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (403,4,3,'Customers by Postal Code Report','Customers By Postal Code Report','Customers by Postal Code Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (502,5,4,'Check-Out to Customer by Due Date Report','Customer Check-out By Due Date Report','Check-Out to Customer by Due Date Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (503,5,3,'Check-Out to Customer by Asset Tag Report','Customer Check-out By Asset Tag Report','Check-Out to Customer by Asset Tag Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1601,16,1,'Check-Out to Employee Report','Check-out By Employee Report','Check-Out to Employee Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (505,5,5,'Check-Out to Customer Due Today Report','Customer Check-out Due Today Report','Check-Out to Customer Due Today Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (506,5,6,'Check-Out to Customer Past Due Report','Customer Check-out Past Due Report','Check-Out to Customer Past Due Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1401,14,1,'Asset Depreciation by Department Report','Asset Depreciation By Department Report','Asset Depreciation by Department Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1210,12,10,'Asset Warranty Information Report','Asset Warranty Information Report','Asset Warranty Information Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1102,11,2,'Asset Audit History by Date Report','Asset Audit History By Date Report','Asset Audit History by Date Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1105,11,5,'Asset Audit History by Location Report','Asset Audit History By Location Report','Asset Audit History by Location Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (605,6,2,'Transaction Check-In by Customer Report','Transaction Check-in By Customer Report','Transaction Check-In by Customer Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (609,6,6,'Transaction Dispose Report','Transaction Dispose Report','Transaction Dispose Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (610,6,8,'Transaction History Report','Transaction History Report','Transaction History Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (611,6,7,'Transaction Move Report','Transaction Move Report','Transaction Move Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (613,6,1,'Transaction Add Report','Transaction Add Report','Transaction Add Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (701,7,-1,'Line Item Pick Ticket','Line Item Pick Ticket','Line Item Pick Ticket','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20006,20000,-2,'Asset History Report','Transaction History Receipt','Asset History Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20003,20000,null,'Asset Check-Out Receipt','Asset Check-out Receipt','Asset Check-Out Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20008,20000,null,'Asset Check-Out Location Receipt','Asset Check-Out Location Receipt','Asset Check-Out Location Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20001,20000,null,'Asset Audit Receipt','Asset Audit Receipt','Asset Audit Receipt','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1504,15,3,'Asset Maintenance History by Asset Tag Report','Asset Maintenance History By Asset Tag Report','Asset Maintenance History by Asset Tag Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (801,8,-1,'Item Receive Ticket','Item Receive Report','Item Receive Ticket','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1004,10,4,'User Security Option Report','User Security Option Report','User Security Option Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10009,10000,null,'Line Item Pick Receipt','Line Item Pick Receipt','Line Item Pick Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10007,10000,null,'Import from QB Error Report','Import from QB Error Report','Import from QB Error Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1101,11,1,'Asset Audit History by Asset Tag Report','Asset Audit History By Asset Tag Report','Asset Audit History by Asset Tag Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (604,6,3,'Transaction Check-out by Customer Report','Transaction Check-out By Customer Report','Transaction Check-out by Customer Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1203,12,3,'Assets by Category Report','Assets By Category Report','Assets by Category Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1206,12,6,'Assets by Manufacturer Report','Assets By Manufacturer Report','Assets by Manufacturer Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1207,12,7,'Assets by PO Report','Assets By PO Report','Assets by PO Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1301,13,1,'Employees by Name Report','Employees by Name Report','Employees by Name Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1302,13,2,'Employees by Department Report','Employees by Department Report','Employees by Department Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (104,1,4,'Asset Types Report','Asset Types Report','Asset Types Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (106,1,-6,'Items by Manufacturer Report','Items by Manufacturer Report','Items by Manufacturer Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (404,4,4,'Customers by State Report','Customers By State Report','Customers by State Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (501,5,1,'Check-Out to Customer Report','Check-out By Customer Report','Check-Out to Customer Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20005,20000,-1,'Asset Maintenance History Report','Asset Maintenance History By Asset Tag Receipt','Asset Maintenance History Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1503,15,4,'Asset Maintenance History by Date Report','Asset Maintenance History By Date Report','Asset Maintenance History by Date Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20002,20000,null,'Asset Check-In Receipt','Asset Check-in By Customer Receipt','Asset Check-In Receipt','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10001,10000,null,'Inventory Adjust Receipt','Inventory Adjust Receipt','Inventory Adjust Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10002,10000,null,'Inventory Check-In Receipt','Inventory Check-in Receipt','Inventory Check-In Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10003,10000,null,'Inventory Check-Out Receipt','Inventory Check-out Receipt','Inventory Check-Out Receipt','F','F',null,'P');
GO
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10004,10000,null,'Inventory Move Receipt','Inventory Move Receipt','Inventory Move Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10005,10000,null,'Inventory Add Receipt','Inventory Add Receipt','Inventory Add Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10006,10000,null,'Inventory Remove Receipt','Inventory Remove Receipt','Inventory Remove Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10008,10000,null,'Import-Export Error Report','Import-Export Error Report','Import-Export Error Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10010,10000,null,'Item Receipt','Item Receive Receipt','Item Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (805,8,-5,'Credit Memo','Item Receive Receipt (All)','Credit Memo','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (708,7,-8,'Line Item Pick Ticket','Line Item Pick Ticket with Bar Codes','Line Item Pick Ticket','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10011,10000,null,'Line Item Post Pick Report','Line Item Pick Receipt (All)','Line Item Post Pick Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (10012,10000,null,'Item Receipt','Item Receive Receipt (All)','Item Receipt','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1001,10,3,'Vendors by Name Report','Vendors By Name Report','Vendors by Name Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1002,10,2,'Manufacturers by Name Report','Manufacturers By Name Report','Manufacturers by Name Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1303,13,3,'Employees by Manager Report','Employees by Manager Report','Employees by Manager Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1201,12,1,'Assets by Asset Tag Report','Assets By Asset Tag Report','Assets by Asset Tag Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1202,12,2,'Assets by Asset Tag With Picture Report','Assets By Asset Tag With Picture Report','Assets by Asset Tag With Picture Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1501,15,1,'Maintenance Schedule by Asset Report','Maintenance Schedule By Asset Report','Maintenance Schedule by Asset Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1005,10,10,'Browse...','Browse...','Browse...','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1502,15,2,'Maintenance Schedule by Assigned To Report','Maintenance Schedule By Assigned To Report','Maintenance Schedule by Assigned To Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (607,6,4,'Transaction Check-In by Employee Report','Transaction Check-in By Employee Report','Transaction Check-In by Employee Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (608,6,5,'Transaction Check-Out by Employee Report','Transaction Check-out By Employee Report','Transaction Check-Out by Employee Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20004,20000,null,'Asset Check-In Receipt','Asset Check-in By Employee Receipt','Asset Check-In Receipt','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1603,16,3,'Check-Out To Employee by Due Date Report','Employee Check-out By Due Date Report','Check-Out To Employee by Due Date Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1602,16,2,'Check-Out To Employee by Asset Tag Report','Employee Check-out By Asset Tag Report','Check-Out To Employee by Asset Tag Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1604,16,4,'Check-Out To Employee Due Today Report','Employee Check-out Due Today Report','Check-Out To Employee Due Today Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1605,16,5,'Check-Out To Employee Past Due Report','Employee Check-out Past Due Report','Check-Out To Employee Past Due Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (20007,20000,-7,'Employee Transaction Report','Employee Transaction Report','Employee Transaction Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1220,12,20,'Asset Links Report','Asset Links Report','Asset Links Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1701,17,1,'Contracts Report','Contracts Report','Contracts Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1702,17,2,'Contracts By Asset Report','Contracts By Asset Report','Contracts By Asset Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1703,17,3,'Software License Report','Software License Report','Software License Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1103,11,3,'Not Audited Assets Report','Not Audited Assets Report','Not Audited Assets Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1104,11,4,'Assets Audit Location Discrepancy Report','Assets Audit Location Discrepancy Report','Assets Audit Location Discrepancy Report','F','F',null,'P');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1402,14,2,'Disposed Assets with Depreciation Info Report','Disposed Assets with Depreciation Info Report','Disposed Assets with Depreciation Info Report','F','F',null,'L');
INSERT INTO report_names (rpt_id,rpt_type,rpt_display_order,rpt_name,rpt_file_name,rpt_default_name,rpt_filter,rpt_show_dialog,rpt_tool_tips,rpt_orientation) VALUES (1006,10,5,'Group Security Report','Group Security Report','Group Security Report','F','F',null,'P');
insert into report_names( rpt_id, rpt_type, rpt_name, rpt_file_name, rpt_default_name, rpt_filter, rpt_show_dialog, rpt_orientation) values (30001, 30000, 'Reservation Receipt', 'Reservation Receipt', 'Reservation Receipt', 'F', 'F', 'P')


GO


----------------------------------------------------
-- Table Name: request_status
----------------------------------------------------
DELETE FROM request_status;
insert into request_status (request_status_id,request_status_text,record_status,company_id) values (1,'Requested',1,1);
insert into request_status (request_status_id,request_status_text,record_status,company_id) values (2,'Ready For Checkout',1,1);
insert into request_status (request_status_id,request_status_text,record_status,company_id) values (3,'Rejected',1,1);
insert into request_status (request_status_id,request_status_text,record_status,company_id) values (4,'Fulfilled',1,1);
insert into request_status (request_status_id,request_status_text,record_status,company_id) values (5,'Cancelled',1,1);
insert into request_status (request_status_id,request_status_text,record_status,company_id) values (6,'Approved',1,1);
GO


----------------------------------------------------
-- Table Name: request_urgency
----------------------------------------------------
DELETE FROM request_urgency;
insert into request_urgency (urgency_id,urgency_text,record_status,company_id) values (1,'Critical',1,1);
insert into request_urgency (urgency_id,urgency_text,record_status,company_id) values (2,'Normal',1,1);
insert into request_urgency (urgency_id,urgency_text,record_status,company_id) values (3,'Low',1,1);
GO




--  [reservation_details]
if ( SELECT COUNT([detail_id]) FROM [reservation_details] WHERE [detail_id] = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT dbo.[reservation_details] ON;

   INSERT INTO [dbo].[reservation_details]
       ([detail_id],
       [reservation_id]
       ,[asset_id]
       ,[asset_type_id]
       ,[quantity]
       ,[reservation_start]
       ,[reservation_end]
       ,[relating_detail_id]
       ,[line_status_id]
       ,[user_id]
       ,[record_status]
       ,[company_id]
       ,[last_updated])
   VALUES
       (0,0,0,0,0,'1/1/2010','1/1/2010',0,1,0,1,1,'1/1/2010')

   SET IDENTITY_INSERT [reservation_details] OFF;
END
GO
	
	

--security_privileges

IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'add')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('add','New Asset',2);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'admin')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('admin','Administration Privilege',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'approve')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('approve','Approve Reservation Request',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'audit')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('audit','Audit',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'backup')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('backup','Backup and Restore',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'calc_dep')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('calc_dep','Calculate Depreciation',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'checkin')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('checkin','Check In',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'checkout')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('checkout','Check Out ',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'delete')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('delete','Delete',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'dispose')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('dispose','Dispose an Asset',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'edit')
BEGIN
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('edit', 'Edit', 1)
	
	INSERT INTO user_privileges (user_id, security_code, record_status) 
      SELECT DISTINCT user_id, 'edit', 1 FROM users WHERE user_id > 0 and record_status = 1 and company_id = 1
END
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'labels')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('labels','Edit Labels',1);
ELSE
BEGIN
	UPDATE security_privileges SET description = 'Edit Labels' WHERE security_code = 'labels'
END	
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'lists')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('lists','Lists',2);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'maint')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('maint','Maintenance',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'manageco')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('manageco','Change Company Information',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'move')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('move','Move',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'new')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('new','New',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'pc')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('pc','Allow PC Login',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'pda')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('pda','Palm PDA',2);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'ppc')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('ppc','Pocket PC',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'reports')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('reports','Reports',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'reserve')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('reserve','Make Asset Reservation',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'web')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('web','Allow Web Access',1);
IF NOT EXISTS (SELECT * FROM security_privileges WHERE security_code = 'upload')
	INSERT INTO security_privileges (security_code,description,company_id) VALUES ('upload','Process Mobile Device Data',1);

GO



if ( SELECT COUNT(site_id) FROM [sites] WHERE site_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [sites] ON;
   INSERT INTO sites (site_id,site_name,description,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10,record_status,company_id,update_user_id,date_updated) VALUES (0,'0','0',null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,1,0,null,null);
   SET IDENTITY_INSERT [sites] OFF;
END
GO


if ( SELECT COUNT(location_id) FROM [location] WHERE location_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [location] ON;
   INSERT INTO location (location_id,site_id,description,code,default_location,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10,record_status,company_id,update_user_id,date_updated) VALUES (0,0,null,'',null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,2,0,null,null);
   SET IDENTITY_INSERT [location] OFF;
END
GO



if ( SELECT COUNT(supplier_id) FROM [supplier] WHERE supplier_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [supplier] ON;
   INSERT INTO supplier (supplier_id,supplier_number,name,email,website,contact_name,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10,record_status,company_id,update_user_id,list_id) VALUES (0,null,' ',null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,0,null,null);
   SET IDENTITY_INSERT [supplier] OFF;
END
GO



----------------------------------------------------
-- Table Name: item
----------------------------------------------------
if ( SELECT COUNT(item_id) FROM [item] WHERE item_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [item] ON;
   insert into item (item_id,item_number,description,class_id,default_location_id,cost,avgcost,manufacturer_id,category_id,model,unit_of_measure,reorder_qty,alt_item_number,linked_file,list_price,sale_price,supplier_id,manager,checkout_duration,width,height,length,dimension_unit,weight,weight_unit,usrdefdate1,usrdefdate2,usrdefdate3,usrdefdate4,usrdefdate5,usrdefnumber1,usrdefnumber2,usrdefnumber3,usrdefnumber4,usrdefnumber5,usrdeftext1,usrdeftext2,usrdeftext3,usrdeftext4,usrdeftext5,usrdeftext6,usrdeftext7,usrdeftext8,usrdeftext9,usrdeftext10,record_status,company_id,date_updated,lead_time,linked_reference) values (0,null,null,0,0,null,null,0,0,null,null,null,null,null,null,null,0,null,0,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,2,null,'5/19/2009 9:03:14 AM',null,null);
   SET IDENTITY_INSERT [item] OFF;
END

GO



DELETE FROM transaction_types
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (100,'Add');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (150,'Dispose');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (200,'Move To');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (250,'Move From');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (300,'Check In');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (350,'Check Out');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (400,'Adjust In');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (450,'Adjust Out');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (500,'Audit In');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (550,'Audit');
INSERT INTO transaction_types (trans_type_no,trans_description) VALUES (600,'Maintenance');
GO




IF  NOT EXISTS (SELECT * FROM [dbo].[user_groups] WHERE group_id = 0)
BEGIN
	SET IDENTITY_INSERT [user_groups] ON;

	INSERT INTO [dbo].[user_groups]
           (group_id, [group_name], [group_description] ,[record_status] ,[company_id])
    VALUES (0, '', '', 2, 1)

	SET IDENTITY_INSERT [user_groups] OFF;
	
END

IF  NOT EXISTS (SELECT * FROM [dbo].[user_groups] WHERE group_id > 0 AND record_status = 1)
BEGIN
	
	IF  EXISTS (SELECT * FROM [dbo].[user_groups] WHERE group_id = 1 AND record_status = 4)
	BEGIN
		-- We did this in UPG_NEW_Tables.sql to satisfy a contraint
		UPDATE user_groups SET record_status = 1 WHERE group_id = 1 AND record_status = 4
	END
	ELSE
	BEGIN
		IF  NOT EXISTS (SELECT * FROM [dbo].[user_groups] WHERE group_id = 1 AND record_status = 1)
		BEGIN
			SET IDENTITY_INSERT [user_groups] ON;

			INSERT INTO [dbo].[user_groups] (group_id, [group_name], [group_description] ,[record_status] ,[company_id])
    			VALUES (1, 'Admin Group', 'Administrative Group With All Rights', 1, 1)

			SET IDENTITY_INSERT [user_groups] OFF;
		END
	END
	
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'admin',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'audit',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'approve',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'backup',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'calc_dep',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'checkin',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'checkout',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'delete',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'dispose',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'edit',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'labels',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'maint',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'manageco',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'move',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'new',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'pc',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'pda',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'ppc',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'reports',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'reserve',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'web',1,1);
	INSERT INTO [user_group_privileges] (group_id,security_code,record_status,company_id) VALUES (1,'upload',1,1);
	
	INSERT INTO [user_group_sites] ([group_id] ,[site_id]) VALUES (1, 0);
END
GO

-- admin group will get approve/reserve/web ON as default
INSERT INTO [user_group_privileges] 
SELECT DISTINCT group_id, 'approve' AS security_code, 1 AS record_status , 1 AS company_id
FROM dbo.user_groups WHERE group_id not in (select group_id from [user_group_privileges] where security_code = 'approve') and group_id = 1

INSERT INTO [user_group_privileges] 
SELECT DISTINCT group_id, 'reserve' AS security_code, 1 AS record_status , 1 AS company_id
FROM dbo.user_groups WHERE group_id not in (select group_id from [user_group_privileges] where security_code = 'reserve') and group_id = 1

INSERT INTO [user_group_privileges] 
SELECT DISTINCT group_id, 'web' AS security_code, 1 AS record_status , 1 AS company_id
FROM dbo.user_groups WHERE group_id not in (select group_id from [user_group_privileges] where security_code = 'web') and group_id = 1

-- all existing user groups (other than admin) will get approve OFF as default
INSERT INTO [user_group_privileges] 
SELECT DISTINCT group_id, 'approve' AS security_code, 2 AS record_status , 1 AS company_id
FROM dbo.user_groups WHERE group_id not in (select group_id from [user_group_privileges] where security_code = 'approve') and group_id > 1

-- all existing user groups (other than admin) will get reserve OFF as default
INSERT INTO [user_group_privileges] 
SELECT DISTINCT group_id, 'reserve' AS security_code, 2 AS record_status , 1 AS company_id
FROM dbo.user_groups WHERE group_id not in (select group_id from [user_group_privileges] where security_code = 'reserve') and group_id > 1

-- all existing user groups (other than admin) will get web OFF as default
INSERT INTO [user_group_privileges] 
SELECT DISTINCT group_id, 'web' AS security_code, 2 AS record_status , 1 AS company_id
FROM dbo.user_groups WHERE group_id not in (select group_id from [user_group_privileges] where security_code = 'web') and group_id > 1


GO

if ( SELECT COUNT(user_id) FROM [users] WHERE user_id = 0 ) = 0
BEGIN
   SET IDENTITY_INSERT [users] ON;
   INSERT INTO users (user_id,last_name,first_name,title,department,manager,user_logon,user_password,changed_password,record_status,company_id,date_updated, group_id) VALUES (0,null,null,null,null,null,null,null,'F',1,1,null, 0);
   SET IDENTITY_INSERT [users] OFF;
END

if ( SELECT COUNT(user_id) FROM [users] WHERE user_id = 1 ) = 0
BEGIN
   SET IDENTITY_INSERT [users] ON;
   INSERT INTO users (user_id,last_name,first_name,title,department,manager,user_logon,user_password,changed_password,record_status,company_id,date_updated, group_id) VALUES (1,'Admin','User','','','','Admin','','F',1,1,'2/23/2004 5:39:27 PM', 1);
   SET IDENTITY_INSERT [users] OFF;
END
GO

if ( SELECT COUNT(user_id) FROM user_privileges WHERE user_id = 1 ) = 0
BEGIN
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'add',2);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'admin',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'approve',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'audit',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'backup',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'calc_dep',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'checkin',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'checkout',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'delete',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'dispose',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'edit',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'labels',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'lists',2);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'maint',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'manageco',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'move',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'new',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'pc',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'pda',2);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'ppc',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'reports',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'reserve',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'web',1);
   INSERT INTO user_privileges (user_id,security_code,record_status) VALUES (1,'upload',1);
END
GO


INSERT INTO user_privileges 
SELECT DISTINCT user_id, 'add' AS security_code, 1 AS record_status 
FROM USERS WHERE user_id not in (select user_id from user_privileges where security_code = 'add') and user_id > 1

-- insert missing user_privileges according to its user_group_privileges 
INSERT INTO user_privileges 
SELECT user_id, user_group_privileges.security_code, user_group_privileges.record_status 
FROM users INNER JOIN dbo.user_group_privileges 
ON users.group_id = user_group_privileges.group_id AND 
   user_group_privileges.security_code in ('approve') AND 
   user_id NOT IN (SELECT user_id FROM user_privileges WHERE security_code = 'approve')

INSERT INTO user_privileges 
SELECT user_id, user_group_privileges.security_code, user_group_privileges.record_status 
FROM users INNER JOIN dbo.user_group_privileges 
ON users.group_id = user_group_privileges.group_id AND 
   user_group_privileges.security_code in ('reserve') AND 
   user_id NOT IN (SELECT user_id FROM user_privileges WHERE security_code = 'reserve')

INSERT INTO user_privileges 
SELECT user_id, user_group_privileges.security_code, user_group_privileges.record_status 
FROM users INNER JOIN dbo.user_group_privileges 
ON users.group_id = user_group_privileges.group_id AND 
   user_group_privileges.security_code in ('web') AND 
   user_id NOT IN (SELECT user_id FROM user_privileges WHERE security_code = 'web')

-- We traditionally do this but since this is one script to run for both scenario (install new and upgrade),
-- we shouldn't be calling this anymore. otherwise it will wipe out all the customized labels.  .. bug: 19228
--update form_field_meta set label = default_label, tool_tip = default_tool_tip;
Go
update report_names set rpt_name = rpt_default_name;
GO


-- Table Name: user_site

INSERT INTO user_site 
SELECT DISTINCT user_id, 0 FROM users
WHERE (user_id not in (SELECT DISTINCT user_id FROM user_site))
and (user_id > 0) 
GO

if (select count(id) from dbo.user_group_sites) <2
BEGIN	
	print '***** User Privileges Upgrade To Group Privileges'
	EXEC SpConvertToGroupSecurity
	print '***** User Privileges Upgrade To Group Privileges Complete'
END
go





IF EXISTS (SELECT security_code FROM dbo.security_privileges WHERE security_code = 'lists' and company_id = 1) 
BEGIN
   UPDATE security_privileges SET company_id = 2 WHERE security_code = 'lists';
   UPDATE user_privileges SET record_status = 2 WHERE security_code = 'lists' 
END


IF EXISTS (SELECT security_code FROM dbo.security_privileges WHERE security_code = 'pda' and company_id = 1) 
BEGIN
   UPDATE security_privileges SET company_id = 2 WHERE security_code = 'pda';
   UPDATE user_privileges SET record_status = 2 WHERE security_code = 'pda' 
END

GO
DELETE FROM ui_settings
WHERE setting_name in ('AssetListDlg', 'ClassListDlg','EmployeeListDlg', 'DialogListSupplier', 'ItemListDlg', 'DialogListContract') AND
setting_type = 'grid'
GO


--------------------------------------------------------
-- This is to fix the problem described in bug #13552
-- There had been change made to send down data based 
-- on date_updated. But Since triggers were not set up 
-- properly initially, there are records with null
-- date_updated....CY
--------------------------------------------------------


DELETE FROM mobile_data_snapshot

UPDATE    item
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    users
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    location
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    sites
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    manufacturer
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    employees
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    customer
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

UPDATE    asset
SET       date_updated = GETDATE()
WHERE     (date_updated is NULL)

GO










-------------------------------------------
-- Rebuild indexes so to prevent the database 
-- from growing too much in fragmentation
-- and negatively impacts performance
-------------------------------------------

DECLARE @TableName varchar(255) 
DECLARE TableCursor CURSOR FOR 

SELECT table_name FROM information_schema.tables 
WHERE table_type = 'base table' 

OPEN TableCursor 

FETCH NEXT FROM TableCursor INTO @TableName 

WHILE @@FETCH_STATUS = 0 
BEGIN 
print @TableName
DBCC DBREINDEX(@TableName,' ',90) 
FETCH NEXT FROM TableCursor INTO @TableName 

END 

CLOSE TableCursor 
DEALLOCATE TableCursor


GO




exec SpUpdateAssetAvailabilityTable
GO